/*
 *
 *  Copyright 1998  Nothing Real, LLC
 *  All Rights Reserved.
 *
 *  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Nothing Real, LLC.
 *  The contents of this file may not be disclosed to third parties,
 *  copied or duplicated in any form, in whole or in part, without
 *  the prior written permission of Nothing Real, LLC.
 * 
 *  RESTRICTED RIGHTS LEGEND:
 *  Use, duplication or disclosure by the Government is subject to
 *  restrictions as set forth in subdivision (c)(1)(ii) of the Rights
 *  in Technical Data and Computer Software clause at DFARS 252.227-7013,
 *  and/or in similar or successor clauses in the FAR, DOD or NASA FAR
 *  Supplement. Unpublished rights reserved under the Copyright Laws of
 *  the United States.
 *
 *  $Header: /Release/Shake-v2.40/scripts/nrui.h 893   9/27/01 2:30p Mgix $
 *
 */

/*
 *  #1 DO NOT modify this file under any circumstances.
 *  #2 DO NOT modify this file under any circumstances.
 *  #3 DO NOT modify this file under any circumstances.
 *  #4 DO NOT copy this file in its entirety to an include directory for modification.
 *  #5 DO NOT name a file in your other include directories "nrui.h".
 *  
 *  DO copy the individual items you want to change to an include
 *  directory and customize their values there.
 *
 *  Why!?
 *
 *  #1-3 This file will change with newer versions of the software. If
 *  you change settings here, they will not apply to a new install.
 *  #4 If (when) this file changes in a new release and you've copied
 *  an old one in its entirety you will very likely override some
 *  items that have been modified for the new relase.
 *  #5 If another file called nrui.h is found, it will be used
 *  instead of this one.  See #4 for why this is bad.
 *
 *  Please do take a look at the section in the HTML manual about
 *  customizing Shake for details on where to put override settings.
 *  
 *  Please do use this file as a reference. You can see how to set
 *  node colors, attach widgets to parameters, set low/high/increment
 *  values for sliders, and much more.  Pretty much anything GUI
 *  related that you can customize is shown in this file.
 */


extern "libnrui_lx.so"
{
    void    nuiPushMenu(const char *menuName, int isPup= 0);
    void    nuiOpenMenu(const char *menuName);
    void    nuiPopMenu();
    void    nuiMenuItem(const char *itemName, curve cmd, curve = "");
    void    nuiMenuSeparator();

    void    nuiPopToolBox();
    void    nuiPushToolBox(const char *toolBoxName);
    void    nuiToolBoxItem(const char *entryName, curve cmd, int isCmd= 0);
    void    nuiAddToolboxFav(const char *entryName);

    void    nuiToolBoxDoInsert();
    void    nuiToolBoxDoBranch();
    void    nuiToolBoxDoCreate();
    void    nuiToolBoxDoReplace();
    void    nuiToolBoxDoLayer(const char *);
    void    nuiToolBoxMenuCall(curve cmd);

    void    nuiVDeskMakeNewViewer();
    void    nuiVDeskDeleteAllViewers();

    void    nuiTFieldCopy();
    void    nuiTFieldPaste();

    void    nuiNodeViewCut();
    void    nuiNodeViewCopy();
    void    nuiNodeViewPaste(int clone=0);
    void    nuiNodeViewDelete();
    void    nuiNodeViewLayout();
    void    nuiNodeViewGridSnap(int);
    void    nuiNodeViewCenter();
    void    nuiNodeViewRenderFlipbook();
    void    nuiNodeViewRender();
    void    nuiNodeViewFrame();
    void    nuiNodeViewZoomIn();
    void    nuiNodeViewZoomOut();
    void    nuiNodeViewSelectAll();
    void    nuiNodeViewSelectUp();
    void    nuiNodeViewSelectDown();
    void    nuiNodeViewSelectUpOne();
    void    nuiNodeViewSelectDownOne();
    void    nuiNodeViewSelectBunch();
    void    nuiNodeViewDisconnect();
    void    nuiNodeViewInvertSelection();
    void    nuiNodeViewSaveGroup(int);
    void    nuiNodeViewRestoreGroup(int);
    void    nuiNodeViewMakeMacro();
    void    nuiNodeViewSelectByName();
    void    nuiNodeViewGroup(int);
    void    nuiNodeViewOpenGroups(int);
    void    nuiNodeViewMacroBodies(int);
    void    nuiNodeViewIgnore(int);
    void    nuiNodeViewSwitchRadar();
    int     nuiNodeViewCheckRadar();
    void    nuiNodeViewSaveSelecttedAsNewScript();
    void    nuiNodeViewForceFileInReload(int);
    void    nuiNodeViewSwitchExprLink();
    int     nuiNodeViewCheckExprLink();

    void    nuiSetObjectColor(
	const char *objectName,
	float	bgRed=		1.0,
	float	bgGreen=	1.0,
	float	bgBlue=		1.0,
	float	fgRed=		1.0,
	float	fgGreen=	1.0,
	float	fgBlue=		1.0
    );
    void    nuiSetMultipleObjectsColor(
	float	bgRed,
	float	bgGreen,
	float	bgBlue,
	float	fgRed,
	float	fgGreen,
	float	fgBlue,
	const char *objectName,
        ....
    );

    void    nuiCurveEditorAddAllCurves();
    void    nuiCurveEditorRemoveCurves();
    void    nuiCurveEditorHideCurves();
    void    nuiCurveEditorShowCurves();
    void    nuiCurveEditorToggleVisiblity();
    void    nuiCurveEditorSelectAllCurves();
    void    nuiCurveEditorSelectCVs();
    void    nuiCurveEditorZoomIn();
    void    nuiCurveEditorZoomOut();
    void    nuiCurveEditorFrameAll();
    void    nuiCurveEditorFrameSelectedCurves();
    void    nuiCurveEditorFrameSelectedCVs();
    void    nuiCurveEditorToggleTimeCode();
    int     nuiCurveEditorCheckTimeCode();
    void    nuiCurveEditorToggleStickyTime();
    int     nuiCurveEditorCheckStickyTime();
    void    nuiCurveEditorToggleTimeSnap();
    void    nuiCurveEditorToggleInfoDisplay();
    int     nuiCurveEditorCheckTimeSnap();
    int     nuiCurveEditorCheckInfoDisplay();
    void    nuiCurveEditorSmoothCurve();
    void    nuiCurveEditorEditSmoothingFunction();

    void    nuiCurveListRemoveCurves();
    void    nuiCurveListHideCurves();
    void    nuiCurveListShowCurves();
    void    nuiCurveListToggleVisiblity();
    void    nuiCurveListSelectAllCurves();
    void    nuiCurveListSelectCVs();

    void    nuiCEViewNoLock();
    void    nuiCEViewXLock();
    void    nuiCEViewYLock();
    int     nuiCEViewChkNoLock();
    int     nuiCEViewChkXLock();
    int     nuiCEViewChkYLock();
    void    nuiCEImportCurvesV();
    void    nuiCEImportCurvesH();

    void    nuiVCtrlZoomIn();
    void    nuiVCtrlZoomOut();			
    void    nuiVCtrlResetView();			
    void    nuiVCtrlFitImageToViewer();		
    void    nuiVCtrlNewViewer();			
    void    nuiVCtrlDelViewer();			
    void    nuiVCtrlFitViewerToDesktop();		
    void    nuiVCtrlFitViewerToImage();		
    void    nuiVCtrlToggleIconify();			
    void    nuiVCtrlTweekCurrentVScript(int,int);
    void    nuiVCtrlDelKey();
    void    nuiVCtrlDelAllKeys();
    void    nuiVCtrlRGB();				
    void    nuiVCtrlR();				
    void    nuiVCtrlG();				
    void    nuiVCtrlB();				
    void    nuiVCtrlA();				

    void    nuiVCtrlTglRGB();
    void    nuiVCtrlTglR();
    void    nuiVCtrlTglG();
    void    nuiVCtrlTglB();
    void    nuiVCtrlTglA();
    void    nuiVCtrlTglUdOff();
    void    nuiVCtrlTglUdOn();
    void    nuiVCtrlTglUdProg();
    void    nuiVCtrlTglVS0();
    void    nuiVCtrlTglVS1();
    void    nuiVCtrlTglVS2();
    void    nuiVCtrlTglVS3();
    void    nuiVCtrlTglNoCmp();
    void    nuiVCtrlTglXWipe();
    void    nuiVCtrlTglYWipe();
    void    nuiVCtrlTglBlend();
    void    nuiVCtrlTglSh000();
    void    nuiVCtrlTglSh025();
    void    nuiVCtrlTglSh050();
    void    nuiVCtrlTglSh075();
    void    nuiVCtrlTglSh100();
    void    nuiVCtrlTglShowBB();
    void    nuiVCtrlTglHideBB();
    void    nuiVCtrlTglRender();
    void    nuiVCtrlTglRenderWindow();
    void    nuiVCtrlTglHideOSC();
    void    nuiVCtrlTglShowOSC();
    void    nuiVCtrlTglShowOSCR();
    void    nuiVCtrlTglAutoKeyOn();
    void    nuiVCtrlTglAutoKeyOff();
    void    nuiVCtrlDelKey();
    void    nuiVCtrlDelAllKeys();

    int    nuiVCtrlChkRGB();
    int    nuiVCtrlChkR();
    int    nuiVCtrlChkG();
    int    nuiVCtrlChkB();
    int    nuiVCtrlChkA();
    int    nuiVCtrlChkUdOff();
    int    nuiVCtrlChkUdOn();
    int    nuiVCtrlChkUdProg();
    int    nuiVCtrlChkVS0();
    int    nuiVCtrlChkVS1();
    int    nuiVCtrlChkVS2();
    int    nuiVCtrlChkVS3();
    int    nuiVCtrlChkNoCmp();
    int    nuiVCtrlChkXWipe();
    int    nuiVCtrlChkYWipe();
    int    nuiVCtrlChkBlend();
    int    nuiVCtrlChkShowBB();
    int    nuiVCtrlChkHideBB();
    int    nuiVCtrlChkHideOSC();
    int    nuiVCtrlChkShowOSC();
    int    nuiVCtrlChkShowOSCR();
    int    nuiVCtrlChkAutoKeyOn();
    int    nuiVCtrlChkAutoKeyOff();

    void    nuiTVToggleInOutPntDisplay();
    void    nuiTVToggleConstPntDisplay();
    void    nuiTVToggleTrim();
    int     nuiTVCheckInOutPntDisplay();
    int     nuiTVCheckConstPntDisplay();
    int     nuiTVCheckTrim();


    void    nuiFileBrowserAddFavorite(const char*);

    void    nuiUndo();
    void    nuiRedo();

    void    nuiAddMaskCommand(const char *name,const char *command);

    void    nuiDefControlAlias(const char *alias,const char *original);
    void    nuiPushControlGroup(const char *groupName);
    void    nuiGroupControl(const char*controlName);
    void    nuiPopControlGroup();
    void    nuiPushControlWidget(const char *groupName, curve cmd);

    void    nuiDefPCtrlLoc(
	const char *s,
	curve columnNum=-1
    );
    void    nuiDefSlider(
	const char *s,
	curve lo,
	curve hi,
	curve granularity= 0,
	curve notchSpacing= -1,
	curve virtualSlider=-1,
	int ignored= 0
    );

    void    nuiDefTweakerCol(
	const char *name,
	curve colNum,
	const char *label,
	curve spacing=0,
	curve width=-1,
	curve maxWidth = -1
    );

    void    nuiDefTweakerNumCol(
	const char *name,
	curve numCol    );

    void    nuiConnectColorPCtrl(int colorSpace=kRGBToggle,int stat=kCurrentColor,int useSourceBuf=0);
    void    nuiConnectColorTriplet(int colorSpace=kRGBToggle,int stat=kCurrentColor,int useSourceBuf=0);
    void    nuiSetColor(int colorNumber, float red, float green, float blue);


    // defines which input image to use for the input scrub
    void    nuiDefInputScrubSource(const char *name, int idx);

    // add a base plug name that will define a point onscreen control
    // there must be a set of plugs with the following names:  ${base}X, ${base}Y
    // for a point osc to be created.
    void    nuiAddPointOsc(const char *name);
};

nuiFileBrowserAddFavorite(getUserFilesPath());
nuiFileBrowserAddFavorite(getInstallPath());
nuiFileBrowserAddFavorite(getInstallPath()+"doc/pix");

nuiPushControlGroup("NRiMask.Mask");
    nuiGroupControl("NRiMask.maskChannel");
    nuiGroupControl("NRiMask.maskPercent");
    nuiGroupControl("NRiMask.invertMask");
    nuiGroupControl("NRiMask.enableMask");
nuiPopControlGroup();

nuiPushControlGroup("proxyScale");
    nuiGroupControl("proxyRatio");
    nuiGroupControl("proxyFilter");
    nuiGroupControl("pixelScale");
    nuiGroupControl("pixelRatio");
nuiPopControlGroup();

nuiPushControlGroup("motionBlur");
    nuiGroupControl("shutterTiming");
    nuiGroupControl("shutterOffset");
    nuiGroupControl("motionSharpness");
nuiPopControlGroup();



nuiPushControlGroup("timing");
    nuiGroupControl("startFrame");
    nuiGroupControl("endFrame");
    nuiGroupControl("timeShift");
    nuiGroupControl("inMode");
    nuiGroupControl("outMode");
nuiPopControlGroup();

nuiPushControlGroup("startFrame");
    nuiGroupControl("inPoint");
nuiPopControlGroup();

nuiPushControlGroup("endFrame");
    nuiGroupControl("outPoint");
nuiPopControlGroup();

//nuiPushControlGroup("hueRange");
//    nuiGroupControl("hueFalloff");
//    nuiGroupControl("hueSharpness");
//nuiPopControlGroup();

//nuiPushControlGroup("hueRange");
//    nuiGroupControl("hueFalloff");
//    nuiGroupControl("hueSharpness");
//nuiPopControlGroup();

//nuiPushControlGroup("satRange");
//    nuiGroupControl("satFalloff");
//    nuiGroupControl("satSharpness");
//nuiPopControlGroup();

//nuiPushControlGroup("valRange");
//    nuiGroupControl("valFalloff");
//    nuiGroupControl("valSharpness");
//nuiPopControlGroup();

nuiPushControlGroup("applyX");
    nuiGroupControl("xShift");
nuiPopControlGroup();
nuiPushControlGroup("applyY");
    nuiGroupControl("yShift");
nuiPopControlGroup();
//nuiPushControlGroup("applyScale");
//nuiPopControlGroup();
nuiPushControlGroup("applyScale");
    nuiGroupControl("Stabilize.scale");
    nuiGroupControl("MatchMove.scale");
nuiPopControlGroup();
nuiPushControlGroup("applyRotate");
    nuiGroupControl("MatchMove.rotate");
    nuiGroupControl("Stabilize.rotate");
nuiPopControlGroup();

nuiPushControlGroup("Color");
    nuiGroupControl("red");
    nuiGroupControl("green");
    nuiGroupControl("blue");
nuiPopControlGroup();
nuiPushControlGroup("LLColor");
    nuiGroupControl("rLL");
    nuiGroupControl("gLL");
    nuiGroupControl("bLL");
nuiPopControlGroup();
nuiPushControlGroup("ULColor");
    nuiGroupControl("rUL");
    nuiGroupControl("gUL");
    nuiGroupControl("bUL");
nuiPopControlGroup();
nuiPushControlGroup("LRColor");
    nuiGroupControl("rLR");
    nuiGroupControl("gLR");
    nuiGroupControl("bLR");
nuiPopControlGroup();
nuiPushControlGroup("URColor");
    nuiGroupControl("rUR");
    nuiGroupControl("gUR");
    nuiGroupControl("bUR");
nuiPopControlGroup();
nuiPushControlGroup("Color1");
    nuiGroupControl("red1");
    nuiGroupControl("green1");
    nuiGroupControl("blue1");
nuiPopControlGroup();
nuiPushControlGroup("Color2");
    nuiGroupControl("red2");
    nuiGroupControl("green2");
    nuiGroupControl("blue2");
nuiPopControlGroup();

nuiPushControlGroup("ColorSettings");

nuiPushControlGroup("fontColor");
    nuiGroupControl("NRiScript.fontRed");
    nuiGroupControl("NRiScript.fontGreen");
    nuiGroupControl("NRiScript.fontBlue");
nuiPopControlGroup();
nuiPushControlWidget("fontColor",nuiConnectColorTriplet(kRGBToggle,kCurrentColor,1));

nuiPushControlGroup("noodleColor");
	nuiGroupControl("NRiScript.noodleRed");
	nuiGroupControl("NRiScript.noodleGreen");
	nuiGroupControl("NRiScript.noodleBlue");
nuiPopControlGroup();
nuiGroupControl("NRiScript.noodleTension");

nuiPushControlWidget("noodleColor",nuiConnectColorTriplet(kRGBToggle,kCurrentColor,1));
nuiPopControlGroup();


nuiPushControlGroup("centerColor");
    nuiGroupControl("RGrad.rCenter");
    nuiGroupControl("RGrad.gCenter");
    nuiGroupControl("RGrad.bCenter");
nuiPopControlGroup();
nuiPushControlGroup("edgeColor");
    nuiGroupControl("rEdge");
    nuiGroupControl("gEdge");
    nuiGroupControl("bEdge");
nuiPopControlGroup();
nuiPushControlGroup("HSVColor");
    nuiGroupControl("hue");
    nuiGroupControl("sat");
    nuiGroupControl("val");
nuiPopControlGroup();
nuiPushControlGroup("source Color");
    nuiGroupControl("sourceHue");
    nuiGroupControl("sourceSat");
    nuiGroupControl("sourceVal");
nuiPopControlGroup();
nuiPushControlGroup("destination Color");
    nuiGroupControl("destHue");
    nuiGroupControl("destSat");
    nuiGroupControl("destVal");
nuiPopControlGroup();
nuiPushControlGroup("Source Color");
    nuiGroupControl("rSource");
    nuiGroupControl("gSource");
    nuiGroupControl("bSource");
nuiPopControlGroup();
nuiPushControlGroup("Replace Color");
    nuiGroupControl("rReplace");
    nuiGroupControl("gReplace");
    nuiGroupControl("bReplace");
nuiPopControlGroup();
nuiPushControlGroup("Low Color");
    nuiGroupControl("rLo");
    nuiGroupControl("gLo");
    nuiGroupControl("bLo");
nuiPopControlGroup();
nuiPushControlGroup("High Color");
    nuiGroupControl("rHi");
    nuiGroupControl("gHi");
    nuiGroupControl("bHi");
nuiPopControlGroup();
nuiPushControlGroup("Shadow Color");
    nuiGroupControl("rShadow");
    nuiGroupControl("gShadow");
    nuiGroupControl("bShadow");
nuiPopControlGroup();



nuiPushControlGroup("source1XPosition");
    nuiGroupControl("source1YPosition");
    nuiGroupControl("source2XPosition");
    nuiGroupControl("source2YPosition");
    nuiGroupControl("source3XPosition");
    nuiGroupControl("source3YPosition");
    nuiGroupControl("source4XPosition");
    nuiGroupControl("source4YPosition");
nuiPopControlGroup();	

nuiPushControlGroup("LogLin.rBlack");
    nuiGroupControl("LogLin.gBlack");
    nuiGroupControl("LogLin.bBlack");
nuiPopControlGroup();

nuiPushControlGroup("LogLin.rWhite");
    nuiGroupControl("LogLin.gWhite");
    nuiGroupControl("LogLin.bWhite");
nuiPopControlGroup();

nuiPushControlGroup("LogLin.rNGamma");
    nuiGroupControl("LogLin.gNGamma");
    nuiGroupControl("LogLin.bNGamma");
nuiPopControlGroup();

nuiPushControlGroup("LogLin.rDGamma");
    nuiGroupControl("LogLin.gDGamma");
    nuiGroupControl("LogLin.bDGamma");
nuiPopControlGroup();
nuiPushControlGroup("LogLin.rSoftClip");
    nuiGroupControl("LogLin.gSoftClip");
    nuiGroupControl("LogLin.bSoftClip");
nuiPopControlGroup();

//
//This assigns grouping to parameters 
//only inside of Shake-style layout.
//

if(gui.trm==0)
{

nuiPushControlGroup("useReference");
    nuiGroupControl("referenceFrame");
nuiPopControlGroup();

nuiPushControlGroup("AOI Controls");
    nuiGroupControl("Constraint.left");
    nuiGroupControl("Constraint.right");
    nuiGroupControl("Constraint.bottom");
    nuiGroupControl("Constraint.top");
nuiPopControlGroup();

nuiPushControlGroup("Channel and Field Controls");
    nuiGroupControl("Constraint.channels");
    nuiGroupControl("Constraint.field");
 nuiPopControlGroup();

nuiPushControlGroup("softness");
    nuiGroupControl("rSoftness");
    nuiGroupControl("gSoftness");
    nuiGroupControl("bSoftness");
nuiPopControlGroup();

nuiPushControlGroup("rGain");
    nuiGroupControl("rBias");
    nuiGroupControl("rLowOffset");
    nuiGroupControl("rHighOffset");
nuiPopControlGroup();
nuiPushControlGroup("gGain");
    nuiGroupControl("gBias");
    nuiGroupControl("gLowOffset");
    nuiGroupControl("gHighOffset");
nuiPopControlGroup();
nuiPushControlGroup("bGain");
    nuiGroupControl("bBias");
    nuiGroupControl("bLowOffset");
    nuiGroupControl("bHighOffset");
nuiPopControlGroup();

nuiPushControlGroup("Grain.size");
    nuiGroupControl("Grain.rSize");
    nuiGroupControl("Grain.gSize");
    nuiGroupControl("Grain.bSize");
nuiPopControlGroup();

nuiPushControlGroup("density");
    nuiGroupControl("rDensity");
    nuiGroupControl("gDensity");
    nuiGroupControl("bDensity");
nuiPopControlGroup();

nuiPushControlGroup("luminanceBias");
	nuiGroupControl("ColorSpace.rWeight");
	nuiGroupControl("ColorSpace.gWeight");
	nuiGroupControl("ColorSpace.bWeight");
nuiPopControlGroup();
}

//
//End Shake-only parameter grouping
//
nuiPushControlWidget("Color",nuiConnectColorTriplet());
nuiPushControlWidget("LLColor",nuiConnectColorTriplet());
nuiPushControlWidget("ULColor",nuiConnectColorTriplet());
nuiPushControlWidget("LRColor",nuiConnectColorTriplet());
nuiPushControlWidget("URColor",nuiConnectColorTriplet());
nuiPushControlWidget("Color1",nuiConnectColorTriplet());
nuiPushControlWidget("Color2",nuiConnectColorTriplet());
nuiPushControlWidget("centerColor",nuiConnectColorTriplet());
nuiPushControlWidget("edgeColor",nuiConnectColorTriplet());
nuiPushControlWidget("HSVColor",nuiConnectColorTriplet(kHSVToggle));
nuiPushControlWidget("source Color",nuiConnectColorTriplet(kHSVToggle));
nuiPushControlWidget("destination Color",nuiConnectColorTriplet(kHSVToggle));
nuiPushControlWidget("Low Color",nuiConnectColorTriplet());
nuiPushControlWidget("High Color",nuiConnectColorTriplet());
nuiPushControlWidget("Shadow Color",nuiConnectColorTriplet());
nuiPushControlWidget("Source Color",nuiConnectColorTriplet());

nuiPushControlWidget("HSVColor",nuiConnectColorTriplet(kHSVToggle));
nuiPushControlWidget("Shadow Color",nuiConnectColorTriplet());
nuiPushControlWidget("Color",nuiConnectColorTriplet());
nuiPushControlWidget("Replace Color",nuiConnectColorTriplet());

const int kExprIn=	    0;
const int kExprOut=	    1;
const int kImageIn=	    2;
const int kImageOut=	    3;
const int kScriptIn=	    4;
const int kScriptOut=	    5;
const int kTrackDataIn=	    6;
const int kTrackDataOut=    7;
const int kAnyIn=	    8;
const int kAnyOut=	    9;
const int kDirIn=	    16;
const int kDirOut=	    17;

const int kCurrentColor=   0;
const int kAverageColor=   1;
const int kMinColor=	   2;
const int kMaxColor=	   3;

const int kRGBToggle=	   0;
const int kHSVToggle=	   1;
const int kHLSToggle=	   2;
const int kCMYToggle=	   3;

const int kBlack=	    0x00;
const int kR=		    0x08;
const int kG=		    0x04;
const int kB=		    0x02;
const int kL=		    0x04;
const int kRGB=		    0x0e;
const int kA=		    0x01;
const int kRA=		    0x09;
const int kGA=		    0x05;
const int kBA=		    0x03;
const int kLA=		    0x05;
const int kRGBA=	    0x0f;
const int kZ=		    0x10;
const int kRGBAZ=	    0x1f;

extern "libnrux_lx.so"
{
    void    nuxDefMultiChoice(const char *, curve string choices,int close=0 );
    void    nuxDefToggle(const char *name, curve string state0 = 0, ....);
    void    nuxDefExprToggle(const char *name, curve string state0 = 0, ....);
    void    nuxDefTrackCtrl(const char *name);
    void    nuxDefBrowseCtrl(const char *name,int);

    // nuxDefButtonCtrl icons should be one or more of the following in this order: "std|focused|down|inactive"
    // the button control should be attached to an integer plug that uses notify as a callback
    void    nuxDefButtonCtrl(const char *name, int useLabel=0, int align=1, curve string icons=0);
    void    nuxDefTextCtrl(const char *name, int align=0);

    // nuxDefRadioBtnCtrl states consist of the following:  "${value}|${button_label or icon_base_name}". 
    // if useIcon is set, the icons specified by ${icon_base_name}.on.nri, ${icon_base_name}.on.focus.nri, 
    // ${icon_base_name}.off.nri, and ${icon_base_name}.off.focus.nri will be displayed.  
    // otherwise the button label will be dislplayed with the generic on / off icons.
    void    nuxDefRadioBtnCtrl(const char *name, int useIcon, int useLabel, int animatable, curve string state0, ....);
    // radio btn cntrl w/o text field
    void    nuxDefRadioBtnOCtrl(const char *name, int useIcon, int useLabel, int animatable, curve string state0, ....);
    void    registerCurveFunc(const char *name);
    void    registerCurveFuncVisible(const char *name);

};

extern "C"
{
    	    void    nuiExit(int);
    	    image   IFileIn();
    	    image   IFileOut();
    const   char    *getFileInName();
    const   char    *getFileOutName();
    const   char    *getScriptInName(const char * =0, int* =0);
    const   char    *getScriptOutName(const char * =0, int* =0);
    	    void    spawnViewerDesktop(int x, int y, int w, int h);
    	    void    nuiMakeNewViewer();
    	    void    nuiDoAbout();
	    void    nuiFind();
	    void    nuiGUISettings(int);
    	    int	    nuiNewScript(void*,int);
	    void    nuiAddScript(void*,int);
    	    void    nuiLoadScript(void*,int);
    	    void    nuiReloadScript(void*,int);
    	    void    nuiSaveScript(void*,int);
    	    void    nuiSaveScriptAs(void*,int);
	    void    nriDefStdPCtrl(const char *name);
	    void    nriDefNoKeyPCtrl(const char *name);
	    void    nuiRenderFlipbook();
	    void    nuiRender();
	    void    nuiTreeViewCopy();
	    void    nuiTreeViewPaste();
	    void    nuiPCtrlLoadExpression();
	    void    nuiPCtrlSaveExpression();
	    void    nuiPCtrlClearExpression();
	    void    nuiPCtrlDeleteKey();
	    void    nuiTrackPCtrlLoadFile();
	    void    nuiTrackPCtrlSave();
	    void    nuiTrackPCtrlClear();
	    void    nuiTrackPCtrlLoad();
	    void    nuiTrackPCtrlLink();
	    void    nuiTrackPCtrlAverage();
	    void    nuiTrackPCtrlSmooth();
	    void    nuiTweekClear();
	    void    nuiAddVariable();
	    void    nuiDeleteVariable();
	    void    nuiAddNotes();
	    void    nuiResetValues();

};

nuiPushMenu("File");
    nuiMenuItem("New Script (Ctrl+N)",		nuiNewScript(0,0));
    nuiMenuItem("Open Script (Ctrl+O)",		nuiLoadScript(0,0));
    nuiMenuItem("Reload Script",		nuiReloadScript(0,0));
    nuiMenuItem("Add Script",			nuiAddScript(0,0));
    nuiMenuItem("Save Script (Ctrl+S)",		nuiSaveScript(0,0));
    nuiMenuItem("Save Script As (Ctrl+Shift+S)",nuiSaveScriptAs(0,0));
    nuiMenuItem("Save Selection as script (S)",	nuiNodeViewSaveSelecttedAsNewScript());
    nuiMenuSeparator();
    nuiMenuItem("Load Interface Settings",	nuiGUISettings(1));
    nuiMenuItem("Save Interface Settings",	nuiGUISettings(0));
    nuiMenuSeparator();
    nuiMenuItem("Flush Cache",                  nriDiskCacheControl(kDiskCacheFlush));
    nuiMenuItem("Purge Memory Cache",           nriDiskCacheControl(kDiskCachePurgeMemory));
    nuiMenuSeparator();
    nuiMenuItem("Exit (Ctrl+Shift+Alt+X)",	nuiExit(0));
nuiPopMenu();

nuiPushMenu("Edit");
    nuiMenuItem("Undo (Ctrl+Z)",		nuiUndo());
    nuiMenuItem("Redo (Ctrl+Y)",		nuiRedo());
    nuiMenuSeparator();
    nuiMenuItem("Find nodes (Ctrl+F)",		nuiFind());
nuiPopMenu();


// toolbox items created below automatically create an equivalent menu item 
// in whatever menu is currently active, so the Effects menu will get populated
// as we add new items in the toolbox.

// ToolBox Color and Node Color variables. You can change the variables or modify
// individual tabs or nodes by looking or adding
// nuiSetObjectColor("Name", bgRed, bgGreen, bgBlue, fgRed, fgGreen, fgBlue);.
// Name is either the FunctionName or NameToolBox 

float imageToolBoxRed = 0.95;
float imageToolBoxGreen = 0.95;
float imageToolBoxBlue = 0.5;

float colorToolBoxRed = 1.0;
float colorToolBoxGreen = 1.0;
float colorToolBoxBlue = 1.0;

float filterToolBoxRed = colorToolBoxRed;
float filterToolBoxGreen = colorToolBoxGreen;
float filterToolBoxBlue = colorToolBoxBlue;

float keyToolBoxRed = colorToolBoxRed;
float keyToolBoxGreen = colorToolBoxGreen;
float keyToolBoxBlue = colorToolBoxBlue;

float layerToolBoxRed = 1.0;
float layerToolBoxGreen = 1.0;
float layerToolBoxBlue = 1.15;

float transformToolBoxRed = 0.6;
float transformToolBoxGreen = 0.6;
float transformToolBoxBlue = 0.8;

float warpToolBoxRed = colorToolBoxRed;
float warpToolBoxGreen = colorToolBoxGreen;
float warpToolBoxBlue = colorToolBoxBlue;

float otherToolBoxRed = colorToolBoxRed;
float otherToolBoxGreen = colorToolBoxGreen;
float otherToolBoxBlue = colorToolBoxBlue;

float imageTextCol = 0.8;
float layerTextCol = imageTextCol;
float standardTextCol = imageTextCol;
float transformTextCol = imageTextCol;
float tabTextCol = 1;
float imageTabTextCol = 0.0;

// These control the color of text on an active tab
gui.tabber.activeTint.red = .9;
gui.tabber.activeTint.green = .9;
gui.tabber.activeTint.blue = .87;

//These control the color of text on an inactive tab

gui.tabber.tint.red = .65;
gui.tabber.tint.green = .65;
gui.tabber.tint.blue = .63;



nuiPushMenu("Tools");
nuiPushToolBox("Image");
    nuiToolBoxItem("Average",	    " const char *fileName = getFileInName(); fileName ? Average(fileName,1,5,1,3,1,1.5,1.0) : (image)0; ");
    nuiToolBoxItem("Checker",	    Checker());
    nuiToolBoxItem("Color",	    Color());
    nuiToolBoxItem("ColorWheel",    ColorWheel());
    nuiToolBoxItem("FileIn",	    IFileIn());
    nuiToolBoxItem("FileOut",	    IFileOut());
    nuiToolBoxItem("Grad",	    Grad());
    nuiToolBoxItem("PullDown",	    " const char *fileName = getFileInName(); fileName ? PullDown(fileName) : (image)0; ");
    nuiToolBoxItem("PullUp",	    " const char *fileName = getFileInName(); fileName ? PullUp(fileName) : (image)0; ");
    nuiToolBoxItem("QuickPaint",    QuickPaint(0));
    nuiToolBoxItem("QuickShape",    QuickShape());
    nuiToolBoxItem("Rand",	    Rand());
    nuiToolBoxItem("Ramp",	    Ramp());
    nuiToolBoxItem("RGrad",	    RGrad());
    nuiToolBoxItem("RotoShape",	    RotoShape());
    nuiToolBoxItem("Text",	    Text());

    nuiAddToolboxFav("FileIn");
    nuiAddToolboxFav("QuickPaint");
    nuiAddToolboxFav("RotoShape");

    nuiSetObjectColor("ImageToolBox", imageToolBoxRed*.75, imageToolBoxGreen*.75, imageToolBoxBlue*.75,imageTabTextCol,imageTabTextCol,imageTabTextCol);
nuiPopToolBox();

nuiPushToolBox("Color");
    nuiToolBoxItem("Add",	    Add(0,0,0,0,0,0));
    nuiToolBoxItem("AdjustHSV",	    AdjustHSV(0));
    nuiToolBoxItem("Brightness",    Brightness(0,1));
    nuiToolBoxItem("Clamp",	    Clamp(0));
    nuiToolBoxItem("ColorCorrect", ColorCorrect(0));
    nuiToolBoxItem("ColorMatch",    ColorMatch());
    nuiToolBoxItem("ColorReplace",  ColorReplace(0));
    nuiToolBoxItem("ColorSpace",    ColorSpace(0));
    nuiToolBoxItem("ColorX",	    ColorX(0,r,g,b,a,z));
    nuiToolBoxItem("Compress",	    Compress(0));
    nuiToolBoxItem("ContrastLum",   ContrastLum(0,1,0.5,0));
    nuiToolBoxItem("ContrastRGB",   ContrastRGB(0,1,1,1,1,0.5,0.5,0.5,0.5,0,0,0,0));
//  nuiToolBoxItem("DelogC",	    DelogC(0));
//  nuiToolBoxItem("DelogRGB",	    DelogRGB(0));
    nuiToolBoxItem("Expand",	    Expand(0));
    nuiToolBoxItem("Fade",	    Fade(0));
    nuiToolBoxItem("Gamma",	    Gamma(0));
    nuiToolBoxItem("HueCurves",	    HueCurves());
    nuiToolBoxItem("Invert",	    Invert(0));
//  nuiToolBoxItem("LogC",	    LogC(0));
//  nuiToolBoxItem("LogRGB",	    LogRGB(0));
    nuiToolBoxItem("LogLin",		LogLin());
    nuiToolBoxItem("Lookup",	    Lookup(0,x,x,x,x));
    nuiToolBoxItem("LookupFile",    LookupFile(0,"","rgba"));
    nuiToolBoxItem("LookupHLS",	    LookupHLS(0,x,x,x,x));
    nuiToolBoxItem("LookupHSV",	    LookupHSV(0,x,x,x,x));
    nuiToolBoxItem("MDiv",	    MDiv(0));
    nuiToolBoxItem("MMult",	    MMult(0));
    nuiToolBoxItem("Monochrome",    Luminance(0));
    nuiToolBoxItem("Mult",	    Mult(0));
    nuiToolBoxItem("Reorder",	    Reorder(0));
    nuiToolBoxItem("Saturation",    Saturation(0));
    nuiToolBoxItem("Set",	    Set(0));
    nuiToolBoxItem("SetAlpha",	    SetAlpha(0));
    nuiToolBoxItem("SetBGColor",    SetBGColor(0));
    nuiToolBoxItem("Solarize",	    Solarize(0));
    nuiToolBoxItem("Threshold",    Threshold());
    nuiToolBoxItem("VideoSafe",	    VideoSafe(0));




    nuiAddToolboxFav("ColorCorrect");
    nuiAddToolboxFav("LogLin");
    nuiAddToolboxFav("Brightness");
//    nuiSetObjectColor("ColorToolBox", colorToolBoxRed*.7, colorToolBoxGreen*.7, colorToolBoxBlue*.7,0,0,0);
nuiPopToolBox();

nuiPushToolBox("Filter");
    nuiToolBoxItem("ApplyFilter",   ApplyFilter(0));
    nuiToolBoxItem("Blur",	    Blur(0));
    nuiToolBoxItem("Convolve",	    Convolve(0));
    nuiToolBoxItem("Defocus",	    Defocus(0));
    nuiToolBoxItem("DilateErode",   DilateErode(0,"rgba",0));
    nuiToolBoxItem("Emboss",	    Emboss(0,10,45,30));
    nuiToolBoxItem("EdgeDetect",    EdgeDetect());
    nuiToolBoxItem("Grain",	    Grain(0));
    nuiToolBoxItem("IBlur",	    IBlur(0,0,0));
    nuiToolBoxItem("IDefocus",	    IDefocus(0,0,0));
    nuiToolBoxItem("IDilateErode",  IDilateErode(0,0,"rgba",0));
    nuiToolBoxItem("IRBlur",	    IRBlur(0,0, width/2, height/2,0,width,1,1,.5,.25,0,5,1,"a",0)); 
    nuiToolBoxItem("ISharpen",	    ISharpen(0,0));
    nuiToolBoxItem("Median",	    Median(0,"rgba",1,0));
    nuiToolBoxItem("PercentBlur",   PercentBlur(0,0));
    nuiToolBoxItem("Pixelize",	    Pixelize(0,4));
    nuiToolBoxItem("RBlur",	    RBlur(0));
    nuiToolBoxItem("Sharpen",	    Sharpen(0));
    nuiToolBoxItem("ZBlur",	    ZBlur(0));
    nuiToolBoxItem("ZDefocus",	    ZDefocus(0));

    nuiAddToolboxFav("Blur");
    nuiAddToolboxFav("DilateErode");
//    nuiSetObjectColor("FilterToolBox", filterToolBoxRed*.7, filterToolBoxGreen*.7, filterToolBoxBlue*.7,0,0,0);
nuiPopToolBox();

nuiPushToolBox("Key");
    nuiToolBoxItem("ChromaKey",	    ChromaKey(0,0.6667,0.2,0.1,0.5,1,0.4,0.8,0.5,1,0.8,0.1,0.5,0,0));
    nuiToolBoxItem("DepthKey",	    DepthKey(0,0,1,0,0,0));
    nuiToolBoxItem("DepthSlice",    DepthSlice(0));
    nuiToolBoxItem("LumaKey",	    LumaKey(0,0,1,0,0,0));
    nuiToolBoxItem("Primatte",	    Primatte_v2(0));
    nuiToolBoxItem("SpillSuppress", SpillSuppress(0,1,1,1,0));

    nuiAddToolboxFav("Primatte");
    nuiAddToolboxFav("Keylight");
//    nuiSetObjectColor("KeyToolBox", keyToolBoxRed*.7, keyToolBoxGreen*.7, keyToolBoxBlue*.7,0,0,0);
nuiPopToolBox();

nuiPushToolBox("Layer");
    nuiToolBoxItem("AddMix",        AddMix());
    nuiToolBoxItem("AddText",	    AddText(0));
    nuiToolBoxItem("Atop",	    Atop(0,0));
    nuiToolBoxItem("Common",	    Common(0,0));
    nuiToolBoxItem("Constraint",    Constraint(0,0));
    nuiToolBoxItem("Copy",	    Copy(0,0));
    nuiToolBoxItem("IAdd",	    IAdd(0,0));
    nuiToolBoxItem("IDiv",	    IDiv(0,0));
    nuiToolBoxItem("IMult",	    IMult(0,0));
    nuiToolBoxItem("Inside",	    Inside(0,0));
    nuiToolBoxItem("Interlace",	    Interlace(0,0));
    nuiToolBoxItem("ISub",	    ISub(0,0));
    nuiToolBoxItem("ISubA",	    ISubA(0,0));
    nuiToolBoxItem("KeyMix",	    KeyMix(0,0,0));
 //  nuiToolBoxItem("LayerMacro",    LayerMacro(0,0,1,"Over",100,100,"rgba",0,0,0,0));
    nuiToolBoxItem("Layer",         Layer(0,0,"Over"));
    nuiToolBoxItem("LayerX",	    LayerX(0,0));
    nuiToolBoxItem("Max",	    Max(0,0));
    nuiToolBoxItem("Min",	    Min(0,0));
    nuiToolBoxItem("Mix",	    Mix(0,0));
    nuiToolBoxItem("Outside",	    Outside(0,0));
    nuiToolBoxItem("Over",	    Over(0,0));
    nuiToolBoxItem("Screen",	    Screen(0,0));
    nuiToolBoxItem("SwitchMatte",   SwitchMatte(0,0));
    nuiToolBoxItem("Under",	    Under(0,0));
    nuiToolBoxItem("Xor",           Xor(0,0));
    nuiToolBoxItem("ZCompose",	    ZCompose(0,0));

    nuiAddToolboxFav("Layer");
    nuiAddToolboxFav("KeyMix");
    nuiSetObjectColor("LayerToolBox", layerToolBoxRed*.6, layerToolBoxGreen*.6, layerToolBoxBlue*.6,imageTabTextCol,imageTabTextCol,imageTabTextCol);

nuiPopToolBox();

nuiPushToolBox("Transform");
    nuiToolBoxItem("CameraShake",   CameraShake(0));
    nuiToolBoxItem("CornerPin",	    CornerPin(0,0,0,width,0,width,height,0,height));
    nuiToolBoxItem("Crop",	    Crop(0));
    nuiToolBoxItem("Fit",	    Fit(0));
    nuiToolBoxItem("Flip",	    Flip(0));
    nuiToolBoxItem("Flop",	    Flop(0));
    nuiToolBoxItem("MatchMove",	    MatchMove(0,0));
    nuiToolBoxItem("Move2D",	    Move2D(0));
    nuiToolBoxItem("Move3D",	    Move3D(0));
    nuiToolBoxItem("Orient",	    Orient(0));
    nuiToolBoxItem("Pan",	    Pan(0));
    nuiToolBoxItem("Resize",	    Resize(0));
    nuiToolBoxItem("Rotate",	    Rotate(0));
    nuiToolBoxItem("Scale",	    Scale(0));
    nuiToolBoxItem("Scroll",	    Scroll(0));
    nuiToolBoxItem("SetDOD",	    SetDOD(0));
    nuiToolBoxItem("Shear",	    Shear(0));
    nuiToolBoxItem("Stabilize",	    Stabilize(0));
    nuiToolBoxItem("Tracker",	    Tracker(0));
    nuiToolBoxItem("Viewport",	    Viewport(0));
    nuiToolBoxItem("Window",	    Window(0));
    nuiToolBoxItem("Zoom",	    Zoom(0,1));

    nuiAddToolboxFav("Move3D");
    nuiAddToolboxFav("Stabilize");

    nuiSetObjectColor("TransformToolBox", transformToolBoxRed*.8, transformToolBoxGreen*.8, transformToolBoxBlue*.8,imageTabTextCol,imageTabTextCol,imageTabTextCol);

nuiPopToolBox();

nuiPushToolBox("Warp");
    nuiToolBoxItem("DisplaceX",	    DisplaceX(0,0));
    nuiToolBoxItem("IDisplace",	    IDisplace(0,0));
    nuiToolBoxItem("PinCushion",    PinCushion(0));
    nuiToolBoxItem("Randomize",	    Randomize(0));
    nuiToolBoxItem("Turbulate",	    Turbulate(0));
    nuiToolBoxItem("Twirl",	    Twirl(0));
    nuiToolBoxItem("WarpX",	    WarpX(0));


    nuiAddToolboxFav("IDisplace");


//    nuiSetObjectColor("WarpToolBox", warpToolBoxRed*.7, warpToolBoxGreen*.7, warpToolBoxBlue*.7,0,0,0);
nuiPopToolBox();

nuiPushToolBox("Other");
    nuiToolBoxItem("AddBorders",    AddBorders(0,0,0));
    nuiToolBoxItem("AddShadow",	    AddShadow(0,40,-40,60,0.01,0.02,0.05,0.6));
    nuiToolBoxItem("Bytes",	    Bytes(0));
    nuiToolBoxItem("DeInterlace",   Deinterlace(0,0));
    nuiToolBoxItem("DropShadow",    DropShadow(0,60,0.01,0.02,0.05,0.6));
    nuiToolBoxItem("Field",	    Field(0,0));
    nuiToolBoxItem("Histogram",	    Histogram(0,512,512,0,0));
    nuiToolBoxItem("PlotScanline",  PlotScanline(0));
    nuiToolBoxItem("Select",	    Select(1,0,0,0,0));
    nuiToolBoxItem("SwapFields",    SwapFields(0));
    nuiToolBoxItem("Tile",	    Tile(0));
    nuiToolBoxItem("TimeX",	    TimeX(0, JSpline(1,inPoint@inPoint,outPoint@outPoint), inPoint, outPoint));
    nuiToolBoxItem("Transition",    Transition(0,0));


    nuiAddToolboxFav("Bytes");

	//nuiAddToolboxFav("Transition");
//    nuiSetObjectColor("OtherToolBox", otherToolBoxRed*.7, otherToolBoxGreen*.7, otherToolBoxBlue*.7,0,0,0);


nuiPopToolBox();
nuiPopMenu();

nuiPushMenu("Viewers");
    nuiMenuItem("New Viewer",	nuiMakeNewViewer());
    nuiMenuItem("Spawn Viewer Desktop",	spawnViewerDesktop(100,100,640,480));
nuiPopMenu();

nuiPushMenu("Render");
    nuiMenuItem("Render FlipBook",  	         nuiRenderFlipbook());
    nuiMenuItem("Render FileOut Nodes",          nuiRender());
nuiPopMenu();

nuiPushMenu("Help");
    nuiMenuItem("About Shake",	nuiDoAbout());
    nuiMenuItem("Documentation",	LaunchDocBrowser(getInstallPath()+"doc/index.html"));
    nuiMenuItem("Support Form",		LaunchDocBrowser(getInstallPath()+"doc/shared/supportform.html"));
    nuiMenuItem("Nothing Real Home Page",LaunchBrowser("http://www.nothingreal.com",0));
nuiPopMenu();

/*
 * Right mouse button popups
 */

nuiPushMenu("NRiTrackPCtrlPopup",1);
    nuiMenuItem("Copy Group (Ctrl+C)",		    nuiTreeViewCopy());
    nuiMenuItem("Paste Group (Ctrl+V)",		    nuiTreeViewPaste());
    nuiMenuSeparator();
    nuiMenuItem("Load Track",  nuiTrackPCtrlLoad());
    nuiMenuItem("Link Track",  nuiTrackPCtrlLink());
    nuiMenuItem("Average Tracks",  nuiTrackPCtrlAverage());
    nuiMenuItem("Smooth Track",    nuiTrackPCtrlSmooth());
    nuiMenuSeparator();
    nuiMenuItem("Load Track File",  nuiTrackPCtrlLoadFile());
    nuiMenuItem("Save Track File",  nuiTrackPCtrlSave());
    nuiMenuItem("Clear Track", nuiTrackPCtrlClear());
    nuiMenuSeparator();
    nuiMenuItem("Clear Tab", nuiTweekClear());
    nuiMenuItem("Create Local Variable", nuiAddVariable());
    nuiMenuItem("Delete Local Variable", nuiDeleteVariable());
    nuiMenuItem("Add Notes", nuiAddNotes());
nuiPopMenu();

nuiPushMenu("NRiTrackTFieldPopup",1);
    nuiMenuItem("Copy (Ctrl+C)",		    nuiTFieldCopy());
    nuiMenuItem("Paste (Ctrl+V)",		    nuiTFieldPaste());
    nuiMenuSeparator();
    nuiMenuItem("Load Track",			    nuiTrackPCtrlLoad());
    nuiMenuItem("Link Track",			    nuiTrackPCtrlLink());
    nuiMenuItem("Average Tracks",		    nuiTrackPCtrlAverage());
    nuiMenuItem("Smooth Track",			    nuiTrackPCtrlSmooth());
    nuiMenuSeparator();
    nuiMenuItem("Load Track File",		    nuiTrackPCtrlLoadFile());
    nuiMenuItem("Save Track File",		    nuiTrackPCtrlSave());
    nuiMenuItem("Clear Track",			    nuiTrackPCtrlClear());
    nuiMenuSeparator();
    nuiMenuItem("Clear Tab",			    nuiTweekClear());
    nuiMenuItem("Create Local Variable",	    nuiAddVariable());
    nuiMenuItem("Delete Local Variable",	    nuiDeleteVariable());
    nuiMenuItem("Add Notes",			    nuiAddNotes());
nuiPopMenu();

nuiPushMenu("NRiTFieldPopup",1);
    nuiMenuItem("Copy (Ctrl+C)",		    nuiTFieldCopy());
    nuiMenuItem("Paste (Ctrl+V)",		    nuiTFieldPaste());
nuiPopMenu();

nuiPushMenu("NRiExprTFieldPopup",1);
    nuiMenuItem("Copy (Ctrl+C)",		    nuiTFieldCopy());
    nuiMenuItem("Paste (Ctrl+V)",		    nuiTFieldPaste());
    nuiMenuSeparator();
    nuiMenuItem("Load Expression",		    nuiPCtrlLoadExpression());
    nuiMenuItem("Save Expression",		    nuiPCtrlSaveExpression());
    nuiMenuItem("Clear Expression",		    nuiPCtrlClearExpression());
    nuiMenuItem("Delete Current Key",		    nuiPCtrlDeleteKey());
    nuiMenuItem("Reset All Values",			    nuiResetValues());
  nuiMenuSeparator();
    nuiMenuItem("Clear Tab",			    nuiTweekClear());
    nuiMenuItem("Create Local Variable",	    nuiAddVariable());
    nuiMenuItem("Delete Local Variable",	    nuiDeleteVariable());
    nuiMenuItem("Add Notes",			    nuiAddNotes());
nuiPopMenu();

if(gui.trm==0)
{
    nuiPushMenu("NRiVDeskPopup",1);
	nuiMenuItem("New Viewer (N)",			nuiVDeskMakeNewViewer());
	nuiMenuItem("Delete All Viewers",		nuiVDeskDeleteAllViewers());
    nuiPopMenu();
}

nuiPushMenu("NRiViewCtrlPopup",1);
    nuiPushMenu("Edit   ",0);
	nuiMenuItem("Undo   (Ctrl+Z)",			nuiUndo());
	nuiMenuItem("Redo   (Ctrl+Y )",			nuiRedo());
    nuiPopMenu();
    nuiPushMenu("View  ",0);
	nuiMenuItem("Zoom In   (+)",			nuiVCtrlZoomIn());
	nuiMenuItem("Zoom Out   (-)",			nuiVCtrlZoomOut());
	nuiMenuItem("Reset View    (Home)",		nuiVCtrlResetView());
	nuiMenuItem("Fit Image to Viewer    (F)",	nuiVCtrlFitImageToViewer());
    nuiPopMenu();
    nuiPushMenu("Render  ",0);
	nuiMenuItem("Render Flipbook ",			nuiRenderFlipbook());
	nuiMenuItem("Render FileOut Nodes ",	        nuiRender());
    nuiPopMenu();
    nuiMenuSeparator();
    if(gui.trm==0)
    {
	nuiMenuItem("New Viewer  (N)",			    nuiVCtrlNewViewer());
	nuiMenuItem("Delete Viewer ",			    nuiVCtrlDelViewer());
	nuiMenuItem("Fit Viewer to Desktop (Shift+F)",	    nuiVCtrlFitViewerToDesktop());
	nuiMenuItem("Fit Viewer to Image (Ctrl+F)",	    nuiVCtrlFitViewerToImage());
	nuiMenuItem("Minimize / Restore Viewer (Ctrl+M)",   nuiVCtrlToggleIconify());
    }

    nuiMenuItem("Load Viewer Script Controls into Parameter1 Tab",   nuiVCtrlTweekCurrentVScript(0,0));
    nuiMenuItem("Load Viewer Script Controls into Parameter2 Tab",   nuiVCtrlTweekCurrentVScript(1,0));
    nuiMenuItem("Load Viewer Script Controls into Floating Window",  nuiVCtrlTweekCurrentVScript(0,1));

    nuiPushMenu("View Channel  ",0);
	nuiMenuItem("Color   (C)",			nuiVCtrlRGB());
	nuiMenuItem("Red     (R)",			nuiVCtrlR());
	nuiMenuItem("Green   (G)",			nuiVCtrlG());
	nuiMenuItem("Blue    (B)",			nuiVCtrlB());
	nuiMenuItem("Alpha   (A)",			nuiVCtrlA());
    nuiPopMenu();
nuiPopMenu();

nuiPushMenu("NRiNodeViewPopup",1);
    nuiMenuSeparator();
    nuiPushMenu("Edit ",0);
	nuiMenuItem("Cut (Ctrl+X)",			nuiNodeViewCut());
	nuiMenuItem("Copy (Ctrl+C)",			nuiNodeViewCopy());
	nuiMenuItem("Paste (Ctrl+V)",			nuiNodeViewPaste());
	nuiMenuItem("Paste Linked (Shift+Ctrl+V)",	nuiNodeViewPaste(1));
	nuiMenuItem("Delete (Delete)",			nuiNodeViewDelete());
	nuiMenuSeparator();
	nuiMenuItem("Undo (Ctrl+Z)",			nuiUndo());
	nuiMenuItem("Redo (Ctrl+Y)",			nuiRedo());
    nuiPopMenu();
    nuiPushMenu("View ",0);
	nuiMenuItem("Zoom In (+)",			nuiNodeViewZoomIn());
	nuiMenuItem("Zoom Out (-)",			nuiNodeViewZoomOut());
	nuiMenuItem("Reset View (Home)",		nuiNodeViewCenter());
	nuiMenuItem("Frame Selected (F)",		nuiNodeViewFrame());
    nuiPopMenu();
    nuiPushMenu("Render ",0);
	nuiMenuItem("Render Flipbook",			nuiRenderFlipbook());
	nuiMenuItem("Render FileOut Nodes",	        nuiNodeViewRender());
    nuiPopMenu();
    nuiMenuSeparator();
    nuiMenuItem("Overview (O)",		                nuiNodeViewSwitchRadar(),       nuiNodeViewCheckRadar());
    nuiMenuItem("View Expression Links (Ctrl+E)",	nuiNodeViewSwitchExprLink(),    nuiNodeViewCheckExprLink());
    nuiPushMenu("Select",0);
	nuiMenuItem("Find Nodes (Ctrl+F)",		nuiNodeViewSelectByName());
	nuiMenuItem("All (Ctrl+A)",			nuiNodeViewSelectAll());
	nuiMenuItem("Associated Nodes (Shift+A)",	nuiNodeViewSelectBunch());
	nuiMenuItem("Invert Selection(!)",		nuiNodeViewInvertSelection());
	nuiMenuItem("Upstream Nodes (Shift+U)",		nuiNodeViewSelectUp());
	nuiMenuItem("Downstream Nodes (Shift+D)",	nuiNodeViewSelectDown());
	nuiMenuItem("Upstream 1 Level(Shift+UpArrow)",	nuiNodeViewSelectUpOne());
	nuiMenuItem("Downstream 1 Level (Shift+DownArrow)",nuiNodeViewSelectDownOne());
    nuiPopMenu();
    nuiPushMenu("Node Layout",0);
	nuiMenuItem("Layout Selected (L)",		nuiNodeViewLayout());
	nuiMenuItem("Align Selected Vertically (X)",    nuiNodeViewGridSnap(1));
	nuiMenuItem("Align Selected Horizontally (Y)",  nuiNodeViewGridSnap(0));
    nuiPopMenu();
    nuiMenuItem("Group/Ungroup Selected Nodes (G)",	nuiNodeViewGroup(2));
    nuiMenuItem("Maximize/Minimize Selected Groups (M)",nuiNodeViewOpenGroups(2));
    nuiMenuSeparator();
    nuiMenuItem("Ignore/Unignore Selected Nodes (I)",	nuiNodeViewIgnore(1));
    nuiMenuItem("Extract Selected Nodes (E)",		nuiNodeViewDisconnect());
    nuiMenuItem("Save Selection as script (S)",		nuiNodeViewSaveSelecttedAsNewScript());
    nuiMenuItem("Force Selected FileIn Reload",		nuiNodeViewForceFileInReload(0));
    nuiMenuItem("Force All FileIn Reload",		nuiNodeViewForceFileInReload(1));

    nuiPushMenu("Macro",0);
	nuiMenuItem("Make Macro (Shift+M)",		nuiNodeViewMakeMacro());
	nuiMenuItem("Show Macro Internals (B)",		nuiNodeViewMacroBodies(0));
	nuiMenuItem("Hide Macro Internals (Alt+B)",	nuiNodeViewMacroBodies(1));
    nuiPopMenu();
nuiPopMenu();

nuiPushMenu("NRiFxButtonPopup",1);
    nuiMenuItem("Insert (Regular Click)",	    nuiToolBoxDoInsert());
    nuiMenuItem("Branch (Shift+Click)",		    nuiToolBoxDoBranch());
    nuiMenuItem("Replace (Ctrl+Click)",		    nuiToolBoxDoReplace());
    nuiMenuItem("Create (Shift+Ctrl+Click)",	    nuiToolBoxDoCreate());
//    nuiMenuItem("Layer",			    nuiToolBoxDoLayer("Layer(Move3D(ColorCorrect(Hook)),0,\\\"Over\\\",1,0,0)"));
//    nuiPushMenu("More layers",0);
//	nuiMenuItem("Simple",			    nuiToolBoxDoLayer("Layer(Hook,0,\\\"Over\\\",1,0,0)"));
//	nuiMenuItem("Move",			    nuiToolBoxDoLayer("Layer(Move3D(Hook),0,\\\"Over\\\",1,0,0)"));
//	nuiMenuItem("Move + Color Correct",	    nuiToolBoxDoLayer("Layer(Move3D(ColorCorrect(Hook)),0,\\\"Over\\\",1,0,0)"));
    nuiPopMenu();
nuiPopMenu();

nuiPushMenu("NRiCEViewPopup",1);
    nuiPushMenu("Edit ",0);
	nuiMenuItem("Undo (Ctrl+Z)",			nuiUndo());
	nuiMenuItem("Redo (Ctrl+Y)",			nuiRedo());
    nuiPopMenu();
    nuiPushMenu("View ",0);
	nuiMenuItem("Zoom In (+)",			nuiCurveEditorZoomIn());
	nuiMenuItem("Zoom Out (-)",			nuiCurveEditorZoomOut());
	nuiMenuItem("Reset View (Home)",		nuiCurveEditorFrameAll());
	nuiMenuItem("Frame Selected (F)",		nuiCurveEditorFrameSelectedCurves());
	nuiMenuItem("Frame Selected CVs (Shift+F)",	nuiCurveEditorFrameSelectedCVs());
    nuiPopMenu();
    nuiPushMenu("Render ",0);
	nuiMenuItem("Render Flipbook",			nuiRenderFlipbook());
	nuiMenuItem("Render FileOut Nodes",	        nuiRender());
    nuiPopMenu();
    nuiMenuSeparator();
    nuiMenuItem("Add All Curves",			nuiCurveEditorAddAllCurves());
    nuiMenuItem("Remove Curves (BackSpace)",		nuiCurveEditorRemoveCurves());
    nuiPushMenu("Visibility ",0);
	nuiMenuItem("Hide Curves",			nuiCurveEditorHideCurves());
	nuiMenuItem("Show Curves",			nuiCurveEditorShowCurves());
	nuiMenuItem("Toggle Visiblity",			nuiCurveEditorToggleVisiblity());
    nuiPopMenu();
    nuiPushMenu("Select ",0);
	nuiMenuItem("Select All Curves (Ctrl+A)",	nuiCurveEditorSelectAllCurves());
	nuiMenuItem("Select CVs (Shift+A)",		nuiCurveEditorSelectCVs());
    nuiPopMenu();
//    nuiPushMenu("Smooth Curves ",0);
//        nuiMenuItem("Smooth Selected Curve",            nuiCurveEditorSmoothCurve());
//	nuiMenuItem("Edit smoothing function",          nuiCurveEditorEditSmoothingFunction());
//    nuiPopMenu();
    nuiMenuSeparator();
    nuiMenuItem("Display Timecode (T)",                 nuiCurveEditorToggleTimeCode(),     nuiCurveEditorCheckTimeCode());
    nuiMenuItem("Sticky Time (S)",                      nuiCurveEditorToggleStickyTime(),   nuiCurveEditorCheckStickyTime());
    nuiMenuItem("Time Snap",		                nuiCurveEditorToggleTimeSnap(),     nuiCurveEditorCheckTimeSnap());
    nuiMenuItem("Display Selected Info",                nuiCurveEditorToggleInfoDisplay(),  nuiCurveEditorCheckInfoDisplay());
nuiPopMenu();

nuiPushMenu("curveLockTogglePopup",1);
    nuiMenuItem("No Lock",			    nuiCEViewNoLock(),  nuiCEViewChkNoLock());
    nuiMenuItem("XLock",			    nuiCEViewXLock(),   nuiCEViewChkXLock());
    nuiMenuItem("YLock",			    nuiCEViewYLock(),   nuiCEViewChkYLock());
nuiPopMenu();

nuiPushMenu("ImportCurvesPopup",1);
    nuiMenuItem("Import Curves Visible",	    nuiCEImportCurvesV());
    nuiMenuItem("Import Curves Hidden",		    nuiCEImportCurvesH());
nuiPopMenu();

nuiPushMenu("ViewCtrlChannelPopup",1);
    nuiMenuItem("Color (C)",			    nuiVCtrlTglRGB(),       nuiVCtrlChkRGB());
    nuiMenuItem("Red (R)",			    nuiVCtrlTglR(),         nuiVCtrlChkR());
    nuiMenuItem("Green (G)",			    nuiVCtrlTglG(),         nuiVCtrlChkG());
    nuiMenuItem("Blue (B)",			    nuiVCtrlTglB(),         nuiVCtrlChkB());
    nuiMenuItem("Alpha (A)",			    nuiVCtrlTglA(),         nuiVCtrlChkA());
nuiPopMenu();

nuiPushMenu("ViewCtrlUpdatePopup",1);
    nuiMenuItem("Update Off",			    nuiVCtrlTglUdOff(),     nuiVCtrlChkUdOff());
    nuiMenuItem("Update On",			    nuiVCtrlTglUdOn(),      nuiVCtrlChkUdOn());
    nuiMenuItem("Progress",			    nuiVCtrlTglUdProg(),    nuiVCtrlChkUdProg());
nuiPopMenu();

nuiPushMenu("ViewCtrlViewerScriptPopup",1);
    nuiMenuItem("No Viewer Script",		    nuiVCtrlTglVS0(),       nuiVCtrlChkVS0());
    nuiMenuItem("Viewer Script 1",		    nuiVCtrlTglVS1(),       nuiVCtrlChkVS1());
    nuiMenuItem("Viewer Script 2",		    nuiVCtrlTglVS2(),       nuiVCtrlChkVS2());
    nuiMenuItem("Viewer Script 3",		    nuiVCtrlTglVS3(),       nuiVCtrlChkVS3());
    nuiMenuSeparator();
    nuiMenuItem("Load Viewer Script Controls into Parameter1 Tab",   nuiVCtrlTweekCurrentVScript(0,0));
    nuiMenuItem("Load Viewer Script Controls into Parameter2 Tab",   nuiVCtrlTweekCurrentVScript(1,0));
    nuiMenuItem("Load Viewer Script Controls into Floating Window",  nuiVCtrlTweekCurrentVScript(0,1));
nuiPopMenu();

nuiPushMenu("ViewCtrlComparePopup",1);
    nuiMenuItem("No Compare",			    nuiVCtrlTglNoCmp(),     nuiVCtrlChkNoCmp());
    nuiMenuItem("X Wipe",			    nuiVCtrlTglXWipe(),     nuiVCtrlChkXWipe());
    nuiMenuItem("Y Wipe",			    nuiVCtrlTglYWipe(),     nuiVCtrlChkYWipe());
    nuiMenuItem("Blend",			    nuiVCtrlTglBlend(),     nuiVCtrlChkBlend());
nuiPopMenu();

nuiPushMenu("ViewCtrlShuttlePopup",1);
    nuiMenuItem("  0%",				    nuiVCtrlTglSh000());
    nuiMenuItem(" 25%",				    nuiVCtrlTglSh025());
    nuiMenuItem(" 50%",				    nuiVCtrlTglSh050());
    nuiMenuItem(" 75%",				    nuiVCtrlTglSh075());
    nuiMenuItem("100%",				    nuiVCtrlTglSh100());
nuiPopMenu();

nuiPushMenu("ViewCtrlDodPopup",1);
    nuiMenuItem("Show Bounding Boxes",		    nuiVCtrlTglShowBB(),    nuiVCtrlChkShowBB());
    nuiMenuItem("Hide Bounding Boxes",		    nuiVCtrlTglHideBB(),    nuiVCtrlChkHideBB());
nuiPopMenu();

nuiPushMenu("ViewCtrlOSCTogglePopup",1);
    nuiMenuItem("Hide On-Screen Ctrls",		    nuiVCtrlTglHideOSC(),   nuiVCtrlChkHideOSC());
    nuiMenuItem("Show On-Screen Ctrls",		    nuiVCtrlTglShowOSC(),   nuiVCtrlChkShowOSC());
    nuiMenuItem("Show On-Screen Ctrls On Release",  nuiVCtrlTglShowOSCR(),  nuiVCtrlChkShowOSCR());
nuiPopMenu();

nuiPushMenu("ViewCtrlOSCAutoKeyPopup",1);
    nuiMenuItem("On-Screen Ctrl Auto Key Off",	    nuiVCtrlTglAutoKeyOn(),     nuiVCtrlChkAutoKeyOn());
    nuiMenuItem("On-Screen Ctrl Auto Key On",	    nuiVCtrlTglAutoKeyOff(),    nuiVCtrlChkAutoKeyOff());
nuiPopMenu();

nuiPushMenu("ViewCtrlOSCDelKeyPopup",1);
    nuiMenuItem("Delete Key",           	    nuiVCtrlDelKey());
    nuiMenuItem("Delete All Keys",	            nuiVCtrlDelAllKeys());
nuiPopMenu();

nuiPushMenu("NRiTreeViewPopup",1);
    nuiMenuItem("Copy Group (Ctrl+C)",		    nuiTreeViewCopy());
    nuiMenuItem("Paste Group (Ctrl+V)",		    nuiTreeViewPaste());
    nuiMenuSeparator();
    nuiMenuItem("Delete Current Key",		    nuiPCtrlDeleteKey());
    nuiMenuItem("Reset All Values",			    nuiResetValues());
 nuiMenuSeparator();
    nuiMenuItem("Clear Tab",			    nuiTweekClear());
    nuiMenuItem("Create Local Variable",	    nuiAddVariable());
    nuiMenuItem("Delete Local Variable",	    nuiDeleteVariable());
   nuiMenuItem("Add Notes",			    nuiAddNotes());
nuiPopMenu();

nuiPushMenu("NRiTVWorkSpacePopup",1);
    nuiMenuItem("InOut Point Display",	        nuiTVToggleInOutPntDisplay(),   nuiTVCheckInOutPntDisplay());
    nuiMenuItem("Const Point Display",	        nuiTVToggleConstPntDisplay(),   nuiTVCheckConstPntDisplay());
    nuiMenuItem("FileIn Trim",		        nuiTVToggleTrim(),              nuiTVCheckTrim());
nuiPopMenu();

nuiPushMenu("NRiTweekWinPopup",1);
    nuiMenuItem("Clear Tab",			    nuiTweekClear());
    nuiMenuItem("Create Local Variable",	    nuiAddVariable());
    nuiMenuItem("Delete Local Variable",	    nuiDeleteVariable());
    nuiMenuItem("Add Notes",			    nuiAddNotes());
    nuiMenuItem("Reset All Values",			    nuiResetValues());
nuiPopMenu();

nuiPushControlGroup("IDiv and IMult Control");
	nuiGroupControl("LayerMacro.ignoreZero");
nuiPopControlGroup(); 

nuiPushControlGroup("Over Control");
	nuiGroupControl("LayerMacro.addMattes");
nuiPopControlGroup(); 

nuiPushControlGroup("Xor Control");
	nuiGroupControl("LayerMacro.useMatte");
nuiPopControlGroup(); 


nuiPushControlGroup("format");
	nuiGroupControl("framesPerSecond");
	nuiGroupControl("dropFrame");
	nuiGroupControl("defaultWidth");
	nuiGroupControl("defaultHeight");
	nuiGroupControl("defaultAspect");
	nuiGroupControl("defaultViewerAspectRatio");
nuiPopControlGroup(); 
nuxDefRadioBtnCtrl("framesPerSecond",0, 1, 0,
		   "24|Film",
		   "29.97|NTSC", 
		   "25|PAL"
		   );

nuxDefRadioBtnCtrl("dropFrame",0, 1, 0,
		   "0|off",
		   "1|on"
		   );
nuxDefRadioBtnCtrl("viewerAspectRatio",0, 1, 0,
		   "script.defaultViewerAspectRatio|formatDefault",
		   "|custom"
		   );

nuxDefRadioBtnCtrl(
    "Stat.type",
    0,
    1,
    1,
    "0|Min",
    "1|Max",
    "2|Average",
    "3|Custom"
);

// To define slider ranges for parameters use:
// nuiDefSlider("parameter", min, max, granularity, notchSpacing);
//
// Granularity:
//	It must be of power of 10
//	If granularity==0, no snap is performed on the raw slider value
//	If granularity=10, slider will hard snap to multiples of 10
//	If granularity=0.001, slider will hard snap to multiples of 0.001
//
// NotchSpacing:
//	It is not a hard snap, i.e. you can still slide to values that are not multiples of notchSpacing.
//	NotchSpacing defines values of special interest, i.e. values the slider sticks longer to,
//      thus making them easier to select.
// 
nuiDefSlider("angle",		    -360,	360, 0.1, 10);
nuiDefSlider("aspectRatio",	    0,		2, 0, 0.1);
nuiDefSlider("bytes",		    1,		4);
nuiDefSlider("cacheMode",	    0,		2);
nuiDefSlider("chromaRange",	    0,		110, 1);
nuiDefSlider("compositeRange",	    0,		110, 1);
nuiDefSlider("cropBottom",	    -height,	2*height);
nuiDefSlider("cropLeft",	    -width,	2*width);
nuiDefSlider("cropRight",	    -width,	2*width);
nuiDefSlider("cropTop",		    -height,	2*height);
nuiDefSlider("defaultHeight",       0,          4096,1, 1, 1);
nuiDefSlider("defaultWidth",        0,          4096,1, 1, 1);
nuiDefSlider("defaultAspect",       0,          2);
nuiDefSlider("fieldOfView",	    0,		180);
nuiDefSlider("first",		    0,		100);
nuiDefSlider("framesPerSecond",	    1,		30, 1);
nuiDefSlider("height",		    1,		GetDefaultHeight());
nuiDefSlider("kerning",	            -1000,	1000, 1, 100);
nuiDefSlider("last",		    0,		100);
nuiDefSlider("maskPercent",	    0,		100, 0.1, 10);
nuiDefSlider("maxThread",	    0,		nrcGetAvailableProcessors());
nuiDefSlider("percent",		    0,		100, 0.1, 10);
nuiDefSlider("pixelScale",	    0,		5, 0.1);
nuiDefSlider("pixelRatio",	    0,		2, 0.1);
nuiDefSlider("radius",		    0,		width, 1);
nuiDefSlider("refFrame",         -inf,          inf,   1);
nuiDefSlider("seed",		    0,		100);
nuiDefSlider("shutterTiming",	    0,		2, 0.01, 0.25);
nuiDefSlider("shutterOffset",	    -1,		1, 0.01);
nuiDefSlider("steps",               0,          5);
nuiDefSlider("time",		    1,		100, 1);
nuiDefSlider("x",                   0,          width);
nuiDefSlider("y",                   0,          height);
nuiDefSlider("trackCenterX",        0,          width);
nuiDefSlider("trackCenterY",        0,          height);
nuiDefSlider("trackLeft",           0,          width);
nuiDefSlider("trackRight",          0,          width);
nuiDefSlider("trackBottom",         0,          height);
nuiDefSlider("trackTop",            0,          height);
nuiDefSlider("trackLeftSearch",     0,          width);
nuiDefSlider("trackRightSearch",    0,          width);
nuiDefSlider("trackBottomSearch",   0,          height);
nuiDefSlider("trackTopSearch",      0,          height);
nuiDefSlider("updateMode",	    0,		2);
nuiDefSlider("viewerAspectRatio",   0,		4, 0.1);
nuiDefSlider("virtualSliderSpeed",  0,          1, 0.01,0.1,3);
nuiDefSlider("width",		    1,		GetDefaultWidth());
nuiDefSlider("xAlign",		    0,		3);
nuiDefSlider("xAngle",		    -360,	360, 0.1, 10);
nuiDefSlider("xCenter",		    0,		width, 1);
nuiDefSlider("xDelta",		    0,		20);
nuiDefSlider("xFontScale",	    0,		200);
nuiDefSlider("xPan",		    -width,	width, 1);
nuiDefSlider("xPercent",	    0,		100);
nuiDefSlider("xPixels",		    0,		200, 0.1, 10);
nuiDefSlider("xPos",		    -width,	width, 1);
nuiDefSlider("xScale",		    0,		4);
nuiDefSlider("xScroll",		    -width,	width, 1);
nuiDefSlider("xShear",		    0,		1);
nuiDefSlider("yAlign",		    0,		3);
nuiDefSlider("yAngle",		    -360,	360, 0.1, 10);
nuiDefSlider("yCenter",		    0,		height, 1);
nuiDefSlider("yDelta",		    0,		20);
nuiDefSlider("yFontScale",	    0,		200);
nuiDefSlider("yPan",		    -height,	height, 1);
nuiDefSlider("yPercent",	    0,		100);
nuiDefSlider("yPixels",		    0,		200, 0.1, 10);
nuiDefSlider("yPos",		    -height,	height, 1);
nuiDefSlider("yScale",		    0,		4);
nuiDefSlider("yScroll",		    -height,	height, 1);
nuiDefSlider("yShear",		    0,		1);
nuiDefSlider("zAngle",		    -360,	360, 0.1, 10);
nuiDefSlider("zCenter",		    0,		width, 1);
nuiDefSlider("zPan",		    -width,	width, 1);
nuiDefSlider("zPos",		    -height,	height, 1);

// In/Out
nuiDefSlider("Average.sStart",		0,		100	);
nuiDefSlider("Average.sEnd",		0,		100	);
nuiDefSlider("Average.dStart",		0,		100	);
nuiDefSlider("Average.dEnd",		0,		100	);
nuiDefSlider("Average.gain",		0,		2	);
nuiDefSlider("Average.scale",		0,		2	);
nuiDefSlider("Checker.xSize",		1,		width );
nuiDefSlider("Checker.ySize",		1,		height );
nuiDefSlider("PullDown.offset",		0,		4	);
nuiDefSlider("PullUp.offset",		-1,		4	);
nuiDefSlider("RGrad.falloffRadius",	0,		width	);
nuiDefSlider("Text.leading",		0,		3);
nuiDefSlider("ZonePlate.centerX",	0,		720);
nuiDefSlider("ZonePlate.centerY",	0,		486);
nuiDefSlider("ZonePlate.variance",	1,		4);
nuiDefSlider("ZonePlate.offset",	0,		360);

// Color
nuiDefSlider("Add.red",			-1,		1);
nuiDefSlider("Add.green",		-1,		1);
nuiDefSlider("Add.blue",		-1,		1);
nuiDefSlider("Add.alpha",		-1,		1);
nuiDefSlider("Add.depth",		-1,		1);
nuiDefSlider("AdjustHSV.hueSharpness",	0,		3);
nuiDefSlider("AdjustHSV.satSharpness",	0,		3);
nuiDefSlider("AdjustHSV.valSharpness",	0,		3);
nuiDefSlider("AdjustHSV.hueOffset",    -1,		1);
nuiDefSlider("AdjustHSV.satOffset",    -1,		1);
nuiDefSlider("AdjustHSV.valOffset",    -1,		1);
nuiDefSlider("Brightness.value",	0,		5);
nuiDefSlider("ContrastLum.value",	0,		10);
nuiDefSlider("ContrastRGB.rValue",	0,		10);
nuiDefSlider("ContrastRGB.bValue",	0,		10);
nuiDefSlider("ContrastRGB.gValue",	0,		10);
nuiDefSlider("DelogC.rOffset",		-180,		180, 1);
nuiDefSlider("DelogC.gOffset",		-180,		180, 1);
nuiDefSlider("DelogC.bOffset",		-180,		180, 1);
nuiDefSlider("DelogC.black",		0,		1023, 1);
nuiDefSlider("DelogC.white",		0,		1023, 1);
nuiDefSlider("DelogC.nGamma",		0,		2.2);
nuiDefSlider("DelogC.dGamma",		0,		2.2);
nuiDefSlider("DelogC.softClip",		0,		50, 1);
nuiDefSlider("DelogRGB.rOffset",	-180,		180, 1);
nuiDefSlider("DelogRGB.gOffset",	-180,		180, 1);
nuiDefSlider("DelogRGB.bOffset",	-180,		180, 1);
nuiDefSlider("DelogRGB.rBlack",		0,		1023, 1);
nuiDefSlider("DelogRGB.gBlack",		0,		1023, 1);
nuiDefSlider("DelogRGB.bBlack",		0,		1023, 1);
nuiDefSlider("DelogRGB.rWhite",		0,		1023, 1);
nuiDefSlider("DelogRGB.gWhite",		0,		1023, 1);
nuiDefSlider("DelogRGB.bWhite",		0,		1023, 1);
nuiDefSlider("DelogRGB.rNGamma",	0,		2.2);
nuiDefSlider("DelogRGB.gNGamma",	0,		2.2);
nuiDefSlider("DelogRGB.bNGamma",	0,		2.2);
nuiDefSlider("DelogRGB.rDGamma",	0,		2.2);
nuiDefSlider("DelogRGB.gDGamma",	0,		2.2);
nuiDefSlider("DelogRGB.bDGamma",	0,		2.2);
nuiDefSlider("DelogRGB.rSoftClip",	0,		50, 1);
nuiDefSlider("DelogRGB.gSoftClip",	0,		50, 1);
nuiDefSlider("DelogRGB.bSoftClip",	0,		50, 1);
nuiDefSlider("Gamma.rGamma",		0,		4   );
nuiDefSlider("Gamma.gGamma",		0,		4   );
nuiDefSlider("Gamma.bGamma",		0,		4   );
nuiDefSlider("Gamma.aGamma",		0,		4   );
nuiDefSlider("LogC.rOffset",		-180,		180, 1);
nuiDefSlider("LogC.gOffset",		-180,		180, 1);
nuiDefSlider("LogC.bOffset",		-180,		180);
nuiDefSlider("LogC.black",		0,		1023, 1);
nuiDefSlider("LogC.white",		0,		1023, 1);
nuiDefSlider("LogC.nGamma",		0,		2.2);
nuiDefSlider("LogC.dGamma",		0,		2.2);
nuiDefSlider("LogC.softClip",		0,		50, 1);
nuiDefSlider("LogLin.rOffset",-180,180,1);
nuiDefSlider("LogLin.gOffset",-180,180,1);
nuiDefSlider("LogLin.bOffset",-180,180,1);
nuiDefSlider("LogLin.rBlack",0,1023,1);
nuiDefSlider("LogLin.gBlack",0,1023,1);
nuiDefSlider("LogLin.bBlack",0,1023,1);
nuiDefSlider("LogLin.rWhite",0,1023,1);
nuiDefSlider("LogLin.gWhite",0,1023,1);
nuiDefSlider("LogLin.bWhite",0,1023,1);
nuiDefSlider("LogLin.rNGamma",0,2.2,0);
nuiDefSlider("LogLin.gNGamma",0,2.2,0);
nuiDefSlider("LogLin.bNGamma",0,2.2,0);
nuiDefSlider("LogLin.rDGamma",0,2.2,0);
nuiDefSlider("LogLin.gDGamma",0,2.2,0);
nuiDefSlider("LogLin.bDGamma",0,2.2,0);
nuiDefSlider("LogLin.rSoftClip",0,50,1);
nuiDefSlider("LogLin.gSoftClip",0,50,1);
nuiDefSlider("LogLin.bSoftClip",0,50,1);
nuiDefSlider("LogRGB.rOffset",		-180,		180, 1);
nuiDefSlider("LogRGB.gOffset",		-180,		180, 1);
nuiDefSlider("LogRGB.bOffset",		-180,		180, 1);
nuiDefSlider("LogRGB.rBlack",		0,		1023, 1);
nuiDefSlider("LogRGB.gBlack",		0,		1023, 1);
nuiDefSlider("LogRGB.bBlack",		0,		1023, 1);
nuiDefSlider("LogRGB.rWhite",		0,		1023, 1);
nuiDefSlider("LogRGB.gWhite",		0,		1023, 1);
nuiDefSlider("LogRGB.bWhite",		0,		1023, 1);
nuiDefSlider("LogRGB.rNGamma",		0,		2.2);
nuiDefSlider("LogRGB.gNGamma",		0,		2.2);
nuiDefSlider("LogRGB.bNGamma",		0,		2.2);
nuiDefSlider("LogRGB.rDGamma",		0,		2.2);
nuiDefSlider("LogRGB.gDGamma",		0,		2.2);
nuiDefSlider("LogRGB.bDGamma",		0,		2.2);
nuiDefSlider("LogRGB.rSoftClip",	0,		50, 1);
nuiDefSlider("LogRGB.gSoftClip",	0,		50, 1);
nuiDefSlider("LogRGB.bSoftClip",	0,		50, 1);

nuiDefSlider("Mult.red",		0,		3);
nuiDefSlider("Mult.green",		0,		3);
nuiDefSlider("Mult.blue",		0,		3);
nuiDefSlider("Mult.alpha",		0,		3);
nuiDefSlider("Mult.depth",		0,		3);
nuiDefSlider("Saturation.value",	0,		3);
nuiDefSlider("VideoSafe.videoGamma",	0,		3);

// Filter
nuiDefSlider("Defocus.xPixels",          0,             201     );
nuiDefSlider("Defocus.yPixels",          0,             201     );
nuiDefSlider("Defocus.boostPoint",      0,              1       );
nuiDefSlider("Defocus.superWhite",      1,              20       );
nuiDefSlider("ZBlur.amount",	        0,		20	);
nuiDefSlider("DilateErode.xPixels",	-5,		5);
nuiDefSlider("DilateErode.yPixels",	-5,		5);
nuiDefSlider("DilateErode.sharpness",	0,		3);
nuiDefSlider("Emboss.gain",		0,		100);
nuiDefSlider("Emboss.azimuth",		0,		360, 0.1, 10);
nuiDefSlider("Emboss.elevation",	0,		360, 0.1, 10);
nuiDefSlider("Grain.filmResponse",	-1,		1);
nuiDefSlider("Grain.size",	    	0.2,		5);
nuiDefSlider("Grain.rSize",	    	0,		5);
nuiDefSlider("Grain.gSize",	    	0,		5);
nuiDefSlider("Grain.bSize",	    	0,		5);
nuiDefSlider("Grain.rBias",     	-0.5,		0.5);
nuiDefSlider("Grain.rLowOffset",    	-1,		0.5);
nuiDefSlider("Grain.rHighOffset",    	-0.5,		1);
nuiDefSlider("Grain.gBias",     	-0.5,		0.5);
nuiDefSlider("Grain.gLowOffset",    	-1,		0.5);
nuiDefSlider("Grain.gHighOffset",    	-0.5,		1);
nuiDefSlider("Grain.bBias",     	-0.5,		0.5);
nuiDefSlider("Grain.bLowOffset",    	-1,		0.5);
nuiDefSlider("Grain.bHighOffset",    	-0.5,		1);
nuiDefSlider("Grain.softness",	    	-5,		5);
nuiDefSlider("Grain.rSoftness",	    	-5,		5);
nuiDefSlider("Grain.gSoftness",	    	-5,		5);
nuiDefSlider("Grain.bSoftness",	    	-5,		5);
nuiDefSlider("Grain.rDensity",	    	0,		5);
nuiDefSlider("Grain.gDensity",	    	0,		5);
nuiDefSlider("Grain.bDensity",	    	0,		5);
nuiDefSlider("IDefocus.xPixels",          0,             201     );
nuiDefSlider("IDefocus.yPixels",          0,             201     );
nuiDefSlider("IDefocus.boostPoint",      0,              1       );
nuiDefSlider("IDefocus.superWhite",      1,              20       );
nuiDefSlider("IDilateErode.xPixels",	-5,		5);
nuiDefSlider("IDilateErode.yPixels",	-5,		5);
nuiDefSlider("IDilateErode.sharpness",	0,		3);
nuiDefSlider("RBlur.xCenter",		0,		width	);
nuiDefSlider("RBlur.yCenter",		0,		height	);
nuiDefSlider("RBlur.iRadius",		0,		width/2	);
nuiDefSlider("RBlur.oRadius",		0,		width/2	);
nuiDefSlider("RBlur.amplitude",		0,		2	);
nuiDefSlider("RBlur.quality",		0,		1	);
nuiDefSlider("VBlur.maxBlur",		0,		20	);
nuiDefSlider("VBlur.regions",		2,		6	);
nuiDefSlider("ZDefocus.xPixels",          0,             201     );
nuiDefSlider("ZDefocus.yPixels",          0,             201     );
nuiDefSlider("ZDefocus.boostPoint",      0,              1       );
nuiDefSlider("ZDefocus.superWhite",      1,              20       );

// Keying
nuiDefSlider("BSRemove.rGain",		0,		2	);
nuiDefSlider("BSRemove.gGain",		0,		2	);
nuiDefSlider("ChromaKey.hueRange",	0,		1, .001, .001	);
nuiDefSlider("ChromaKey.hueFalloff",	0,		1, .001, .001	);
nuiDefSlider("ChromaKey.satRange",	0,		1, .001, .001	);
nuiDefSlider("ChromaKey.satFalloff",	0,		1, .001, .001	);
nuiDefSlider("ChromaKey.valRange",	0,		1, .001, .001	);
nuiDefSlider("ChromaKey.valFalloff",	0,		1, .001, .001	);
nuiDefSlider("SpillSuppress.rGain",	0,		2	);
nuiDefSlider("SpillSuppress.gGain",	0,		2	);
nuiDefSlider("SpillSuppress.lumGain",	0,		2	);

// Layer
nuiDefSlider("Constraint.type",		0,		15	);
nuiDefSlider("Constraint.left",		0,		width );
nuiDefSlider("Constraint.right",	0,		width );
nuiDefSlider("Constraint.bottom",	0,		height );
nuiDefSlider("Constraint.top",		0,		height );
nuiDefSlider("AddText.leading",		0,		3);
nuiDefSlider("AddText.xScale",		0,		100);
nuiDefSlider("AddText.yScale",		0,		100);
nuiDefSlider("LayerMacro.fgOpacity",		0,		100);
nuiDefSlider("LayerMacro.bgPercent",	0,		100 );

// Time
nuiDefSlider("Repeat.repetitions",	0,		24 );
nuiDefSlider("Sequence2.cut",		0,		100 );
nuiDefSlider("Sequence3.cut1",	    	0,		100 );
nuiDefSlider("Sequence3.cut2",		0,		100 );
nuiDefSlider("TimeSlide.oldStart",	0,		100 );
nuiDefSlider("TimeSlide.newStart",	0,		100 );
nuiDefSlider("TimeX.newTime",           0,              100 );
nuiDefSlider("TimeX.newInPoint",        0,              100 );
nuiDefSlider("TimeX.newOutPoint",       0,              100 );
nuiDefSlider("startFrame",           -inf,              inf, 1 );
nuiDefSlider("endFrame",             -inf,              inf, 1 );
nuiDefSlider("inPoint",              -inf,              inf, 1 );
nuiDefSlider("outPoint",             -inf,              inf, 1 );
nuiDefSlider("firstFrame",           -inf,              inf, 1 );
nuiDefSlider("lastFrame",            -inf,              inf, 1 );
nuiDefSlider("increment",            0,			5,   0.1 );
nuiDefSlider("timeShift",            -inf,              inf, 1 );

// Transform
nuiDefSlider("CameraShake.xFrequency",	0,		5 );
nuiDefSlider("CameraShake.yFrequency",	0,		5 );
nuiDefSlider("CameraShake.xAmplitude",	0,		20 );
nuiDefSlider("CameraShake.yAmplitude",	0,		20 );
nuiDefSlider("CornerPin.x0",		0,		width);
nuiDefSlider("CornerPin.y0",		0,		height);
nuiDefSlider("CornerPin.x1",		0,		width);
nuiDefSlider("CornerPin.y1",		0,		height);
nuiDefSlider("CornerPin.x2",		0,		width);
nuiDefSlider("CornerPin.y2",		0,		height);
nuiDefSlider("CornerPin.x3",		0,		width);
nuiDefSlider("CornerPin.y3",		0,		height);
nuiDefSlider("CornerPin.antialiasing",	0,		1);
nuiDefSlider("Fit.xSize",		0,		width);
nuiDefSlider("Fit.ySize",		0,		height);
nuiDefSlider("Move2D.referenceFrame",	0,		100);
nuiDefSlider("Orient.nTurn",		0,		3);
nuiDefSlider("Resize.xSize",		0,		width, 1);
nuiDefSlider("Resize.ySize",		0,		height, 1);
nuiDefSlider("SetDOD.left",		-100,		width);
nuiDefSlider("SetDOD.right",		0,		width+100);
nuiDefSlider("SetDOD.bottom",		-100,		height);
nuiDefSlider("SetDOD.top",		0,		height+100);
nuiDefSlider("Window.xRes",		0,		width);
nuiDefSlider("Window.yRes",		0,		height);

// Warp
nuiDefSlider("PinCushion.xFactor",	-2, 2);
nuiDefSlider("PinCushion.yFactor",	-2,	2);
nuiDefSlider("Randomize.xAmplitude",	0,		10);
nuiDefSlider("Randomize.yAmplitude",	0,		10);
nuiDefSlider("Randomize.xOffset",	0,		10);
nuiDefSlider("Randomize.yOffset",	0,		10);
nuiDefSlider("Turbulate.xAmplitude",	0,		10);
nuiDefSlider("Turbulate.yAmplitude",	0,		10);
nuiDefSlider("Turbulate.xOffset",	0,		10);
nuiDefSlider("Turbulate.yOffset",	0,		10);
nuiDefSlider("Turbulate.detail",	0,		10);
nuiDefSlider("Twirl.startAngle",	-360,		360);
nuiDefSlider("Twirl.endAngle",		-360,		360);
nuiDefSlider("Twirl.xRadius",		0,		width);
nuiDefSlider("Twirl.yRadius",		0,		height);
nuiDefSlider("Twirl.bias",		-4,		4);
nuiDefSlider("WarpX.xDelta",		1,		10);
nuiDefSlider("WarpX.yDelta",		1,		10);
nuiDefSlider("IDisplace.xScale",         0,              400);
nuiDefSlider("IDisplace.yScale",         0,              400);

// Other
nuiDefSlider("AddBorders.xBorder",	0,		100);
nuiDefSlider("AddBorders.yBorder",	0,		100);
nuiDefSlider("AddShadow.xOffset",	-100,		100,	1);
nuiDefSlider("AddShadow.yOffset",	-100,		100,	1);
nuiDefSlider("AddShadow.fuzziness",	0,		100);
nuiDefSlider("AddShadow.opacity",	0,		1);
nuiDefSlider("DropShadow.fuzziness",	0,		100);
nuiDefSlider("DropShadow.opacity",	0,		1);
nuiDefSlider("PlotScanline.line",	0,		height);
nuiDefSlider("Select.branch",		1,		4);
nuiDefSlider("Tile.nXTile",		1,		10);
nuiDefSlider("Tile.nYTile",		1,		10);
nuiDefSlider("smoothValue",             1,              11);
nuiDefSlider("Transition.blur",		0,              400);
nuiDefSlider("Transition.overlap",      0,              200);
nuxDefExprToggle("HWipe.reverse"); 
nuxDefExprToggle("VWipe.reverse"); 
 
// 
// Tremor-style column layout 
//

//Globals Tab
nuiDefTweakerNumCol("NRiScript",5);
nuiDefPCtrlLoc("NRiScript.time",1);
nuiDefPCtrlLoc("NRiScript.timeRange",1);
nuiDefPCtrlLoc("NRiScript.timecodeMode",1);
nuiDefPCtrlLoc("NRiScript.proxyScale",3);
nuiDefPCtrlLoc("NRiScript.interactiveScale",3);
nuiDefPCtrlLoc("NRiScript.viewerAspectRatio",3);
nuiDefPCtrlLoc("NRiScript.defaultBytes",3);
nuiDefPCtrlLoc("NRiScript.quality",5);
nuiDefPCtrlLoc("NRiScript.motionBlur",1);
nuiDefPCtrlLoc("NRiScript.cacheMode",5);
nuiDefPCtrlLoc("NRiScript.format",3);
nuiDefPCtrlLoc("NRiScript.fieldRendering",3);
nuiDefPCtrlLoc("NRiScript.maxThread",5);
nuiDefPCtrlLoc("NRiScript.project",3);
nuiDefPCtrlLoc("NRiScript.virtualSliderSpeed",5);
nuiDefPCtrlLoc("NRiScript.virtualSliderMode",5);
nuiDefPCtrlLoc("NRiScript.viewerZoom",3);
nuiDefPCtrlLoc("NRiScript.fontRed",3);
nuiDefPCtrlLoc("NRiScript.fontGreen",3);
nuiDefPCtrlLoc("NRiScript.fontBlue",3);
nuiDefPCtrlLoc("NRiScript.noodleRed",3);
nuiDefPCtrlLoc("NRiScript.noodleGreen",3);
nuiDefPCtrlLoc("NRiScript.noodleBlue",3);
nuiDefPCtrlLoc("NRiScript.noodleTension",3);



nuiDefTweakerCol("NRiScript",1,"Time",8,275,300);
nuiDefTweakerCol("NRiScript",2,"",8,30);
nuiDefTweakerCol("NRiScript",3,"Format",8,445);
nuiDefTweakerCol("NRiScript",4,"",8,30);
nuiDefTweakerCol("NRiScript",5,"Controls",8,320);


//Average
nuiDefTweakerNumCol("Average",6);
nuiDefPCtrlLoc("Average.imageName",2);
nuiDefPCtrlLoc("Average.sStart",4);
nuiDefPCtrlLoc("Average.sEnd",4);
nuiDefPCtrlLoc("Average.dStart",4);
nuiDefPCtrlLoc("Average.dEnd",4);
nuiDefPCtrlLoc("Average.gain",6);
nuiDefPCtrlLoc("Average.bytes",6);
nuiDefPCtrlLoc("Average.scale",6);
nuiDefTweakerCol("Average",1,"",10,150);
nuiDefTweakerCol("Average",2,"File",10,550);
nuiDefTweakerCol("Average",3,"",10,50);
nuiDefTweakerCol("Average",4,"Timing",10,200);
nuiDefTweakerCol("Average",5,"",10,50);
nuiDefTweakerCol("Average",6,"",10,200);

//Checker
nuiDefTweakerNumCol("Checker",2);
nuiDefPCtrlLoc("Checker.timeShift",1);
nuiDefPCtrlLoc("Checker.startFrame",1);
nuiDefPCtrlLoc("Checker.endFrame",1);
nuiDefPCtrlLoc("Checker.width",1);
nuiDefPCtrlLoc("Checker.height",1);
nuiDefPCtrlLoc("Checker.bytes",1);
nuiDefPCtrlLoc("Checker.xSize",2);
nuiDefPCtrlLoc("Checker.ySize",2);
nuiDefTweakerCol("Checker",1,"",10,250);
nuiDefTweakerCol("Checker",2,"Size",10,350);

//Color
nuiDefTweakerNumCol("Color",2);
nuiDefPCtrlLoc("Color.timeShift",1);
nuiDefPCtrlLoc("Color.startFrame",1);
nuiDefPCtrlLoc("Color.endFrame",1);
nuiDefPCtrlLoc("Color.width",1);
nuiDefPCtrlLoc("Color.height",1);
nuiDefPCtrlLoc("Color.bytes",1);
nuiDefPCtrlLoc("Color.red",2);
nuiDefPCtrlLoc("Color.green",2);
nuiDefPCtrlLoc("Color.blue",2);
nuiDefPCtrlLoc("Color.alpha",2);
nuiDefPCtrlLoc("Color.depth",2);
nuiDefTweakerCol("Color",1,"",10,250);
nuiDefTweakerCol("Color",2,"Color",10,400);

//ColorWheel
nuiDefTweakerNumCol("ColorWheel",3);
nuiDefPCtrlLoc("ColorWheel.timeShift",1);
nuiDefPCtrlLoc("ColorWheel.startFrame",1);
nuiDefPCtrlLoc("ColorWheel.endFrame",1);
nuiDefPCtrlLoc("ColorWheel.width",1);
nuiDefPCtrlLoc("ColorWheel.height",1);
nuiDefPCtrlLoc("ColorWheel.bytes",1);
nuiDefPCtrlLoc("ColorWheel.satEdge",3);
nuiDefPCtrlLoc("ColorWheel.satCenter",2);
nuiDefPCtrlLoc("ColorWheel.valEdge",3);
nuiDefPCtrlLoc("ColorWheel.valCenter",2);
nuiDefTweakerCol("ColorWheel",1,"",10,250);
nuiDefTweakerCol("ColorWheel",2,"Center",10,250);
nuiDefTweakerCol("ColorWheel",3,"Edge",10,250);


//FileIn
nuiDefTweakerNumCol("FileIn",5);
nuiDefPCtrlLoc("FileIn.imageName",3);
nuiDefPCtrlLoc("FileIn.startFrame",2);
nuiDefPCtrlLoc("FileIn.endFrame",2);
nuiDefPCtrlLoc("FileIn.timeShift",2);
nuiDefPCtrlLoc("FileIn.inMode",2);
nuiDefPCtrlLoc("FileIn.outMode",2);
nuiDefPCtrlLoc("FileIn.autoAlpha",5);
nuiDefPCtrlLoc("FileIn.fileFormat",5);
nuiDefPCtrlLoc("FileIn.deInterlacing",5);
nuiDefTweakerCol("FileIn",1,"",10,20);
nuiDefTweakerCol("FileIn",2,"Timing",10,290);
nuiDefTweakerCol("FileIn",3,"File",10,500);
nuiDefTweakerCol("FileIn",4,"",10,50);
nuiDefTweakerCol("FileIn",5,"",10,250);


//FileOut
nuiDefTweakerNumCol("FileOut",4);
nuiDefPCtrlLoc("FileOut.imageName",2);
nuiDefPCtrlLoc("FileOut.fileFormat",4);
nuiDefPCtrlLoc("FileOut.pixelFormat",4);
nuiDefTweakerCol("FileOut",1,"",10,50);
nuiDefTweakerCol("FileOut",2,"File",10,550);
nuiDefTweakerCol("FileOut",3,"",10,50);
nuiDefTweakerCol("FileOut",4,"",10,350);

//Grad
nuiDefTweakerNumCol("Grad",5);
nuiDefPCtrlLoc("Grad.timeShift",1);
nuiDefPCtrlLoc("Grad.startFrame",1);
nuiDefPCtrlLoc("Grad.endFrame",1);
nuiDefPCtrlLoc("Grad.width",1);
nuiDefPCtrlLoc("Grad.height",1);
nuiDefPCtrlLoc("Grad.bytes",1);
nuiDefPCtrlLoc("Grad.xMid",1);
nuiDefPCtrlLoc("Grad.yMid",1);
nuiDefPCtrlLoc("Grad.rLL",2);
nuiDefPCtrlLoc("Grad.gLL",2);
nuiDefPCtrlLoc("Grad.bLL",2);
nuiDefPCtrlLoc("Grad.aLL",2);
nuiDefPCtrlLoc("Grad.zLL",2);
nuiDefPCtrlLoc("Grad.rLR",3);
nuiDefPCtrlLoc("Grad.gLR",3);
nuiDefPCtrlLoc("Grad.bLR",3);
nuiDefPCtrlLoc("Grad.aLR",3);
nuiDefPCtrlLoc("Grad.zLR",3);
nuiDefPCtrlLoc("Grad.rUR",4);
nuiDefPCtrlLoc("Grad.gUR",4);
nuiDefPCtrlLoc("Grad.bUR",4);
nuiDefPCtrlLoc("Grad.aUR",4);
nuiDefPCtrlLoc("Grad.zUR",4);
nuiDefPCtrlLoc("Grad.rUL",5);
nuiDefPCtrlLoc("Grad.gUL",5);
nuiDefPCtrlLoc("Grad.bUL",5);
nuiDefPCtrlLoc("Grad.aUL",5);
nuiDefPCtrlLoc("Grad.zUL",5);
nuiDefTweakerCol("Grad",1,"",10,225);
nuiDefTweakerCol("Grad",2,"Lower-Left",10,300);
nuiDefTweakerCol("Grad",3,"Lower-Right",10,300);
nuiDefTweakerCol("Grad",4,"Upper-Right",10,300);
nuiDefTweakerCol("Grad",5,"Upper-Left",10,300);


//PullDown
nuiDefTweakerNumCol("PullDown",4);
nuiDefPCtrlLoc("PullDown.imageName",2);
nuiDefPCtrlLoc("PullDown.dominance",4);
nuiDefPCtrlLoc("PullDown.offset",4);
nuiDefTweakerCol("PullDown",1,"",10,50);
nuiDefTweakerCol("PullDown",2,"File",10,550);
nuiDefTweakerCol("PullDown",3,"",10,50);
nuiDefTweakerCol("PullDown",4,"Fields",10,250);

//PullUp
nuiDefTweakerNumCol("PullUp",4);
nuiDefPCtrlLoc("PullUp.imageName",2);
nuiDefPCtrlLoc("PullUp.dominance",4);
nuiDefPCtrlLoc("PullUp.offset",4);
nuiDefTweakerCol("PullUp",1,"",10,50);
nuiDefTweakerCol("PullUp",2,"File",10,550);
nuiDefTweakerCol("PullUp",3,"",10,50);
nuiDefTweakerCol("PullUp",4,"Fields",10,250);


//QuickShape
nuiDefTweakerNumCol("QuickShape",4);
nuiDefPCtrlLoc("QuickShape.timeShift",1);
nuiDefPCtrlLoc("QuickShape.startFrame",1);
nuiDefPCtrlLoc("QuickShape.endFrame",1);
nuiDefPCtrlLoc("QuickShape.width",1);
nuiDefPCtrlLoc("QuickShape.height",1);
nuiDefPCtrlLoc("QuickShape.bytes",1);
nuiDefPCtrlLoc("QuickShape.xPan",2);
nuiDefPCtrlLoc("QuickShape.yPan",2);
nuiDefPCtrlLoc("QuickShape.angle",3);
nuiDefPCtrlLoc("QuickShape.aspectRatio",3);
nuiDefPCtrlLoc("QuickShape.xScale",3);
nuiDefPCtrlLoc("QuickShape.yScale",3);
nuiDefPCtrlLoc("QuickShape.xCenter",3);
nuiDefPCtrlLoc("QuickShape.yCenter",3);
nuiDefPCtrlLoc("QuickShape.motionBlur",4);
nuiDefPCtrlLoc("QuickShape.shutterTiming",4);
nuiDefPCtrlLoc("QuickShape.shitterOffset",4);
nuiDefTweakerCol("QuickShape",1,"",10,300);
nuiDefTweakerCol("QuickShape",2,"",10,250);
nuiDefTweakerCol("QuickShape",3,"",10,300);
nuiDefTweakerCol("QuickShape",4,"",10,350);


//Ramp
nuiDefTweakerNumCol("Ramp",5);
nuiDefPCtrlLoc("Ramp.timeShift",1);
nuiDefPCtrlLoc("Ramp.startFrame",1);
nuiDefPCtrlLoc("Ramp.endFrame",1);
nuiDefPCtrlLoc("Ramp.width",1);
nuiDefPCtrlLoc("Ramp.height",1);
nuiDefPCtrlLoc("Ramp.bytes",1);
nuiDefPCtrlLoc("Ramp.orientation",2);
nuiDefPCtrlLoc("Ramp.center",2);
nuiDefPCtrlLoc("Ramp.red1",4);
nuiDefPCtrlLoc("Ramp.green1",4);
nuiDefPCtrlLoc("Ramp.blue1",4);
nuiDefPCtrlLoc("Ramp.alpha1",4);
nuiDefPCtrlLoc("Ramp.depth1",4);
nuiDefPCtrlLoc("Ramp.red2",5);
nuiDefPCtrlLoc("Ramp.green2",5);
nuiDefPCtrlLoc("Ramp.blue2",5);
nuiDefPCtrlLoc("Ramp.alpha2",5);
nuiDefPCtrlLoc("Ramp.depth2",5);

nuiDefTweakerCol("Ramp",1,"",10,250);
nuiDefTweakerCol("Ramp",2,"",10,250);
nuiDefTweakerCol("Ramp",3,"",10,50);
nuiDefTweakerCol("Ramp",4,"Left/Bottom",10,350);
nuiDefTweakerCol("Ramp",5,"Right/Top",10,350);

//Rand
nuiDefTweakerNumCol("Rand",3);
nuiDefPCtrlLoc("Rand.timeShift",1);
nuiDefPCtrlLoc("Rand.startFrame",1);
nuiDefPCtrlLoc("Rand.endFrame",1);
nuiDefPCtrlLoc("Rand.width",1);
nuiDefPCtrlLoc("Rand.height",1);
nuiDefPCtrlLoc("Rand.bytes",1);
nuiDefPCtrlLoc("Rand.density",3);
nuiDefPCtrlLoc("Rand.seed",3);

nuiDefTweakerCol("Rand",1,"",10,250);
nuiDefTweakerCol("Rand",2,"",10,50);
nuiDefTweakerCol("Rand",3,"",10,250);


//RGrad
nuiDefTweakerNumCol("RGrad",4);
nuiDefPCtrlLoc("RGrad.timeShift",1);
nuiDefPCtrlLoc("RGrad.startFrame",1);
nuiDefPCtrlLoc("RGrad.endFrame",1);
nuiDefPCtrlLoc("RGrad.width",1);
nuiDefPCtrlLoc("RGrad.height",1);
nuiDefPCtrlLoc("RGrad.bytes",1);
nuiDefPCtrlLoc("RGrad.aspectRatio",2);
nuiDefPCtrlLoc("RGrad.xCenter",2);
nuiDefPCtrlLoc("RGrad.yCenter",2);
nuiDefPCtrlLoc("RGrad.center",2);
nuiDefPCtrlLoc("RGrad.radius",2);
nuiDefPCtrlLoc("RGrad.falloffRadius",2);
nuiDefPCtrlLoc("RGrad.falloff",2);
nuiDefPCtrlLoc("RGrad.rCenter",3);
nuiDefPCtrlLoc("RGrad.gCenter",3);
nuiDefPCtrlLoc("RGrad.bCenter",3);
nuiDefPCtrlLoc("RGrad.aCenter",3);
nuiDefPCtrlLoc("RGrad.zCenter",3);
nuiDefPCtrlLoc("RGrad.rEdge",4);
nuiDefPCtrlLoc("RGrad.gEdge",4);
nuiDefPCtrlLoc("RGrad.bEdge",4);
nuiDefPCtrlLoc("RGrad.aEdge",4);
nuiDefPCtrlLoc("RGrad.zEdge",4);

nuiDefTweakerCol("RGrad",1,"",10,250);
nuiDefTweakerCol("RGrad",2,"",10,250);
nuiDefTweakerCol("RGrad",3,"",10,400);
nuiDefTweakerCol("RGrad",4,"",10,400);

//RotoShape
nuiDefTweakerNumCol("RotoShape",4);
nuiDefPCtrlLoc("RotoShape.timeShift",1);
nuiDefPCtrlLoc("RotoShape.startFrame",1);
nuiDefPCtrlLoc("RotoShape.endFrame",1);
nuiDefPCtrlLoc("RotoShape.width",1);
nuiDefPCtrlLoc("RotoShape.height",1);
nuiDefPCtrlLoc("RotoShape.bytes",1);
nuiDefPCtrlLoc("RotoShape.xPan",2);
nuiDefPCtrlLoc("RotoShape.yPan",2);
nuiDefPCtrlLoc("RotoShape.angle",3);
nuiDefPCtrlLoc("RotoShape.aspectRatio",3);
nuiDefPCtrlLoc("RotoShape.xScale",3);
nuiDefPCtrlLoc("RotoShape.yScale",3);
nuiDefPCtrlLoc("RotoShape.xCenter",3);
nuiDefPCtrlLoc("RotoShape.yCenter",3);
nuiDefPCtrlLoc("RotoShape.motionBlur",4);
nuiDefPCtrlLoc("RotoShape.shutterTiming",4);
nuiDefPCtrlLoc("RotoShape.shitterOffset",4);
nuiDefTweakerCol("RotoShape",1,"",10,300);
nuiDefTweakerCol("RotoShape",2,"",10,250);
nuiDefTweakerCol("RotoShape",3,"",10,300);
nuiDefTweakerCol("RotoShape",4,"",10,350);

//Text
nuiDefTweakerNumCol("Text",6);
nuiDefPCtrlLoc("Text.timeShift",1);
nuiDefPCtrlLoc("Text.startFrame",1);
nuiDefPCtrlLoc("Text.endFrame",1);
nuiDefPCtrlLoc("Text.width",1);
nuiDefPCtrlLoc("Text.height",1);
nuiDefPCtrlLoc("Text.bytes",1);
nuiDefPCtrlLoc("Text.text",2);
nuiDefPCtrlLoc("Text.font",1);
nuiDefPCtrlLoc("Text.xFontScale",2);
nuiDefPCtrlLoc("Text.yFontScale",2);
nuiDefPCtrlLoc("Text.leading",2);
nuiDefPCtrlLoc("Text.xAlign",2);
nuiDefPCtrlLoc("Text.yAlign",2);
nuiDefPCtrlLoc("Text.red",4);
nuiDefPCtrlLoc("Text.green",4);
nuiDefPCtrlLoc("Text.blue",4);
nuiDefPCtrlLoc("Text.alpha",4);
nuiDefPCtrlLoc("Text.xPos",6);
nuiDefPCtrlLoc("Text.yPos",6);
nuiDefPCtrlLoc("Text.zPos",6);
nuiDefPCtrlLoc("Text.xAngle",6);
nuiDefPCtrlLoc("Text.yAngle",6);
nuiDefPCtrlLoc("Text.zAngle",6);
nuiDefPCtrlLoc("Text.fieldOfView",6);
nuiDefPCtrlLoc("Text.kerning",1);
nuiDefPCtrlLoc("Text.fontQuality",1);
nuiDefTweakerCol("Text",1,"",10,220);
nuiDefTweakerCol("Text",2,"Format",10,400,450);
nuiDefTweakerCol("Text",3,"",10,20);
nuiDefTweakerCol("Text",4,"Color",10,300,450);
nuiDefTweakerCol("Text",5,"",10,20);
nuiDefTweakerCol("Text",6,"Position",10,200);

//VTRIn
nuxDefToggle("VTRIn.lockDuration");
nuiDefTweakerNumCol("VTRIn",4);
nuiDefPCtrlLoc("VTRIn.timeShift",2);
nuiDefPCtrlLoc("VTRIn.startFrame",2);
nuiDefPCtrlLoc("VTRIn.endFrame",2);
nuiDefPCtrlLoc("VTRIn.inMode",2);
nuiDefPCtrlLoc("VTRIn.outMode",2);
nuiDefPCtrlLoc("VTRIn.firstFrame",4);
nuiDefPCtrlLoc("VTRIn.lastFrame",4);
nuiDefPCtrlLoc("VTRIn.increment",4);
nuiDefPCtrlLoc("VTRIn.autoAlpha",4);
nuiDefPCtrlLoc("VTRIn.deInterlacing",4);
nuiDefPCtrlLoc("VTRIn.timecodeMode",3);
nuiDefPCtrlLoc("VTRIn.inTimecode",3);
nuiDefPCtrlLoc("VTRIn.outTimecode",3);
nuiDefPCtrlLoc("VTRIn.duration",3);
nuiDefPCtrlLoc("VTRIn.lockDuration",3);
nuiDefPCtrlLoc("VTRIn.reelName",3);
nuiDefPCtrlLoc("VTRIn.clipName",3);
nuiDefPCtrlLoc("VTRIn.yuvDecode",4);
nuiDefTweakerCol("VTRIn",1,"",10,20);
nuiDefTweakerCol("VTRIn",2,"",10,290);
nuiDefTweakerCol("VTRIn",4,"",7,260,300);
nuiDefTweakerCol("VTRIn",3,"",10,400,430);

//VTROut
nuxDefToggle("VTROut.lockDuration");
nuxDefToggle("VTROut.yuvEncode");
nuiDefTweakerNumCol("VTROut",2);
nuiDefPCtrlLoc("VTROut.timecodeMode",2);
nuiDefPCtrlLoc("VTROut.inTimecode",2);
nuiDefPCtrlLoc("VTROut.outTimecode",2);
nuiDefPCtrlLoc("VTROut.duration",2);
nuiDefPCtrlLoc("VTROut.lockDuration",2);
nuiDefPCtrlLoc("VTROut.yuvDecode",2);
nuiDefTweakerCol("VTROut",1,"",10,200);
nuiDefTweakerCol("VTROut",2,"",10,300,350);
nuxDefMultiChoice("VTROut.conformMode", "fit|crop|resize|default");
nuxDefMultiChoice("VTROut.conformFilter", nfxFilterList());

//AddText
nuiDefTweakerNumCol("AddText",6);
nuiDefPCtrlLoc("AddText.text",2);
nuiDefPCtrlLoc("AddText.font",2);
nuiDefPCtrlLoc("AddText.xFontScale",2);
nuiDefPCtrlLoc("AddText.yFontScale",2);
nuiDefPCtrlLoc("AddText.leading",2);
nuiDefPCtrlLoc("AddText.xAlign",2);
nuiDefPCtrlLoc("AddText.yAlign",2);
nuiDefPCtrlLoc("AddText.red",4);
nuiDefPCtrlLoc("AddText.green",4);
nuiDefPCtrlLoc("AddText.blue",4);
nuiDefPCtrlLoc("AddText.alpha",4);
nuiDefPCtrlLoc("AddText.xPos",6);
nuiDefPCtrlLoc("AddText.yPos",6);
nuiDefPCtrlLoc("AddText.zPos",6);
nuiDefPCtrlLoc("AddText.xAngle",6);
nuiDefPCtrlLoc("AddText.yAngle",6);
nuiDefPCtrlLoc("AddText.zAngle",6);
nuiDefPCtrlLoc("AddText.fieldOfView",6);
nuiDefPCtrlLoc("AddText.kerning",4);
nuiDefPCtrlLoc("AddText.fontQuality",4);
nuiDefTweakerCol("AddText",1,"",10,0);
nuiDefTweakerCol("AddText",2,"Format",10,400,450);
nuiDefTweakerCol("AddText",3,"",10,20);
nuiDefTweakerCol("AddText",4,"Color",10,300,450);
nuiDefTweakerCol("AddText",5,"",10,20);
nuiDefTweakerCol("AddText",6,"Position",10,200);

//Add
nuiDefTweakerNumCol("Add",2);
nuiDefPCtrlLoc("Add.red",2);
nuiDefPCtrlLoc("Add.green",2);
nuiDefPCtrlLoc("Add.blue",2);
nuiDefPCtrlLoc("Add.alpha",2);
nuiDefPCtrlLoc("Add.depth",2);
nuiDefTweakerCol("Add",1,"",10,250);
nuiDefTweakerCol("Add",2,"Add",10,400);


//AdjustHSV
nuiDefTweakerNumCol("AdjustHSV",4);
nuiDefPCtrlLoc("AdjustHSV.sourceHue",1);
nuiDefPCtrlLoc("AdjustHSV.sourceSat",1);
nuiDefPCtrlLoc("AdjustHSV.sourceVal",1);
nuiDefPCtrlLoc("AdjustHSV.destHue",1);
nuiDefPCtrlLoc("AdjustHSV.destSat",1);
nuiDefPCtrlLoc("AdjustHSV.destVal",1);
nuiDefPCtrlLoc("AdjustHSV.hueOffset",2);
nuiDefPCtrlLoc("AdjustHSV.hueRange",2);
nuiDefPCtrlLoc("AdjustHSV.hueSharpness",2);
nuiDefPCtrlLoc("AdjustHSV.hueFalloff",2);
nuiDefPCtrlLoc("AdjustHSV.satOffset",3);
nuiDefPCtrlLoc("AdjustHSV.satRange",3);
nuiDefPCtrlLoc("AdjustHSV.satSharpness",3);
nuiDefPCtrlLoc("AdjustHSV.satFalloff",3);
nuiDefPCtrlLoc("AdjustHSV.valOffset",4);
nuiDefPCtrlLoc("AdjustHSV.valRange",4);
nuiDefPCtrlLoc("AdjustHSV.valSharpness",4);
nuiDefPCtrlLoc("AdjustHSV.valFalloff",4);
nuiDefTweakerCol("AdjustHSV",1,"",10,420);
nuiDefTweakerCol("AdjustHSV",2,"Hue",10,250);
nuiDefTweakerCol("AdjustHSV",3,"Saturation",10,250);
nuiDefTweakerCol("AdjustHSV",4,"Value",10,250);

//Brightness
nuiDefTweakerNumCol("Brightness",2);
nuiDefPCtrlLoc("Brightness.value",2);
nuiDefTweakerCol("Brightness",1,"",10,250);
nuiDefTweakerCol("Brightness",2,"Brightness",10,250);


//Clamp
nuiDefTweakerNumCol("Clamp",3);
nuiDefPCtrlLoc("Clamp.rLo",2);
nuiDefPCtrlLoc("Clamp.gLo",2);
nuiDefPCtrlLoc("Clamp.bLo",2);
nuiDefPCtrlLoc("Clamp.aLo",2);
nuiDefPCtrlLoc("Clamp.rHi",3);
nuiDefPCtrlLoc("Clamp.gHi",3);
nuiDefPCtrlLoc("Clamp.bHi",3);
nuiDefPCtrlLoc("Clamp.aHi",3);
nuiDefTweakerCol("Clamp",1,"",10,250);
nuiDefTweakerCol("Clamp",2,"Low Color",10,400);
nuiDefTweakerCol("Clamp",3,"High Color",10,400);

//ColorMatch
nuiDefTweakerNumCol("ColorMatch",5);
nuiDefPCtrlLoc("ColorMatch.rLowS",2);
nuiDefPCtrlLoc("ColorMatch.gLowS",2);
nuiDefPCtrlLoc("ColorMatch.bLowS",2);
nuiDefPCtrlLoc("ColorMatch.aLowS",2);
nuiDefPCtrlLoc("ColorMatch.rLowD",2);
nuiDefPCtrlLoc("ColorMatch.gLowD",2);
nuiDefPCtrlLoc("ColorMatch.bLowD",2);
nuiDefPCtrlLoc("ColorMatch.aLowD",2);
nuiDefPCtrlLoc("ColorMatch.rMidS",3);
nuiDefPCtrlLoc("ColorMatch.gMidS",3);
nuiDefPCtrlLoc("ColorMatch.bMidS",3);
nuiDefPCtrlLoc("ColorMatch.aMidS",3);
nuiDefPCtrlLoc("ColorMatch.rMidD",3);
nuiDefPCtrlLoc("ColorMatch.gMidD",3);
nuiDefPCtrlLoc("ColorMatch.bMidD",3);
nuiDefPCtrlLoc("ColorMatch.aMidD",3);
nuiDefPCtrlLoc("ColorMatch.rHighS",4);
nuiDefPCtrlLoc("ColorMatch.gHighS",4);
nuiDefPCtrlLoc("ColorMatch.bHighS",4);
nuiDefPCtrlLoc("ColorMatch.aHighS",4);
nuiDefPCtrlLoc("ColorMatch.rHighD",4);
nuiDefPCtrlLoc("ColorMatch.gHighD",4);
nuiDefPCtrlLoc("ColorMatch.bHighD",4);
nuiDefPCtrlLoc("ColorMatch.aHighD",4);
nuiDefPCtrlLoc("ColorMatch.rContrast",5);
nuiDefPCtrlLoc("ColorMatch.gContrast",5);
nuiDefPCtrlLoc("ColorMatch.bContrast",5);
nuiDefPCtrlLoc("ColorMatch.aContrast",5);
nuiDefPCtrlLoc("ColorMatch.rGamma",5);
nuiDefPCtrlLoc("ColorMatch.gGamma",5);
nuiDefPCtrlLoc("ColorMatch.bGamma",5);
nuiDefPCtrlLoc("ColorMatch.aGamma",5);
nuiDefPCtrlLoc("ColorMatch.rMult",5);
nuiDefPCtrlLoc("ColorMatch.gMult",5);
nuiDefPCtrlLoc("ColorMatch.bMult",5);
nuiDefPCtrlLoc("ColorMatch.aMult",5);
nuiDefPCtrlLoc("ColorMatch.rAdd",5);
nuiDefPCtrlLoc("ColorMatch.gAdd",5);
nuiDefPCtrlLoc("ColorMatch.bAdd",5);
nuiDefPCtrlLoc("ColorMatch.aAdd",5);
nuiDefPCtrlLoc("ColorMatch.min",5);
nuiDefPCtrlLoc("ColorMatch.max",5);
nuiDefTweakerCol("ColorMatch",1,"",10,10);
nuiDefTweakerCol("ColorMatch",2,"Shadows",10,220,440);
nuiDefTweakerCol("ColorMatch",3,"MidTones",10,220,440);
nuiDefTweakerCol("ColorMatch",4,"Highlights",10,220,440);
nuiDefTweakerCol("ColorMatch",5,"Color Correct",10,400,430);


//ColorReplace
nuiDefTweakerNumCol("ColorReplace",5);
nuiDefPCtrlLoc("ColorReplace.affectAlpha",1);
nuiDefPCtrlLoc("ColorReplace.rSource",2);
nuiDefPCtrlLoc("ColorReplace.gSource",2);
nuiDefPCtrlLoc("ColorReplace.bSource",2);
nuiDefPCtrlLoc("ColorReplace.rReplace",3);
nuiDefPCtrlLoc("ColorReplace.gReplace",3);
nuiDefPCtrlLoc("ColorReplace.bReplace",3);
nuiDefPCtrlLoc("ColorReplace.hueRange",4);
nuiDefPCtrlLoc("ColorReplace.hueFalloff",4);
nuiDefPCtrlLoc("ColorReplace.satRange",4);
nuiDefPCtrlLoc("ColorReplace.satFalloff",4);
nuiDefPCtrlLoc("ColorReplace.valRange",4);
nuiDefPCtrlLoc("ColorReplace.valFalloff",4);
nuiDefTweakerCol("ColorReplace",1,"",10,200);
nuiDefTweakerCol("ColorReplace",2,"From",10,250,450);
nuiDefTweakerCol("ColorReplace",3,"To",10,250,450);
nuiDefTweakerCol("ColorReplace",4,"",10,250);

//ColorSpace
nuiDefTweakerNumCol("ColorSpace",4);
nuiDefPCtrlLoc("ColorSpace.inSpace",2);
nuiDefPCtrlLoc("ColorSpace.outSpace",2);
nuiDefPCtrlLoc("ColorSpace.rWeight",4);
nuiDefPCtrlLoc("ColorSpace.gWeight",4);
nuiDefPCtrlLoc("ColorSpace.bWeight",4);
nuiDefTweakerCol("ColorSpace",1,"",10,200);
nuiDefTweakerCol("ColorSpace",2,"Space",10,350);
nuiDefTweakerCol("ColorSpace",3,"",10,50);
nuiDefTweakerCol("ColorSpace",4,"Luminance Weight",10,250);

//ColorX
nuiDefTweakerNumCol("ColorX",2);
nuiDefPCtrlLoc("ColorX.rExpr",2);
nuiDefPCtrlLoc("ColorX.gExpr",2);
nuiDefPCtrlLoc("ColorX.bExpr",2);
nuiDefPCtrlLoc("ColorX.aExpr",2);
nuiDefPCtrlLoc("ColorX.zExpr",2);
nuiDefTweakerCol("ColorX",1,"",10,200);
nuiDefTweakerCol("ColorX",2,"Expressions",10,550);


//Compress
nuiDefTweakerNumCol("Compress",3);
nuiDefPCtrlLoc("Compress.rLo",2);
nuiDefPCtrlLoc("Compress.gLo",2);
nuiDefPCtrlLoc("Compress.bLo",2);
nuiDefPCtrlLoc("Compress.aLo",2);
nuiDefPCtrlLoc("Compress.rHi",3);
nuiDefPCtrlLoc("Compress.gHi",3);
nuiDefPCtrlLoc("Compress.bHi",3);
nuiDefPCtrlLoc("Compress.aHi",3);
nuiDefTweakerCol("Compress",1,"",10,250);
nuiDefTweakerCol("Compress",2,"Low Color",10,400);
nuiDefTweakerCol("Compress",3,"High Color",10,400);

//ContrastLum
nuiDefTweakerNumCol("ContrastLum",4);
nuiDefPCtrlLoc("ContrastLum.value",2);
nuiDefPCtrlLoc("ContrastLum.center",3);
nuiDefPCtrlLoc("ContrastLum.softClip",4);
nuiDefTweakerCol("ContrastLum",1,"",10,250);
nuiDefTweakerCol("ContrastLum",2,"Contrast",10,250);
nuiDefTweakerCol("ContrastLum",3,"Center",10,250);
nuiDefTweakerCol("ContrastLum",4,"Rolloff",10,250);

//ContrastRGB
nuiDefTweakerNumCol("ContrastRGB",5);
nuiDefPCtrlLoc("ContrastRGB.rValue",2);
nuiDefPCtrlLoc("ContrastRGB.rCenter",2);
nuiDefPCtrlLoc("ContrastRGB.rSoftClip",2);
nuiDefPCtrlLoc("ContrastRGB.gValue",3);
nuiDefPCtrlLoc("ContrastRGB.gCenter",3);
nuiDefPCtrlLoc("ContrastRGB.gSoftClip",3);
nuiDefPCtrlLoc("ContrastRGB.bValue",4);
nuiDefPCtrlLoc("ContrastRGB.bCenter",4);
nuiDefPCtrlLoc("ContrastRGB.bSoftClip",4);
nuiDefPCtrlLoc("ContrastRGB.aValue",5);
nuiDefPCtrlLoc("ContrastRGB.aCenter",5);
nuiDefPCtrlLoc("ContrastRGB.aSoftClip",5);
nuiDefTweakerCol("ContrastRGB",1,"",10,250);
nuiDefTweakerCol("ContrastRGB",2,"Red",10,250);
nuiDefTweakerCol("ContrastRGB",3,"Green",10,250);
nuiDefTweakerCol("ContrastRGB",4,"Blue",10,250);
nuiDefTweakerCol("ContrastRGB",5,"Alpha",10,250);


//Expand
nuiDefTweakerNumCol("Expand",3);
nuiDefPCtrlLoc("Expand.rLo",2);
nuiDefPCtrlLoc("Expand.gLo",2);
nuiDefPCtrlLoc("Expand.bLo",2);
nuiDefPCtrlLoc("Expand.aLo",2);
nuiDefPCtrlLoc("Expand.rHi",3);
nuiDefPCtrlLoc("Expand.gHi",3);
nuiDefPCtrlLoc("Expand.bHi",3);
nuiDefPCtrlLoc("Expand.aHi",3);
nuiDefTweakerCol("Expand",1,"",10,250);
nuiDefTweakerCol("Expand",2,"Low Color",10,400);
nuiDefTweakerCol("Expand",3,"High Color",10,400);

//Fade
nuiDefTweakerNumCol("Fade",2);
nuiDefPCtrlLoc("Fade.value",2);
nuiDefTweakerCol("Fade",1,"",10,250);
nuiDefTweakerCol("Fade",2,"Fade",10,250);


//Gamma
nuiDefPCtrlLoc("Gamma.rGamma",2);
nuiDefPCtrlLoc("Gamma.gGamma",2);
nuiDefPCtrlLoc("Gamma.bGamma",2);
nuiDefPCtrlLoc("Gamma.aGamma",2);
nuiDefTweakerCol("Gamma",2,"Gamma",10,400);
nuiDefTweakerNumCol("Gamma",4);

//Invert
nuiDefTweakerNumCol("Invert",2);
nuiDefPCtrlLoc("Invert.channels",2);
nuiDefTweakerCol("Invert",1,"",10,250);
nuiDefTweakerCol("Invert",2,"Invert Channels",10,250);


//LogLin
nuiDefTweakerNumCol("LogLin",7);
nuiDefPCtrlLoc("LogLin.conversion",1);
nuiDefPCtrlLoc("LogLin.rOffset",3);
nuiDefPCtrlLoc("LogLin.gOffset",3);
nuiDefPCtrlLoc("LogLin.bOffset",3);
nuiDefPCtrlLoc("LogLin.rBlack",4);
nuiDefPCtrlLoc("LogLin.gBlack",4);
nuiDefPCtrlLoc("LogLin.bBlack",4);
nuiDefPCtrlLoc("LogLin.rWhite",5);
nuiDefPCtrlLoc("LogLin.gWhite",5);
nuiDefPCtrlLoc("LogLin.bWhite",5);
nuiDefPCtrlLoc("LogLin.rSoftClip",6);
nuiDefPCtrlLoc("LogLin.gSoftClip",6);
nuiDefPCtrlLoc("LogLin.bSoftClip",6);
nuiDefPCtrlLoc("LogLin.rNGamma",7);
nuiDefPCtrlLoc("LogLin.gNGamma",7);
nuiDefPCtrlLoc("LogLin.bNGamma",7);
nuiDefPCtrlLoc("LogLin.rDGamma",7);
nuiDefPCtrlLoc("LogLin.gDGamma",7);
nuiDefPCtrlLoc("LogLin.bDGamma",7);
nuiDefTweakerCol("LogLin",1,"",10,240);
nuiDefTweakerCol("LogLin",2,"",10,30);
nuiDefTweakerCol("LogLin",3,"Offset",10,200);
nuiDefTweakerCol("LogLin",4,"Black Point",10,200);
nuiDefTweakerCol("LogLin",5,"White Point",10,200);
nuiDefTweakerCol("LogLin",6,"Soft Clip",10,200);
nuiDefTweakerCol("LogLin",7,"Gamma",10,200);

//Monochrome
nuiDefTweakerNumCol("Monochrome",3);
nuiDefPCtrlLoc("Monochrome.rWeight",2);
nuiDefPCtrlLoc("Monochrome.gWeight",2);
nuiDefPCtrlLoc("Monochrome.bWeight",2);
nuiDefTweakerCol("Monochrome",1,"",10,250);
nuiDefTweakerCol("Monochrome",2,"Weight",10,250);

//Mult
nuiDefTweakerNumCol("Mult",2);
nuiDefPCtrlLoc("Mult.red",2);
nuiDefPCtrlLoc("Mult.green",2);
nuiDefPCtrlLoc("Mult.blue",2);
nuiDefPCtrlLoc("Mult.alpha",2);
nuiDefPCtrlLoc("Mult.depth",2);
nuiDefTweakerCol("Mult",1,"",10,250);
nuiDefTweakerCol("Mult",2,"Mult",10,400);

//Reorder
nuiDefTweakerNumCol("Reorder",2);
nuiDefPCtrlLoc("Reorder.channels",2);
nuiDefTweakerCol("Reorder",1,"",10,250);
nuiDefTweakerCol("Reorder",2,"Channels",10,250);

//Saturation
nuiDefTweakerNumCol("Saturation",2);
nuiDefPCtrlLoc("Saturation.value",2);
nuiDefTweakerCol("Saturation",1,"",10,250);
nuiDefTweakerCol("Saturation",2,"Saturation",10,250);

//SetAlpha
nuiDefTweakerNumCol("SetAlpha",2);
nuiDefPCtrlLoc("SetAlpha.alpha",2);
nuiDefTweakerCol("SetAlpha",1,"",10,250);
nuiDefTweakerCol("SetAlpha",2,"Alpha Value",10,250);

//SetBGColor
nuiDefTweakerNumCol("SetBGColor",4);
nuiDefPCtrlLoc("SetBGColor.mask",2);
nuiDefPCtrlLoc("SetBGColor.red",4);
nuiDefPCtrlLoc("SetBGColor.green",4);
nuiDefPCtrlLoc("SetBGColor.blue",4);
nuiDefPCtrlLoc("SetBGColor.alpha",4);
nuiDefPCtrlLoc("SetBGColor.depth",4);
nuiDefTweakerCol("SetBGColor",1,"",10,250);
nuiDefTweakerCol("SetBGColor",2,"Channels",10,250);
nuiDefTweakerCol("SetBGColor",3,"",10,50);
nuiDefTweakerCol("SetBGColor",4,"Color",10,400);

//Threshold
nuiDefTweakerNumCol("Threshold",2);
nuiDefPCtrlLoc("Threshold.red",2);
nuiDefPCtrlLoc("Threshold.green",2);
nuiDefPCtrlLoc("Threshold.blue",2);
nuiDefPCtrlLoc("Threshold.alpha",2);
nuiDefPCtrlLoc("Threshold.depth",2);
nuiDefTweakerCol("Threshold",1,"",10,250);
nuiDefTweakerCol("Threshold",2,"Threshold",10,400);

//ApplyFilter
nuiDefTweakerNumCol("ApplyFilter",4);
nuiDefPCtrlLoc("ApplyFilter.xScale",2);
nuiDefPCtrlLoc("ApplyFilter.yScale",2);
nuiDefTweakerCol("ApplyFilter",2,"",10,250);
nuiDefTweakerCol("ApplyFilter",2,"Amount",10,250);

//Blur
nuiDefTweakerNumCol("Blur",4);
nuiDefPCtrlLoc("Blur.xPixels",2);
nuiDefPCtrlLoc("Blur.yPixels",2);
nuiDefTweakerCol("Blur",2,"Amount",10,250);

//Defocus
nuiDefTweakerNumCol("Defocus",4);
nuiDefPCtrlLoc("Defocus.xPixels",2);
nuiDefPCtrlLoc("Defocus.yPixels",2);
nuiDefPCtrlLoc("Defocus.channels",3);
nuiDefPCtrlLoc("Defocus.percent",3);
nuiDefPCtrlLoc("Defocus.shape",4);
nuiDefPCtrlLoc("Defocus.boostPoint",4);
nuiDefPCtrlLoc("Defocus.superWhite",4);
nuiDefTweakerCol("Defocus",1,"",10,250);
nuiDefTweakerCol("Defocus",2,"Amount",10,250);
nuiDefTweakerCol("Defocus",3,"Channels",10,250);
nuiDefTweakerCol("Defocus",4,"Highlight",10,350);

//DilateErode
nuiDefTweakerNumCol("DilateErode",4);
nuiDefPCtrlLoc("DilateErode.xPixels",2);
nuiDefPCtrlLoc("DilateErode.yPixels",2);
nuiDefTweakerCol("DilateErode",2,"Amount",10,250);

//Emboss
nuiDefTweakerNumCol("Emboss",4);
nuiDefPCtrlLoc("Emboss.gain",2);
nuiDefPCtrlLoc("Emboss.azimuth",3);
nuiDefPCtrlLoc("Emboss.elevation",4);
nuiDefTweakerCol("Emboss",1,"",10,250);
nuiDefTweakerCol("Emboss",2,"Amount",10,250);
nuiDefTweakerCol("Emboss",3,"Angle",10,250);
nuiDefTweakerCol("Emboss",4,"Brightness",10,250);



//EdgeDetect
nuiDefTweakerNumCol("EdgeDetect",4);
nuiDefPCtrlLoc("EdgeDetect.strength",2);
nuiDefPCtrlLoc("EdgeDetect.threshold",2);
nuiDefPCtrlLoc("EdgeDetect.binaryOutput",2);
nuiDefPCtrlLoc("EdgeDetect.method",2);
nuiDefPCtrlLoc("EdgeDetect.babuSteps",2);
nuiDefPCtrlLoc("EdgeDetect.xBlur",3);
nuiDefPCtrlLoc("EdgeDetect.yBlur",3);
nuiDefPCtrlLoc("EdgeDetect.xDilateErode",3);
nuiDefPCtrlLoc("EdgeDetect.yDilateErode",3);
nuiDefPCtrlLoc("EdgeDetect.despeckle",3);
nuiDefPCtrlLoc("EdgeDetect.directionFilter",4);
nuiDefPCtrlLoc("EdgeDetect.directionFilterAngle",4);
nuiDefPCtrlLoc("EdgeDetect.rgbEdges",4);
nuiDefPCtrlLoc("EdgeDetect.addEdgesToImage",4);
nuiDefPCtrlLoc("EdgeDetect.bytes",2);
nuiDefTweakerCol("EdgeDetect",1,"",10,50);
nuiDefTweakerCol("EdgeDetect",2,"",10,350);
nuiDefTweakerCol("EdgeDetect",3,"",10,350);
nuiDefTweakerCol("EdgeDetect",4,"",10,350);


//Grain
nuiDefTweakerNumCol("Grain",6);
nuiDefPCtrlLoc("Grain.seed",2);
nuiDefPCtrlLoc("Grain.aspect",2);
nuiDefPCtrlLoc("Grain.filmResponse",3);
nuiDefPCtrlLoc("Grain.obeyAlpha",2);
nuiDefPCtrlLoc("Grain.size",3);
nuiDefPCtrlLoc("Grain.softness",3);
nuiDefPCtrlLoc("Grain.density",3);
nuiDefPCtrlLoc("Grain.lGain",3);
nuiDefPCtrlLoc("Grain.rGain",4);
nuiDefPCtrlLoc("Grain.rSize",4);
nuiDefPCtrlLoc("Grain.rDensity",4);
nuiDefPCtrlLoc("Grain.rSoftness",4);
nuiDefPCtrlLoc("Grain.rBias",4);
nuiDefPCtrlLoc("Grain.rLowOffset",4);
nuiDefPCtrlLoc("Grain.rHighOffset",4);
nuiDefPCtrlLoc("Grain.gGain",5);
nuiDefPCtrlLoc("Grain.gSize",5);
nuiDefPCtrlLoc("Grain.gDensity",5);
nuiDefPCtrlLoc("Grain.gSoftness",5);
nuiDefPCtrlLoc("Grain.gBias",5);
nuiDefPCtrlLoc("Grain.gLowOffset",5);
nuiDefPCtrlLoc("Grain.gHighOffset",5);
nuiDefPCtrlLoc("Grain.bGain",6);
nuiDefPCtrlLoc("Grain.bSize",6);
nuiDefPCtrlLoc("Grain.bDensity",6);
nuiDefPCtrlLoc("Grain.bSoftness",6);
nuiDefPCtrlLoc("Grain.bBias",6);
nuiDefPCtrlLoc("Grain.bLowOffset",6);
nuiDefPCtrlLoc("Grain.bHighOffset",6);
nuiDefTweakerCol("Grain",1,"",10,20);
nuiDefTweakerCol("Grain",2,"Controls",10,250);
nuiDefTweakerCol("Grain",3,"Global",10,250);
nuiDefTweakerCol("Grain",4,"Red",10,250);
nuiDefTweakerCol("Grain",5,"Green",10,250);
nuiDefTweakerCol("Grain",6,"Blue",10,250);

//IBlur
nuiDefTweakerNumCol("IBlur",4);
nuiDefPCtrlLoc("IBlur.xPixels",2);
nuiDefPCtrlLoc("IBlur.yPixels",2);
nuiDefPCtrlLoc("IBlur.spread",3);
nuiDefPCtrlLoc("IBlur.xFilter",3);
nuiDefPCtrlLoc("IBlur.yFilter",3);
nuiDefPCtrlLoc("IBlur.channels",3);
nuiDefPCtrlLoc("IBlur.steps",4);
nuiDefPCtrlLoc("IBlur.stepBlend",4);
nuiDefPCtrlLoc("IBlur.controlChannel",4);
nuiDefPCtrlLoc("IBlur.invert",4);
nuiDefTweakerCol("IBlur",2,"Amount",10,250);

//IDefocus
nuiDefTweakerNumCol("IDefocus",5);
nuiDefPCtrlLoc("IDefocus.xPixels",2);
nuiDefPCtrlLoc("IDefocus.yPixels",2);
nuiDefPCtrlLoc("IDefocus.percent",3);
nuiDefPCtrlLoc("IDefocus.channels",3);
nuiDefPCtrlLoc("IDefocus.shape",4);
nuiDefPCtrlLoc("IDefocus.boostPoint",4);
nuiDefPCtrlLoc("IDefocus.superWhite",4);
nuiDefPCtrlLoc("IDefocus.steps",5);
nuiDefPCtrlLoc("IDefocus.stepBlend",5);
nuiDefPCtrlLoc("IDefocus.controlChannel",5);
nuiDefPCtrlLoc("IDefocus.invert",5);
nuiDefTweakerCol("IDefocus",1,"",10,150);
nuiDefTweakerCol("IDefocus",2,"Amount",10,250);
nuiDefTweakerCol("IDefocus",3,"Channels",10,250);
nuiDefTweakerCol("IDefocus",4,"Highlight",10,350);
nuiDefTweakerCol("IDefocus",5,"Blend",10,250);


//IDilateErode
nuiDefTweakerNumCol("IDilateErode",4);
nuiDefPCtrlLoc("IDilateErode.xPixels",2);
nuiDefPCtrlLoc("IDilateErode.yPixels",2);
nuiDefTweakerCol("IDilateErode",2,"Amount",10,250);
nuiDefPCtrlLoc("IDilateErode.border",3);
nuiDefPCtrlLoc("IDilateErode.soften",3);
nuiDefPCtrlLoc("IDilateErode.sharpness",3);
nuiDefPCtrlLoc("IDilateErode.channels",3);
nuiDefPCtrlLoc("IDilateErode.steps",4);
nuiDefPCtrlLoc("IDilateErode.stepBlend",4);
nuiDefPCtrlLoc("IDilateErode.controlChannel",4);
nuiDefPCtrlLoc("IDilateErode.invert",4);

//IRBlur
nuiDefTweakerNumCol("IRBlur",4);
nuiDefPCtrlLoc("IRBlur.xCenter",2);
nuiDefPCtrlLoc("IRBlur.yCenter",2);
nuiDefPCtrlLoc("IRBlur.iRadius",2);
nuiDefPCtrlLoc("IRBlur.oRadius",2);
nuiDefPCtrlLoc("IRBlur.aspectRatio",2);
nuiDefPCtrlLoc("IRBlur.damp",3);
nuiDefPCtrlLoc("IRBlur.amplitude",3);
nuiDefPCtrlLoc("IRBlur.blurQuality",3);
nuiDefPCtrlLoc("IRBlur.mirror",3);
nuiDefPCtrlLoc("IRBlur.steps",4);
nuiDefPCtrlLoc("IRBlur.stepBlend",4);
nuiDefPCtrlLoc("IRBlur.controlChannel",4);
nuiDefPCtrlLoc("IRBlur.invert",4);
nuiDefTweakerCol("IRBlur",1,"",10,250);
nuiDefTweakerCol("IRBlur",2,"Position",10,250);
nuiDefTweakerCol("IRBlur",3,"Blur",10,250);
nuiDefTweakerCol("IRBlur",4,"Blend",10,250);

//ISharpen
nuiDefTweakerNumCol("ISharpen",4);
nuiDefPCtrlLoc("ISharpen.xPixels",2);
nuiDefPCtrlLoc("ISharpen.yPixels",2);
nuiDefPCtrlLoc("ISharpen.percent",3);
nuiDefPCtrlLoc("ISharpen.channels",3);
nuiDefPCtrlLoc("ISharpen.steps",4);
nuiDefPCtrlLoc("ISharpen.stepBlend",4);
nuiDefPCtrlLoc("ISharpen.controlChannel",4);
nuiDefPCtrlLoc("ISharpen.invert",4);
nuiDefTweakerCol("ISharpen",1,"",10,250);
nuiDefTweakerCol("ISharpen",2,"Amount",10,250);
nuiDefTweakerCol("ISharpen",3,"Channels",10,250);
nuiDefTweakerCol("ISharpen",4,"Blend",10,250);


//PercentBlur
nuiDefTweakerNumCol("PercentBlur",4);
nuiDefPCtrlLoc("PercentBlur.xPercent",2);
nuiDefPCtrlLoc("PercentBlur.yPercent",2);
nuiDefTweakerCol("PercentBlur",2,"Amount",10,250);

//RBlur
nuiDefTweakerNumCol("RBlur",3);
nuiDefPCtrlLoc("RBlur.xCenter",2);
nuiDefPCtrlLoc("RBlur.yCenter",2);
nuiDefPCtrlLoc("RBlur.iRadius",2);
nuiDefPCtrlLoc("RBlur.oRadius",2);
nuiDefPCtrlLoc("RBlur.aspectRatio",2);
nuiDefPCtrlLoc("RBlur.damp",3);
nuiDefPCtrlLoc("RBlur.amplitude",3);
nuiDefPCtrlLoc("RBlur.quality",3);
nuiDefPCtrlLoc("RBlur.mirror",3);
nuiDefTweakerCol("RBlur",1,"",10,250);
nuiDefTweakerCol("RBlur",2,"Position",10,250);
nuiDefTweakerCol("RBlur",3,"Blur",10,250);

//Sharpen
nuiDefTweakerNumCol("Sharpen",4);
nuiDefPCtrlLoc("Sharpen.xPixels",2);
nuiDefPCtrlLoc("Sharpen.yPixels",2);
nuiDefTweakerCol("Sharpen",2,"Amount",10,250);

//ZBlur
nuiDefTweakerNumCol("ZBlur",4);
nuiDefPCtrlLoc("ZBlur.amount",2);
nuiDefPCtrlLoc("ZBlur.near",3);
nuiDefPCtrlLoc("ZBlur.far",3);
nuiDefPCtrlLoc("ZBlur.focusCenter",3);
nuiDefPCtrlLoc("ZBlur.focusRange",3);
nuiDefPCtrlLoc("ZBlur.steps",4);
nuiDefPCtrlLoc("ZBlur.stepBlend",4);
nuiDefTweakerCol("ZBlur",1,"",10,250);
nuiDefTweakerCol("ZBlur",2,"Amount",10,250);
nuiDefTweakerCol("ZBlur",3,"Camera",10,250);
nuiDefTweakerCol("ZBlur",4,"Blend",10,250);

//ZDefocus
nuiDefTweakerNumCol("ZDefocus",6);
nuiDefPCtrlLoc("ZDefocus.xPixels",2);
nuiDefPCtrlLoc("ZDefocus.yPixels",2);
nuiDefPCtrlLoc("ZDefocus.channels",3);
nuiDefPCtrlLoc("ZDefocus.percent",3);
nuiDefPCtrlLoc("ZDefocus.shape",4);
nuiDefPCtrlLoc("ZDefocus.boostPoint",4);
nuiDefPCtrlLoc("ZDefocus.superWhite",4);
nuiDefPCtrlLoc("ZDefocus.near",5);
nuiDefPCtrlLoc("ZDefocus.far",5);
nuiDefPCtrlLoc("ZDefocus.focusCenter",5);
nuiDefPCtrlLoc("ZDefocus.focusRange",5);
nuiDefPCtrlLoc("ZDefocus.steps",6);
nuiDefPCtrlLoc("ZDefocus.stepBlend",6);
nuiDefTweakerCol("ZDefocus",1,"",10,50);
nuiDefTweakerCol("ZDefocus",2,"Amount",10,200);
nuiDefTweakerCol("ZDefocus",3,"Channels",10,250);
nuiDefTweakerCol("ZDefocus",4,"Highlight",10,300);
nuiDefTweakerCol("ZDefocus",5,"Camera",10,250);
nuiDefTweakerCol("ZDefocus",6,"Blend",10,250);

//ChromaKey
nuiDefTweakerNumCol("ChromaKey",4);
nuiDefPCtrlLoc("ChromaKey.hue",1);
nuiDefPCtrlLoc("ChromaKey.sat",1);
nuiDefPCtrlLoc("ChromaKey.val",1);
nuiDefPCtrlLoc("ChromaKey.matteMult",1);
nuiDefPCtrlLoc("ChromaKey.arithmetic",1);
nuiDefPCtrlLoc("ChromaKey.hueRange",2);
nuiDefPCtrlLoc("ChromaKey.hueFalloff",2);
nuiDefPCtrlLoc("ChromaKey.hueSharpness",2);
nuiDefPCtrlLoc("ChromaKey.satRange",3);
nuiDefPCtrlLoc("ChromaKey.satFalloff",3);
nuiDefPCtrlLoc("ChromaKey.satSharpness",3);
nuiDefPCtrlLoc("ChromaKey.valRange",4);
nuiDefPCtrlLoc("ChromaKey.valFalloff",4);
nuiDefPCtrlLoc("ChromaKey.valSharpness",4);


nuiDefTweakerCol("ChromaKey",1,"Key",10,350);
nuiDefTweakerCol("ChromaKey",2,"Hue",10,250);
nuiDefTweakerCol("ChromaKey",3,"Saturation",10,250);
nuiDefTweakerCol("ChromaKey",4,"Value",10,250);


//Primatte_v2
nuiDefTweakerNumCol("Primatte_v2",3);
nuiDefPCtrlLoc("Primatte_v2.clipMode",1);
nuiDefPCtrlLoc("Primatte_v2.output",1);
nuiDefPCtrlLoc("Primatte_v2.arithmetic",1);
nuiDefPCtrlLoc("Primatte_v2.processBGColor",1);
nuiDefPCtrlLoc("Primatte_v2.gMatteChannel",1);
nuiDefPCtrlLoc("Primatte_v2.hMatteChannel",1);
nuiDefPCtrlLoc("Primatte_v2.replaceMode",3);
nuiDefPCtrlLoc("Primatte_v2.rReplace",3);
nuiDefPCtrlLoc("Primatte_v2.gReplace",3);
nuiDefPCtrlLoc("Primatte_v2.bReplace",3);
nuiDefPCtrlLoc("Primatte_v2.operator",3);
nuiDefPCtrlLoc("Primatte_v2.currentOperation",3);


nuiDefTweakerCol("Primatte_v2",1,"",10,400);
nuiDefTweakerCol("Primatte_v2",2,"",10,450);
nuiDefTweakerCol("Primatte_v2",3,"",10,400);

//Constraint
nuiDefTweakerNumCol("Constraint",5);
nuiDefPCtrlLoc("Constraint.clipMode",1);
nuiDefPCtrlLoc("Constraint.invert",1);
nuiDefPCtrlLoc("Constraint.type",1);
nuiDefPCtrlLoc("Constraint.left",3);
nuiDefPCtrlLoc("Constraint.right",3);
nuiDefPCtrlLoc("Constraint.top",3);
nuiDefPCtrlLoc("Constraint.bottom",3);
nuiDefPCtrlLoc("Constraint.rTol",5);
nuiDefPCtrlLoc("Constraint.gTol",5);
nuiDefPCtrlLoc("Constraint.bTol",5);
nuiDefPCtrlLoc("Constraint.aTol",5);
nuiDefPCtrlLoc("Constraint.thresholdType",5);
nuiDefPCtrlLoc("Constraint.tReplace",5);
nuiDefPCtrlLoc("Constraint.channels",1);
nuiDefPCtrlLoc("Constraint.field",1);

nuiDefTweakerCol("Constraint",1,"",10,450);
nuiDefTweakerCol("Constraint",2,"",10,20);
nuiDefTweakerCol("Constraint",4,"",10,20);
nuiDefTweakerCol("Constraint",3,"Area",10,250);
nuiDefTweakerCol("Constraint",5,"Tolerance",10,250);

//LayerMacro
nuxDefMultiChoice("Layer.operation",  "Atop|Common|Constraint|Copy|IAdd|IDiv|IMult|Inside|ISub|ISubA|Max|Min|Mix|Over|Outside|Screen|SwitchMatte|Under|Xor|ZCompose",1 ) ; 
/*
nuxDefRadioBtnCtrl("LayerMacro.operation",1, 1, 0,
		   "Over|ux/function/layer.over", 
		   "Under|ux/function/layer.under", 
		   "Inside|ux/function/layer.inside", 
		   "Outside|ux/function/layer.outside", 
		   "Atop|ux/function/layer.atop", 
		   "Screen|ux/function/layer.screen", 
		   "IDiv|ux/function/layer.idiv", 
		   "IAdd|ux/function/layer.iadd", 
		   "IMult|ux/function/layer.imult", 
		   "ISub|ux/function/layer.isub", 
		   "ISubA|ux/function/layer.isuba", 
		   "Mix|ux/function/layer.mix", 
		   "Min|ux/function/layer.min", 
		   "Max|ux/function/layer.max", 
		   "Foreground|ux/function/layer.fg", 
		   "Background|ux/function/layer.bg", 
		   "Modified Foreground|ux/function/layer.modfg", 
		   "Modified Background|ux/function/layer.modbg" 
		   );

*/

nuxDefRadioBtnCtrl("LogLin.conversion",1, 1, 0,
		   "0|ux/radio/radio_log2lin",
		   "1|ux/radio/radio_lin2log"
		   );

//nuiDefPCtrlLoc("LayerMacro.operation",1);
//nuiDefPCtrlLoc("LayerMacro.preMultiply",3);
//why isn't the above working?
nuiDefTweakerCol("LayerMacro",1,"Transfer Modes",10,1220);
nuiDefTweakerNumCol("LayerMacro",2);

//CameraShake
nuiDefPCtrlLoc("CameraShake.xFrequency",2);
nuiDefPCtrlLoc("CameraShake.yFrequency",2);
nuiDefPCtrlLoc("CameraShake.xAmplitude",3);
nuiDefPCtrlLoc("CameraShake.yAmplitude",3);
nuiDefTweakerCol("CameraShake",2,"",10,350);
nuiDefTweakerCol("CameraShake",3,"",10,350);
nuiDefTweakerCol("CameraShake",4,"",10,550);
nuiDefTweakerNumCol("CameraShake",5);

//CornerPin
nuiDefTweakerNumCol("CornerPin",6);
nuiDefPCtrlLoc("CornerPin.x0",2);
nuiDefPCtrlLoc("CornerPin.y0",2);
nuiDefPCtrlLoc("CornerPin.x1",3);
nuiDefPCtrlLoc("CornerPin.y1",3);
nuiDefPCtrlLoc("CornerPin.x2",4);
nuiDefPCtrlLoc("CornerPin.y2",4);
nuiDefPCtrlLoc("CornerPin.x3",5);
nuiDefPCtrlLoc("CornerPin.y3",5);
nuiDefPCtrlLoc("CornerPin.xFilter",6);
nuiDefPCtrlLoc("CornerPin.yFilter",6);
nuiDefPCtrlLoc("CornerPin.inverseTransform",6);
nuiDefPCtrlLoc("CornerPin.antialiasing",6);
nuiDefPCtrlLoc("CornerPin.motionBlur",6);
nuiDefPCtrlLoc("CornerPin.useReference",6);
nuiDefPCtrlLoc("CornerPin.referenceFrame",6);

nuiDefTweakerCol("CornerPin",1,"",10,20);
nuiDefTweakerCol("CornerPin",2,"LL",10,200);
nuiDefTweakerCol("CornerPin",3,"LR",10,200);
nuiDefTweakerCol("CornerPin",4,"UR",10,200);
nuiDefTweakerCol("CornerPin",5,"UL",10,200);
nuiDefTweakerCol("CornerPin",6,"",10,350);


//Fit
nuiDefTweakerNumCol("Fit",3);
nuiDefPCtrlLoc("Fit.xSize",2);
nuiDefPCtrlLoc("Fit.ySize",2);
nuiDefTweakerCol("Fit",1,"",10,250);
nuiDefTweakerCol("Fit",2,"Resolution",10,250);

//MatchMove
nuiDefTweakerNumCol("MatchMove",5);
nuiDefPCtrlLoc("MatchMove.applyTransform",2);
nuiDefPCtrlLoc("MatchMove.trackType",2);
nuiDefPCtrlLoc("MatchMove.applyX",2);
nuiDefPCtrlLoc("MatchMove.applyY",2);
nuiDefPCtrlLoc("MatchMove.applyScale",2);
nuiDefPCtrlLoc("MatchMove.applyRotate",2);
nuiDefPCtrlLoc("MatchMove.source1XPosition",2);
nuiDefPCtrlLoc("MatchMove.xFilter",3);
nuiDefPCtrlLoc("MatchMove.yFilter",3);
nuiDefPCtrlLoc("MatchMove.motionBlur",3);
nuiDefPCtrlLoc("MatchMove.refFrame",3);
nuiDefPCtrlLoc("MatchMove.outputType",3);
nuiDefPCtrlLoc("MatchMove.clipMode",3);
nuiDefPCtrlLoc("MatchMove.trackRange",2);
nuiDefPCtrlLoc("MatchMove.subPixelResolution",4);
nuiDefPCtrlLoc("MatchMove.matchSpace",4);
nuiDefPCtrlLoc("MatchMove.referenceTolerance",4);
nuiDefPCtrlLoc("MatchMove.referenceBehavior",4);
nuiDefPCtrlLoc("MatchMove.failureTolerance",4);
nuiDefPCtrlLoc("MatchMove.failureBehavior",4);
nuiDefPCtrlLoc("MatchMove.limitProcessing",2);
nuiDefTweakerCol("MatchMove",1,"",8,20);
nuiDefTweakerCol("MatchMove",2,"Track Controls",8,280,300);
nuiDefTweakerCol("MatchMove",3,"Xform,Comp Controls",8,280,400);
nuiDefTweakerCol("MatchMove",4,"Tolerance",8,370,400);
nuiDefTweakerCol("MatchMove",5,"Tracks",8,300,400);

//Move2D
nuiDefTweakerNumCol("Move2D",6);
nuiDefPCtrlLoc("Move2D.xPan",2);
nuiDefPCtrlLoc("Move2D.yPan",2);
nuiDefPCtrlLoc("Move2D.angle",3);
nuiDefPCtrlLoc("Move2D.aspectRatio",3);
nuiDefPCtrlLoc("Move2D.xScale",4);
nuiDefPCtrlLoc("Move2D.yScale",4);
nuiDefPCtrlLoc("Move2D.xShear",5);
nuiDefPCtrlLoc("Move2D.yShear",5);
nuiDefTweakerCol("Move2D",1,"",10,20);
nuiDefTweakerCol("Move2D",2,"Translate",10,220);
nuiDefTweakerCol("Move2D",3,"Rotate",10,220);
nuiDefTweakerCol("Move2D",4,"Scale",10,220);
nuiDefTweakerCol("Move2D",5,"Shear",10,220);


//Move3D
nuiDefTweakerNumCol("Move3D",6);
nuiDefPCtrlLoc("Move3D.xPan",2);
nuiDefPCtrlLoc("Move3D.yPan",2);
nuiDefPCtrlLoc("Move3D.zPan",2);
nuiDefPCtrlLoc("Move3D.xAngle",3);
nuiDefPCtrlLoc("Move3D.yAngle",3);
nuiDefPCtrlLoc("Move3D.zAngle",3);
nuiDefPCtrlLoc("Move3D.xScale",4);
nuiDefPCtrlLoc("Move3D.yScale",4);
nuiDefPCtrlLoc("Move3D.zScale",4);
nuiDefPCtrlLoc("Move3D.aspectRatio",6);
nuiDefTweakerCol("Move3D",1,"",10,100);
nuiDefTweakerCol("Move3D",2,"Translate",10,250);
nuiDefTweakerCol("Move3D",3,"Rotate",10,250);
nuiDefTweakerCol("Move3D",4,"Scale",10,250);
nuiDefTweakerCol("Move3D",5,"",10,75);



//Pan
nuiDefTweakerNumCol("Pan",3);
nuiDefPCtrlLoc("Pan.xPan",2);
nuiDefPCtrlLoc("Pan.yPan",2);

nuiDefTweakerCol("Pan",1,"",10,250);
nuiDefTweakerCol("Pan",2,"Move",10,250);

//Rotate
nuiDefTweakerNumCol("Rotate",3);
nuiDefPCtrlLoc("Rotate.angle",2);

nuiDefTweakerCol("Rotate",1,"",10,250);
nuiDefTweakerCol("Rotate",2,"Angle",10,250);

//Resize
nuiDefTweakerNumCol("Resize",3);
nuiDefPCtrlLoc("Resize.xSize",2);
nuiDefPCtrlLoc("Resize.ySize",2);

nuiDefTweakerCol("Resize",1,"",10,250);
nuiDefTweakerCol("Resize",2,"Resolution",10,250);

//Scale
nuiDefTweakerNumCol("Scale",3);
nuiDefPCtrlLoc("Scale.xScale",2);
nuiDefPCtrlLoc("Scale.yScale",2);
nuiDefTweakerCol("Scale",1,"",10,250);
nuiDefTweakerCol("Scale",2,"Scale Amount",10,250);

//Shear
nuiDefTweakerNumCol("Shear",3);
nuiDefPCtrlLoc("Shear.xShear",2);
nuiDefPCtrlLoc("Shear.yShear",2);

nuiDefTweakerCol("Shear",1,"",10,250);
nuiDefTweakerCol("Shear",2,"Amount",10,250);

nuiDefTweakerNumCol("Stabilize",5);
nuiDefPCtrlLoc("Stabilize.applyTransform",2);
nuiDefPCtrlLoc("Stabilize.inverseTransform",2);
nuiDefPCtrlLoc("Stabilize.trackType",2);
nuiDefPCtrlLoc("Stabilize.applyX",2);
nuiDefPCtrlLoc("Stabilize.applyY",2);
nuiDefPCtrlLoc("Stabilize.applyScale",2);
nuiDefPCtrlLoc("Stabilize.applyRotate",2);
nuiDefPCtrlLoc("Stabilize.source1XPosition",2);
nuiDefPCtrlLoc("Stabilize.xFilter",3);
nuiDefPCtrlLoc("Stabilize.yFilter",3);
nuiDefPCtrlLoc("Stabilize.transformationOrder",3);
nuiDefPCtrlLoc("Stabilize.motionBlur",3);
nuiDefPCtrlLoc("Stabilize.refFrame",3);
nuiDefPCtrlLoc("Stabilize.outputType",3);
nuiDefPCtrlLoc("Stabilize.clipMode",3);
nuiDefPCtrlLoc("Stabilize.trackRange",2);
nuiDefPCtrlLoc("Stabilize.subPixelResolution",4);
nuiDefPCtrlLoc("Stabilize.matchSpace",4);
nuiDefPCtrlLoc("Stabilize.referenceTolerance",4);
nuiDefPCtrlLoc("Stabilize.referenceBehavior",4);
nuiDefPCtrlLoc("Stabilize.failureTolerance",4);
nuiDefPCtrlLoc("Stabilize.failureBehavior",4);
nuiDefPCtrlLoc("Stabilize.limitProcessing",2);
nuiDefTweakerCol("Stabilize",1,"",8,20);
nuiDefTweakerCol("Stabilize",2,"Track Controls",8,285);
nuiDefTweakerCol("Stabilize",3,"Xform,Comp Controls",8,280,400);
nuiDefTweakerCol("Stabilize",4,"Tolerance",8,370,400);
nuiDefTweakerCol("Stabilize",5,"Tracks",8,300,400);


//Tracker
nuiDefTweakerNumCol("Tracker",5);
nuiDefPCtrlLoc("Tracker.trackRange",2);
nuiDefPCtrlLoc("Tracker.subPixelResolution",4);
nuiDefPCtrlLoc("Tracker.matchSpace",4);
nuiDefPCtrlLoc("Tracker.referenceTolerance",4);
nuiDefPCtrlLoc("Tracker.referenceBehavior",4);
nuiDefPCtrlLoc("Tracker.failureTolerance",4);
nuiDefPCtrlLoc("Tracker.failureBehavior",4);
nuiDefPCtrlLoc("Tracker.limitProcessing",2);
nuiDefTweakerCol("Tracker",1,"",10,20);
nuiDefTweakerCol("Tracker",2,"Controls",10,200,300);
nuiDefTweakerCol("Tracker",3,"",10,20);
nuiDefTweakerCol("Tracker",4,"Tolerance",10,470);
nuiDefTweakerCol("Tracker",5,"Tracks",10,300,400);

//Zoom
nuiDefTweakerNumCol("Zoom",3);
nuiDefPCtrlLoc("Zoom.xScale",2);
nuiDefPCtrlLoc("Zoom.yScale",2);
nuiDefTweakerCol("Zoom",1,"",10,250);
nuiDefTweakerCol("Zoom",2,"Zoom Amount",10,250);

//IDisplace
nuiDefPCtrlLoc("IDisplace.xScale",2);
nuiDefPCtrlLoc("IDisplace.yScale",2);
nuiDefPCtrlLoc("IDisplace.xOffset",4);
nuiDefTweakerCol("IDisplace",2,"Amount",10,350);
nuiDefTweakerNumCol("IDisplace",5);

nuiDefTweakerCol("Lookup",1,"",10,150);
nuiDefTweakerNumCol("Lookup",2);
nuiDefPCtrlLoc("Lookup.rExpr",2);
nuiPushControlGroup("colorExpr");
   nuiGroupControl("Lookup.rExpr");
    nuiGroupControl("Lookup.gExpr");
    nuiGroupControl("Lookup.bExpr");
    nuiGroupControl("Lookup.aExpr");
nuiPopControlGroup();	
registerCurveFunc("colorExpr");

nuiDefTweakerCol("LookupHSV",1,"",10,150);
nuiDefTweakerNumCol("LookupHSV",2);
nuiDefPCtrlLoc("LookupHSV.hExpr",2);
nuiPushControlGroup("LookupHSV.hsvExpr");
    nuiGroupControl("LookupHSV.vExpr");
    nuiGroupControl("LookupHSV.sExpr");
    nuiGroupControl("LookupHSV.hExpr");
    nuiGroupControl("LookupHSV.aExpr");
nuiPopControlGroup();	
registerCurveFunc("LookupHSV.hsvExpr");

nuiDefTweakerCol("LookupHLS",1,"",10,150);
nuiDefTweakerNumCol("LookupHLS",2);
nuiDefPCtrlLoc("LookupHLS.hExpr",2);
nuiPushControlGroup("LookupHLS.hlsExpr");
    nuiGroupControl("LookupHLS.hExpr");
    nuiGroupControl("LookupHLS.lExpr");
    nuiGroupControl("LookupHLS.sExpr");
    nuiGroupControl("LookupHLS.aExpr");
nuiPopControlGroup();	
registerCurveFunc("LookupHLS.hlsExpr");

nuiDefTweakerNumCol("AddMix",2);
nuiDefPCtrlLoc("AddMix.background",1);
nuiPushControlGroup("AddMix.controlCurves");
    nuiGroupControl("AddMix.background");
    nuiGroupControl("AddMix.foreground");
nuiPopControlGroup();	
registerCurveFuncVisible("AddMix.controlCurves");

// AddShadow
nuiDefTweakerNumCol("AddShadow",3);
nuiDefPCtrlLoc("AddShadow.xOffset",2);
nuiDefPCtrlLoc("AddShadow.yOffset",2);
nuiDefPCtrlLoc("AddShadow.fuzziness",2);
nuiDefPCtrlLoc("AddShadow.Shadow Color",3);
nuiDefPCtrlLoc("AddShadow.opacity",3);
nuiDefTweakerCol("AddShadow",1,"",10,250);
nuiDefTweakerCol("AddShadow",2,"Controls",10,250);
nuiDefTweakerCol("AddShadow",3,"Color",10,450);

// DropShadow
nuiDefTweakerNumCol("DropShadow",3);
nuiDefPCtrlLoc("DropShadow.fuzziness",2);
nuiDefPCtrlLoc("DropShadow.Shadow Color",3);
nuiDefPCtrlLoc("DropShadow.opacity",3);
nuiDefTweakerCol("DropShadow",1,"",10,250);
nuiDefTweakerCol("DropShadow",2,"Controls",10,250);
nuiDefTweakerCol("DropShadow",3,"Color",10,450);

//Bytes
nuiDefTweakerNumCol("Bytes",2);
nuiDefPCtrlLoc("Bytes.outBytes",2);
nuiDefTweakerCol("Bytes",1,"",10,250);
nuiDefTweakerCol("Bytes",2,"Bit Depth in Bytes",10,250);


// Transition
nuiDefTweakerNumCol("Transition",5);
nuiDefTweakerCol("Transition",1,"",10,20);
nuiDefTweakerCol("Transition",2,"Controls",10,270);
nuiDefTweakerCol("Transition",3,"Mixer Controls",10,250);
nuiDefTweakerCol("Transition",4,"",10,20);
nuiDefTweakerCol("Transition",5,"",10,700);
nuiDefPCtrlLoc("Transition.overlap",2);
nuiDefPCtrlLoc("Transition.mixer",2);



// image translator pctrls
nuxDefMultiChoice("NRxQTWriter.codec",          nqtCodecList());

nuxDefMultiChoice("NRxTiffWriter.byteOrder",        {{ extern const char *nfxGetTiffByteOrders(); nfxGetTiffByteOrders(); }} );
nuxDefMultiChoice("NRxTiffWriter.orientation",        {{ extern const char *nfxGetTiffOrientations(); nfxGetTiffOrientations(); }} );
nuxDefMultiChoice("NRxTiffWriter.codec",        {{ extern const char *nfxGetTiffCodecs(); nfxGetTiffCodecs(); }} );
nuxDefRadioBtnCtrl("NRxTiffWriter.pixelFormat",0, 1, 0,
		   "as-is|as-is",
		   "rgb|rgb", 
		   "rgba|rgba"
		   );

nuxDefRadioBtnCtrl("NRxCineonWriter.pixelFormat",0, 1, 0,
		   "as-is|as-is",
		   "rgb|rgb", 
		   "rgba|rgba"
		   );
nuxDefMultiChoice("NRxCineonWriter.orientation",          {{ extern const char *nfxGetCineonOrientations(); nfxGetCineonOrientations(); }} );
nuxDefMultiChoice("NRxCineonWriter.flavor",          {{ extern const char *nfxGetCineonTypes(); nfxGetCineonTypes(); }} );
nuxDefMultiChoice("NRxCineonReader.flavor",          {{ extern const char *nfxGetCineonTypes(); nfxGetCineonTypes(); }} );

nuxDefMultiChoice("NRxYuvWriter.yuvFormat",          {{ extern const char *nfxGetYuvFormats(); nfxGetYuvFormats(); }} );
nuxDefToggle("NRxYuvWriter.yuvEncode");
nuxDefToggle("NRxYuvReader.yuvDecode");

nriDefStdPCtrl("NRxJPegWriter.quality");
nuiDefSlider("NRxJPegWriter.quality", 1, 100, 1);
nuxDefRadioBtnCtrl("NRxJPegWriter.pixelFormat",0, 1, 0,
		   "as-is|as-is",
		   "rgb|rgb"
		   );

nuxDefRadioBtnCtrl("NRxSgiWriter.pixelFormat",0, 1, 0,
		   "as-is|as-is",
		   "rgb|rgb",
		   "rgba|rgba"
		   );

nuxDefRadioBtnCtrl("NRxSgiRawWriter.pixelFormat",0, 1, 0,
		   "as-is|as-is",
		   "rgb|rgb",
		   "rgba|rgba"
		   );

nuxDefRadioBtnCtrl("NRxAliasWriter.pixelFormat",0, 1, 0,
		   "rgb|rgb",
		   "a|a"
		   );

nuxDefRadioBtnCtrl("NRxTgaWriter.pixelFormat",0, 1, 0,
		   "as-is|as-is",
		   "rgba|rgba",
		   "rgb|rgb",
		   "l|l"
		   );


// multi choice definitions
//
// Note: if you want to add your own multi-choice definition on
// a particular parameter, the syntax is:
//	nuxDefMultiChoice("name of the string parameter","choice 1|choice 2|choice 3");

//nuxDefMultiChoice("controlChannel", "A|R|G|B");
nuxDefMultiChoice("filter",	    nfxFilterList());
nuxDefMultiChoice("fileFormat",	    nfxWFormatList());
nuxDefMultiChoice("font",	    nglFontList());
nuxDefMultiChoice("kernel",	    nfxKernelList());
//nuxDefMultiChoice("keyChannel",	    "A|R|G|B");
//nuxDefMultiChoice("maskChannel",    "A|R|G|B");
//nuxDefMultiChoice("matteChannel",   "A|R|G|B");
nuxDefMultiChoice("proxyFilter",    nfxFilterList());
nuxDefMultiChoice("resolution",	    nfxVFileOutSizeList());
nuxDefMultiChoice("shape",          "fast gaussian|fast box|circle|square|hexagon|octagon");
nuxDefMultiChoice("format",	    FormatList());
nuxDefMultiChoice("xFilter",	    nfxFilterList());
//nuxDefMultiChoice("xChannel",	    "A|R|G|B");
nuxDefMultiChoice("yFilter",	    nfxFilterList());
//nuxDefMultiChoice("yChannel",	    "A|R|G|B");
nuxDefMultiChoice("variableType",   "Float|Int|String");
nuxDefMultiChoice("FileIn.fileFormat",	    nfxRFormatList());
nuxDefMultiChoice("FileOut.fileFormat",	    nfxWFormatList());
nuxDefMultiChoice("VFileIn.fileFormat",	    nfxRFormatList());
nuxDefMultiChoice("VFileOut.fileFormat",    nfxWFormatList());
nuxDefMultiChoice("exprFormat",	            CWFormatList());
//nuxDefMultiChoice("matchSpace",      "luminance|hue|saturation");
//nuxDefMultiChoice("subPixelResolution","1|1/4|1/16|1/32|1/64");
nuxDefMultiChoice("referenceBehavior","use start frame|update every frame|update from keyframes|update if above reference tolerance|update if below reference tolerance");
nuxDefMultiChoice("failureBehavior","stop|predict location and create key|predict location and don't create key|don't predict location|use existing key to predict location");
//nuxDefMultiChoice("trackType","1 point|2 point|4 point");
nuxDefMultiChoice("outputType","Foreground|Background|Atop|IAdd|IMult|Inside|ISub|ISubA|Mix|Outside|Over|Screen");
//nuxDefMultiChoice("inMode","Black|Freeze|Repeat|Mirror");
//nuxDefMultiChoice("outMode","Black|Freeze|Repeat|Mirror");
//nuxDefMultiChoice("LayerMacro.operation",  "Over|Atop|IAdd|IDiv|IMult|Inside|ISub|ISubA|Max|Min|Mix|Outside|Screen|Under|Xor|Foreground|Background|Modified Foreground|Modified Background" ) ; 
//nuxDefMultiChoice("ColorSpace.inSpace",  "rgb|cmy|hls|hsv|yiq|yuv" ) ; 
//nuxDefMultiChoice("ColorSpace.outSpace",  "rgb|cmy|hls|hsv|yiq|yuv" ) ; 
nuxDefMultiChoice("Transition.mixer",	nfxMixerList());
nuiDefSlider("mixPercent", 1, 100, 1);
nuxDefMultiChoice("timecodeMode",     TimecodeModeList());
// force timecode text fields to have no virtual sliding
nuiDefSlider("outTimecode",0,1,0,0,4);
nuiDefSlider("inTimecode", 0,1,0,0,4);
nuiDefSlider("duration",0,1,0,0,4);


// radio toggles
nuxDefRadioBtnCtrl("bytes",1,1,1,"1|ux/num.0001","2|ux/num.0002","4|ux/num.0004");
nuxDefRadioBtnCtrl("outBytes",1,1,1,"1|ux/num.0001","2|ux/num.0002","4|ux/num.0004");
nuxDefRadioBtnCtrl("defaultBytes",1,1,1,"1|ux/num.0001","2|ux/num.0002","4|ux/num.0004");
//nuxDefRadioBtnCtrl("KeyMix.channel",0, 1, 1, "R|R", "G|G", "B|B", "A|A");
nuxDefRadioBtnCtrl("proxyScale",1, 1, 0,
		   "1|ux/invNum.0001", 
		   "1/2|ux/invNum.0002", 
		   "1/3|ux/invNum.0003", 
		   "1/4|ux/invNum.0004", 
		   "1/10|ux/invNum.0010"
		   );
nuxDefRadioBtnCtrl("interactiveScale",1, 1, 0,
		   "1|ux/invNum.0001", 
		   "1/2|ux/invNum.0002", 
		   "1/3|ux/invNum.0003", 
		   "1/4|ux/invNum.0004", 
		   "1/10|ux/invNum.0010"
		   );

nuxDefRadioBtnCtrl("keyChannel",1, 1, 1, "R|ux/radio/radio_red", "G|ux/radio/radio_green", "B|ux/radio/radio_blue", "A|ux/radio/radio_alpha");
nuxDefRadioBtnCtrl("maskChannel",1, 1, 1, "R|ux/radio/radio_red", "G|ux/radio/radio_green", "B|ux/radio/radio_blue", "A|ux/radio/radio_alpha");
nuxDefRadioBtnCtrl("controlChannel",1, 1, 1, "R|ux/radio/radio_red", "G|ux/radio/radio_green", "B|ux/radio/radio_blue", "A|ux/radio/radio_alpha");
nuxDefRadioBtnCtrl("matteChannel",1, 1, 1, "R|ux/radio/radio_red", "G|ux/radio/radio_green", "B|ux/radio/radio_blue", "A|ux/radio/radio_alpha");
nuxDefRadioBtnCtrl("xChannel",1, 1, 1, "R|ux/radio/radio_red", "G|ux/radio/radio_green", "B|ux/radio/radio_blue", "A|ux/radio/radio_alpha");
nuxDefRadioBtnCtrl("yChannel",1, 1, 1, "R|ux/radio/radio_red", "G|ux/radio/radio_green", "B|ux/radio/radio_blue", "A|ux/radio/radio_alpha");
nuxDefRadioBtnCtrl("trackType",1, 1, 1, "1 point|ux/radio/radio_1point", "2 point|ux/radio/radio_2point", "4 point|ux/radio/radio_4point");
nuxDefRadioBtnCtrl("subPixelResolution",1, 1, 1, "1|ux/radio/radio_one", "1/4|ux/radio/radio_onefourth", "1/16|ux/radio/radio_onesixteen", "1/32|ux/radio/radio_onethirtytwo", "1/64|ux/radio/radio_onesixtyfour");
nuxDefRadioBtnCtrl("matchSpace",1, 1, 1, "luminance|ux/radio/radio_lum", "saturation|ux/radio/radio_sat", "hue|ux/radio/radio_hue");
nuxDefRadioBtnCtrl("inMode",1, 1, 1, "Black|ux/radio/radio_black_filein", "Freeze|ux/radio/radio_freeze", "Repeat|ux/radio/radio_repeat", "Mirror|ux/radio/radio_mirror", "InclusiveMirror|ux/radio/radio_mirrorInc");
nuxDefRadioBtnCtrl("outMode",1, 1, 1, "Black|ux/radio/radio_black_filein", "Freeze|ux/radio/radio_freeze", "Repeat|ux/radio/radio_repeat", "Mirror|ux/radio/radio_mirror", "InclusiveMirror|ux/radio/radio_mirrorInc");

nuxDefRadioBtnCtrl("Text.xAlign",1, 1, 1, "1|ux/radio/radio_left", "2|ux/radio/radio_center", "3|ux/radio/radio_right");
nuxDefRadioBtnCtrl("Text.yAlign",1, 1, 1, "1|ux/radio/radio_bottom", "2|ux/radio/radio_center", "3|ux/radio/radio_top");
nuxDefRadioBtnCtrl("ColorSpace.inSpace",1, 1, 1, "rgb|ux/radio/radio_rgb", "cmy|ux/radio/radio_cmy", "hls|ux/radio/radio_hls", "hsv|ux/radio/radio_hsv", "yiq|ux/radio/radio_yiq", "yuv|ux/radio/radio_yuv");
nuxDefRadioBtnCtrl("ColorSpace.outSpace",1, 1, 1, "rgb|ux/radio/radio_rgb", "cmy|ux/radio/radio_cmy", "hls|ux/radio/radio_hls", "hsv|ux/radio/radio_hsv", "yiq|ux/radio/radio_yiq", "yuv|ux/radio/radio_yuv");
nuxDefRadioBtnCtrl("ChromaKey.arithmetic",1, 1, 1, "0|ux/radio/radio_replace", "1|ux/radio/radio_add", "2|ux/radio/radio_subtract", "3|ux/radio/radio_multiply");
nuxDefRadioBtnCtrl("AddText.xAlign",1, 1, 1, "1|ux/radio/radio_left", "2|ux/radio/radio_center", "3|ux/radio/radio_right");
nuxDefRadioBtnCtrl("AddText.yAlign",1, 1, 1, "1|ux/radio/radio_bottom", "2|ux/radio/radio_center", "3|ux/radio/radio_top");
nuxDefRadioBtnCtrl("Common.mode",1, 1, 1, "0|ux/radio/radio_show", "1|ux/radio/radio_hide", "2|ux/radio/radio_white","3|ux/radio/radio_black","4|ux/radio/radio_proportion");
nuxDefRadioBtnCtrl("KeyMix.channel",1, 1, 1, "R|ux/radio/radio_red", "G|ux/radio/radio_green", "B|ux/radio/radio_blue", "A|ux/radio/radio_alpha");
//nuxDefRadioBtnCtrl("IDisplace.xChannel",1, 1, 1, "R|ux/radio/radio_red", "G|ux/radio/radio_green", "B|ux/radio/radio_blue", "A|ux/radio/radio_alpha");
//nuxDefRadioBtnCtrl("IDisplace.yChannel",1, 1, 1, "R|ux/radio/radio_red", "G|ux/radio/radio_green", "B|ux/radio/radio_blue", "A|ux/radio/radio_alpha");
nuxDefRadioBtnCtrl("Deinterlace.mode",1, 1, 1, "0|ux/radio/radio_replicate", "1|ux/radio/radio_interpolate", "2|ux/radio/radio_blur");
nuxDefRadioBtnCtrl("Histogram.ignore",1, 1, 1, "0|ux/radio/radio_none", "1|ux/radio/radio_zero", "2|ux/radio/radio_one", "3|ux/radio/radio_zero_one");


// Controls for EdgeDetect
nuiDefSlider("EdgeDetect.strength",0,10,0.0001);
nuiDefSlider("EdgeDetect.threshold",0,1,0.0001);
nuxDefToggle("EdgeDetect.binaryOutput");
nuxDefToggle("EdgeDetect.directionFilter");
nuiDefSlider("EdgeDetect.directionFilterAngle",-360,360,0.1);
nuiDefControlAlias("EdgeDetect.xBlur","xPixels");
nuiDefControlAlias("EdgeDetect.yBlur","yPixels");
nuiDefControlAlias("EdgeDetect.xDilateErode","DilateErode.xPixels");
nuiDefControlAlias("EdgeDetect.yDilateErode","DilateErode.yPixels");
nuiDefSlider("EdgeDetect.despeckle",0,10);
nuxDefToggle("EdgeDetect.rgbEdges");
nuxDefToggle("EdgeDetect.addEdgesToImage");
nuxDefMultiChoice("EdgeDetect.method",  "Sobel|Babu" ) ; 
nuxDefRadioBtnCtrl("colorSpace",1, 0, 0,
		   "0|ux/radio/RGB",
		   "1|ux/radio/HSV",
		   "2|ux/radio/HLS",
		   "3|ux/radio/CMY",
		   "4|ux/radio/TMV"
		   );
nuxDefRadioBtnCtrl("currentTab",1, 0, 0,
		   "0|ux/radio/master",
		   "1|ux/radio/low",
		   "2|ux/radio/medium",
		   "3|ux/radio/high",
		   "4|ux/radio/curves"
		   );
nuxDefRadioBtnCtrl("viewRange",1, 0, 0,
		   "0|ux/radio/Normal",
		   "1|ux/radio/view_low",
		   "2|ux/radio/view_mid",
		   "3|ux/radio/view_hi"
		   );

//nuxDefRadioBtnCtrl("EdgeDetect.method", 0, 1, 1, "Sobel|Sobel", "Babu|Babu");


// toggle definitions
//
// Note: to add your own toggle definition on for a particular parameter 
// with 'n' states, the syntax is:
//	for a standard toggle
//	nuxDefToggle("name of the string parameter","state1Icon.nri|state1FocusIcon.nri", ..., "stateNIcon.nri|stateNFocusIcon.nri");
//
//	or for a toggle that allows expressions
//	nuxDefExprToggle("name of the string parameter","state1Icon.nri|state1FocusIcon.nri", ..., "stateNIcon.nri|stateNFocusIcon.nri");

// standard toggle definitions
// generic
nuxDefToggle("ignoreNode");
nuxDefToggle("virtualSliderMode");
nuxDefToggle("cacheMode", "ux/none.nri|ux/none.focus.nri", "ux/read.nri|ux/read.focus.nri", "ux/regular.nri|ux/regular.focus.nri", "ux/aggressive.nri|ux/aggressive.focus.nri");
nuxDefToggle("updateMode", "ux/manual.nri|ux/manual.focus.nri", "ux/release.nri|ux/release.focus.nri", "ux/always.nri|ux/always.focus.nri");
nuxDefToggle("obeyAlpha");
// expression toggle definitions
// generic
nuxDefExprToggle("absolute");
nuxDefExprToggle("addMattes");
nuxDefExprToggle("autoAlpha");
nuxDefExprToggle("borders");
nuxDefToggle("clipMode","ux/foreground.nri|ux/foreground.focus.nri", "ux/background.nri|ux/background.focus.nri");
nuxDefExprToggle("enabled");
nuxDefExprToggle("enableMask");
nuxDefExprToggle("field", "ux/even.nri|ux/even.focus.nri", "ux/odd.nri|ux/odd.focus.nri");

//nuxDefExprToggle("fieldRendering"); todo - uncomment when icons are made
nuiDefSlider("fieldRendering", 0, 2, 1);  // todo remove me
nuiDefSlider("FileIn.deInterlacing", 0, 2, 1);  // todo replace with icons or pulldown
// Temporary buttons for field rendering - peter
nuxDefExprToggle("fieldRendering", "ux/off_field.nri|ux/off_field.focus.nri", "ux/odd_field.nri|ux/odd_field.focus.nri", "ux/even_field.nri|ux/even_field.focus.nri" );
nuxDefExprToggle("deInterlacing", "ux/off_field.nri|ux/off_field.focus.nri", "ux/odd_field.nri|ux/odd_field.focus.nri", "ux/even_field.nri|ux/even_field.focus.nri" );

nuxDefExprToggle("ignoreZero");
nuxDefExprToggle("invert");
nuxDefExprToggle("inverseTransform");
nuxDefExprToggle("invertMask");
nuxDefExprToggle("limitProcessing");
nuxDefExprToggle("matteMult");
nuxDefExprToggle("mirror");
nuxDefExprToggle("preMultiply");
nuxDefExprToggle("quality", "ux/lo.nri|ux/lo.focus.nri", "ux/hi.nri|ux/hi.focus.nri");
nuxDefExprToggle("screenColor", "ux/blue.nri|ux/blue.focus.nri", "ux/green.nri|ux/green.focus.nri");
nuxDefExprToggle("thresholdType", "ux/lo.nri|ux/lo.focus.nri", "ux/hi.nri|ux/hi.focus.nri");
nuxDefExprToggle("videoType", "ux/vr_ntsc.off.nri|ux/vr_ntsc.off.focus.nri", "ux/vr_pal.off.nri|ux/vr_pal.off.focus.nri");
nuxDefExprToggle("processingType", "ux/luminance.nri|ux/luminance.focus.nri", "ux/saturation.nri|ux/saturation.focus.nri");
nuxDefExprToggle("writeFileOuts");
nuxDefRadioBtnOCtrl("renderFileOuts", 1, 1, 0, "1|requester/render_all_fileouts", "0|requester/render_select_fileouts");
nuxDefToggle("NRiRenderWinNode.quality", "ux/lo.nri|ux/lo.focus.nri", "ux/hi.nri|ux/hi.focus.nri");
nuxDefToggle("applyViewerScript");
nuxDefToggle("updateFromGlobals");
nuxDefExprToggle("useReference");
nuxDefExprToggle("applyTransform");
nuxDefRadioBtnCtrl("distributeRender",1, 1, 0, "0|ux/radio/radio_off", "1|ux/radio/radio_on");

nuxDefExprToggle("applyX");
nuxDefExprToggle("applyY");
nuxDefExprToggle("applyRotate");
nuxDefExprToggle("applyScale");
// specific
nuxDefExprToggle("ApplyFilter.spread","ux/spread.0.nri|ux/spread.0.focus.nri","ux/spread.1.nri|ux/spread.1.focus.nri");
nuxDefExprToggle("Blur.spread","ux/spread.0.nri|ux/spread.0.focus.nri","ux/spread.1.nri|ux/spread.1.focus.nri");
nuxDefExprToggle("Common.mode", "ux/show.nri|ux/show.focus.nri","ux/hide.nri|ux/hide.focus.nri","ux/white.nri|ux/white.focus.nri", "ux/black.nri|ux/black.focus.nri","ux/proportional.nri|ux/proportional.focus.nri");
nuxDefExprToggle("Constraint.tReplace", "ux/pixel.nri|ux/pixel.focus.nri", "ux/channel.nri|ux/channel.focus.nri");
nuxDefExprToggle("Deinterlace.mode", "ux/replicate.nri|ux/replicate.focus.nri","ux/interpolate.nri|ux/interpolate.focus.nri","ux/blur.nri|ux/blur.focus.nri");
nuxDefExprToggle("DepthSlice.grad");
nuxDefExprToggle("DepthSlice.mirror");
nuxDefExprToggle("DilateErode.soften");
nuxDefExprToggle("IDilateErode.soften");
nuxDefExprToggle("Histogram.ignore","ux/histo.none.nri|ux/histo.none.focus.nri","ux/histo.zero.nri|ux/histo.zero.focus.nri","ux/histo.one.nri|ux/histo.one.focus.nri","ux/histo.zero_one.nri|ux/histo.zero_one.focus.nri");
nuxDefExprToggle("Histogram.maxPerChannel");
nuxDefExprToggle("IBlur.spread","ux/spread.0.nri|ux/spread.0.focus.nri","ux/spread.1.nri|ux/spread.1.focus.nri");
nuxDefExprToggle("Interlace.mode","ux/replace.nri|ux/replace.focus.nri", "ux/merge.nri|ux/merge.focus.nri");
nuxDefExprToggle("Median.thresholdType");
nuxDefExprToggle("PullDown.dominance", "ux/even.nri|ux/even.focus.nri", "ux/odd.nri|ux/odd.focus.nri");
nuxDefExprToggle("PullUp.dominance", "ux/even.nri|ux/even.focus.nri", "ux/odd.nri|ux/odd.focus.nri");
nuxDefExprToggle("Ramp.orientation","ux/vertical.nri|ux/vertical.focus.nri","ux/horizontal.nri|ux/horizontal.focus.nri");
nuxDefExprToggle("RBlur.mirror");
nuxDefExprToggle("SwitchMatte.invertMatte");
nuxDefExprToggle("Xor.useMatte");
nuxDefExprToggle("Fit.preCrop");
nuxDefExprToggle("RangeMatch.matchHi");
nuxDefExprToggle("RangeMatch.matchLo");
nuxDefExprToggle("RangeMatch.transformSource", "ux/rgb_long.nri|ux/rgb_long.focus.nri", "ux/luminance.nri|ux/luminance.focus.nri");
nuxDefExprToggle("chartOvelay", "ux/video.nri|ux/video.focus.nri", "ux/oneEightFive.nri|ux/oneEightFive.focus.nri");
nuxDefExprToggle("ViewerScript1_.chartOverlay", "ux/video.nri|ux/video.focus.nri", "ux/oneEightFive.nri|ux/oneEightFive.focus.nri","ux/off_word.nri|ux/off_word.focus.nri"); 
nuxDefExprToggle("ViewerScript1_.videoSafe");
nuxDefExprToggle("ViewerScript1_.matteOverlay");
//nuxDefExprToggle("LayerMacro.ignoreZero");
//nuxDefExprToggle("LayerMacro.preMultiply");
//nuxDefExprToggle("LayerMacro.addMattes");
//nuxDefExprToggle("LayerMacro.useMatte");
//nuxDefExprToggle("Track.updateReference");
nuxDefExprToggle("MatchMove.applyTransform","ux/applytransform.off.nri|ux/applytransform.off.focus.nri","ux/applytransform.on.nri|ux/applytransform.on.focus.nri");
nuxDefExprToggle("Stabilize.applyTransform","ux/applytransform.off.nri|ux/applytransform.off.focus.nri","ux/applytransform.on.nri|ux/applytransform.on.focus.nri");
nuxDefRadioBtnCtrl("Stabilize.inverseTransform",1, 1, 1, "0|ux/radio/Stabilize", "1|ux/radio/MatchMove");
nuxDefExprToggle("Orient.flip","ux/radio/xy_control.y.nri|ux/radio/xy_control.y.focus.nri","ux/radio/xy_control.y.down.nri|ux/radio/xy_control.y.down.focus.nri");
nuxDefExprToggle("Orient.flop","ux/radio/xy_control.x.nri|ux/radio/xy_control.x.focus.nri","ux/radio/xy_control.x.down.nri|ux/radio/xy_control.x.down.focus.nri");
nuxDefRadioBtnCtrl("Orient.nTurn",1, 1, 1,
	"0|ux/radio/nturn.0",
	"1|ux/radio/nturn.1",
	"2|ux/radio/nturn.2",
	"3|ux/radio/nturn.3"
);


// browse ctrl
nuxDefBrowseCtrl("Average.imageName",	kImageIn);
nuxDefBrowseCtrl("Commit.cachePath",	kDirOut);
nuxDefBrowseCtrl("FileIn.imageName",	kImageIn);
nuxDefBrowseCtrl("FileOut.imageName",	kImageOut);
nuxDefBrowseCtrl("PullDown.imageName",	kImageIn);
nuxDefBrowseCtrl("PullUp.imageName",	kImageIn);
nuxDefBrowseCtrl("fileName",		kAnyIn);
nuxDefBrowseCtrl("imageName",		kImageIn);
nuxDefBrowseCtrl("lookupFile",		kExprIn);
nuxDefBrowseCtrl("scriptName",		kScriptIn);
nuxDefBrowseCtrl("renderPath",          kAnyOut);

// standard plug controls
nriDefStdPCtrl("RBlur.quality");
nriDefStdPCtrl("Average.scale");

//#if 0 // not for 2.30 release
// QuickPaint
nuiDefTweakerNumCol("QuickPaint",2);
nuiDefTweakerCol("QuickPaint",1,"",10,850);
nuiDefTweakerCol("QuickPaint",2,"",10,350);
nuxDefToggle("QuickPaint.constPressure");
nuxDefToggle("QuickPaint.compressSave");
nuiDefSlider("QuickPaint.maxPressure",		    1,	100, 0, 1);
nuiDefSlider("QuickPaint.snapshotInterval",	    1,	100, 0, 1);

nuiDefTweakerNumCol("QPPaint", 2);
nuiDefTweakerCol("QPPaint",0,"",10,10);
nuiDefTweakerCol("QPPaint",1,"",10,400);
nuiDefTweakerCol("QPPaint",2,"",10,400);
nuiDefSlider("QPPaint.brushSize",                   1,  100, 0, 1);

nuiDefTweakerNumCol("QPEdit", 2);
nuiDefTweakerCol("QPEdit",0,"",10,10);
nuiDefTweakerCol("QPEdit",1,"",10,400);
nuiDefTweakerCol("QPEdit",2,"",10,400);
nuiDefSlider("QPEdit.startPoint",                   0,  100, 0, 1);
nuiDefSlider("QPEdit.endPoint",                     0,  100, 0, 1);
nuiDefSlider("QPEdit.brushSize",                    1,  100, 0, 1);

nuiDefTweakerNumCol("QPGlobals", 1);
nuiDefTweakerCol("QPGlobals",0,"",10,10);
nuiDefTweakerCol("QPGlobals",1,"",10,300);
//#endif

// Color Match
nuiPushControlGroup("lowSource");
    nuiGroupControl("ColorMatch.rLowS");
    nuiGroupControl("ColorMatch.gLowS");
    nuiGroupControl("ColorMatch.bLowS");
    nuiGroupControl("ColorMatch.aLowS");
nuiPopControlGroup();

nuiPushControlGroup("lowDest");
    nuiGroupControl("ColorMatch.rLowD");
    nuiGroupControl("ColorMatch.gLowD");
    nuiGroupControl("ColorMatch.bLowD");
	nuiGroupControl("ColorMatch.aLowD");
nuiPopControlGroup();

nuiPushControlGroup("midSource");
    nuiGroupControl("ColorMatch.rMidS");
    nuiGroupControl("ColorMatch.gMidS");
    nuiGroupControl("ColorMatch.bMidS");
	nuiGroupControl("ColorMatch.aMidS");
nuiPopControlGroup();

nuiPushControlGroup("midDest");
    nuiGroupControl("ColorMatch.rMidD");
    nuiGroupControl("ColorMatch.gMidD");
    nuiGroupControl("ColorMatch.bMidD");
	nuiGroupControl("ColorMatch.aMidD");
nuiPopControlGroup();

nuiPushControlGroup("highSource");
    nuiGroupControl("ColorMatch.rHighS");
    nuiGroupControl("ColorMatch.gHighS");
    nuiGroupControl("ColorMatch.bHighS");
    nuiGroupControl("ColorMatch.aHighS");
nuiPopControlGroup();

nuiPushControlGroup("highDest");
    nuiGroupControl("ColorMatch.rHighD");
    nuiGroupControl("ColorMatch.gHighD");
    nuiGroupControl("ColorMatch.bHighD");
    nuiGroupControl("ColorMatch.aHighD");
nuiPopControlGroup();

nuiPushControlWidget("lowSource",nuiConnectColorTriplet(kRGBToggle, kAverageColor, 0 ));
nuiPushControlWidget("lowDest",nuiConnectColorTriplet(kRGBToggle, kAverageColor, 0 ));
nuiPushControlWidget("midSource",nuiConnectColorTriplet(kRGBToggle, kAverageColor, 0 ));
nuiPushControlWidget("midDest",nuiConnectColorTriplet(kRGBToggle, kAverageColor, 0 ));
nuiPushControlWidget("highSource",nuiConnectColorTriplet(kRGBToggle, kAverageColor, 0 ));
nuiPushControlWidget("highDest",nuiConnectColorTriplet(kRGBToggle, kAverageColor, 0 ));

nuiPushControlGroup("Contrast");
    nuiGroupControl("ColorMatch.rContrast");
    nuiGroupControl("ColorMatch.gContrast");
    nuiGroupControl("ColorMatch.bContrast");
    nuiGroupControl("ColorMatch.aContrast");
nuiPopControlGroup();

nuiPushControlGroup("Gamma");
    nuiGroupControl("ColorMatch.rGamma");
    nuiGroupControl("ColorMatch.gGamma");
    nuiGroupControl("ColorMatch.bGamma");
    nuiGroupControl("ColorMatch.aGamma");
nuiPopControlGroup();

nuiPushControlGroup("Mult");
    nuiGroupControl("ColorMatch.rMult");
    nuiGroupControl("ColorMatch.gMult");
    nuiGroupControl("ColorMatch.bMult");
    nuiGroupControl("ColorMatch.aMult");
nuiPopControlGroup();

nuiPushControlGroup("Add");
    nuiGroupControl("ColorMatch.rAdd");
    nuiGroupControl("ColorMatch.gAdd");
    nuiGroupControl("ColorMatch.bAdd");
    nuiGroupControl("ColorMatch.aAdd");
nuiPopControlGroup();

nuiPushControlWidget("Contrast",nuiConnectColorTriplet());
nuiPushControlWidget("Gamma",nuiConnectColorTriplet());
nuiPushControlWidget("Mult",nuiConnectColorTriplet());
nuiPushControlWidget("Add",nuiConnectColorTriplet());

// Color corrector
nuiPushControlGroup("ColorCorrect.masterControls");
    nuiGroupControl("ColorCorrect.rContrast");
    nuiGroupControl("ColorCorrect.gContrast");
    nuiGroupControl("ColorCorrect.bContrast");
    nuiGroupControl("ColorCorrect.aContrast");
    nuiGroupControl("ColorCorrect.rCenter");
    nuiGroupControl("ColorCorrect.gCenter");
    nuiGroupControl("ColorCorrect.bCenter");
    nuiGroupControl("ColorCorrect.aCenter");
    nuiGroupControl("ColorCorrect.rSoftClip");
    nuiGroupControl("ColorCorrect.gSoftClip");
    nuiGroupControl("ColorCorrect.bSoftClip");
    nuiGroupControl("ColorCorrect.aSoftClip");
    nuiGroupControl("ColorCorrect.rGamma");
    nuiGroupControl("ColorCorrect.gGamma");
    nuiGroupControl("ColorCorrect.bGamma");
    nuiGroupControl("ColorCorrect.aGamma");
    nuiGroupControl("ColorCorrect.rGain");
    nuiGroupControl("ColorCorrect.gGain");
    nuiGroupControl("ColorCorrect.bGain");
    nuiGroupControl("ColorCorrect.aGain");
    nuiGroupControl("ColorCorrect.rAdd");
    nuiGroupControl("ColorCorrect.gAdd");
    nuiGroupControl("ColorCorrect.bAdd");
    nuiGroupControl("ColorCorrect.aAdd");
nuiPopControlGroup();

nuiPushControlGroup("ColorCorrect.lowControls");
    nuiGroupControl("ColorCorrect.rlContrast");
    nuiGroupControl("ColorCorrect.glContrast");
    nuiGroupControl("ColorCorrect.blContrast");
    nuiGroupControl("ColorCorrect.alContrast");
    nuiGroupControl("ColorCorrect.rlCenter");
    nuiGroupControl("ColorCorrect.glCenter");
    nuiGroupControl("ColorCorrect.blCenter");
    nuiGroupControl("ColorCorrect.alCenter");
    nuiGroupControl("ColorCorrect.rlSoftClip");
    nuiGroupControl("ColorCorrect.glSoftClip");
    nuiGroupControl("ColorCorrect.blSoftClip");
    nuiGroupControl("ColorCorrect.alSoftClip");
    nuiGroupControl("ColorCorrect.rlGamma");
    nuiGroupControl("ColorCorrect.glGamma");
    nuiGroupControl("ColorCorrect.blGamma");
    nuiGroupControl("ColorCorrect.alGamma");
    nuiGroupControl("ColorCorrect.rlGain");
    nuiGroupControl("ColorCorrect.glGain");
    nuiGroupControl("ColorCorrect.blGain");
    nuiGroupControl("ColorCorrect.alGain");
    nuiGroupControl("ColorCorrect.rlAdd");
    nuiGroupControl("ColorCorrect.glAdd");
    nuiGroupControl("ColorCorrect.blAdd");
    nuiGroupControl("ColorCorrect.alAdd");
nuiPopControlGroup();
nuiPushControlGroup("ColorCorrect.midControls");
    nuiGroupControl("ColorCorrect.rmContrast");
    nuiGroupControl("ColorCorrect.gmContrast");
    nuiGroupControl("ColorCorrect.bmContrast");
    nuiGroupControl("ColorCorrect.amContrast");
    nuiGroupControl("ColorCorrect.rmCenter");
    nuiGroupControl("ColorCorrect.gmCenter");
    nuiGroupControl("ColorCorrect.bmCenter");
    nuiGroupControl("ColorCorrect.amCenter");
    nuiGroupControl("ColorCorrect.rmSoftClip");
    nuiGroupControl("ColorCorrect.gmSoftClip");
    nuiGroupControl("ColorCorrect.bmSoftClip");
    nuiGroupControl("ColorCorrect.amSoftClip");
    nuiGroupControl("ColorCorrect.rmGamma");
    nuiGroupControl("ColorCorrect.gmGamma");
    nuiGroupControl("ColorCorrect.bmGamma");
    nuiGroupControl("ColorCorrect.amGamma");
    nuiGroupControl("ColorCorrect.rmGain");
    nuiGroupControl("ColorCorrect.gmGain");
    nuiGroupControl("ColorCorrect.bmGain");
    nuiGroupControl("ColorCorrect.amGain");
    nuiGroupControl("ColorCorrect.rmAdd");
    nuiGroupControl("ColorCorrect.gmAdd");
    nuiGroupControl("ColorCorrect.bmAdd");
    nuiGroupControl("ColorCorrect.amAdd");
nuiPopControlGroup();
nuiPushControlGroup("ColorCorrect.highControls");
    nuiGroupControl("ColorCorrect.rhContrast");
    nuiGroupControl("ColorCorrect.ghContrast");
    nuiGroupControl("ColorCorrect.bhContrast");
    nuiGroupControl("ColorCorrect.ahContrast");
    nuiGroupControl("ColorCorrect.rhCenter");
    nuiGroupControl("ColorCorrect.ghCenter");
    nuiGroupControl("ColorCorrect.bhCenter");
    nuiGroupControl("ColorCorrect.ahCenter");
    nuiGroupControl("ColorCorrect.rhSoftClip");
    nuiGroupControl("ColorCorrect.ghSoftClip");
    nuiGroupControl("ColorCorrect.bhSoftClip");
    nuiGroupControl("ColorCorrect.ahSoftClip");
    nuiGroupControl("ColorCorrect.rhGamma");
    nuiGroupControl("ColorCorrect.ghGamma");
    nuiGroupControl("ColorCorrect.bhGamma");
    nuiGroupControl("ColorCorrect.ahGamma");
    nuiGroupControl("ColorCorrect.rhGain");
    nuiGroupControl("ColorCorrect.ghGain");
    nuiGroupControl("ColorCorrect.bhGain");
    nuiGroupControl("ColorCorrect.ahGain");
    nuiGroupControl("ColorCorrect.rhAdd");
    nuiGroupControl("ColorCorrect.ghAdd");
    nuiGroupControl("ColorCorrect.bhAdd");
    nuiGroupControl("ColorCorrect.ahAdd");
nuiPopControlGroup();
nuiPushControlGroup("ColorCorrect.SourceColor");
    nuiGroupControl("ColorCorrect.rSource");
    nuiGroupControl("ColorCorrect.gSource");
    nuiGroupControl("ColorCorrect.bSource");
nuiPopControlGroup();
nuiPushControlGroup("ColorCorrect.ReplaceColor");
    nuiGroupControl("ColorCorrect.rReplace");
    nuiGroupControl("ColorCorrect.gReplace");
    nuiGroupControl("ColorCorrect.bReplace");
nuiPopControlGroup();



// primatte
nuxDefRadioBtnOCtrl("gMatteChannel",1, 1, 0, "r|ux/radio/radio_red", "g|ux/radio/radio_green", "b|ux/radio/radio_blue", "a|ux/radio/radio_alpha");
nuxDefRadioBtnOCtrl("hMatteChannel",1, 1, 0, "r|ux/radio/radio_red", "g|ux/radio/radio_green", "b|ux/radio/radio_blue", "a|ux/radio/radio_alpha");
nuiDefTweakerNumCol("Primatte_v2",3);
nuxDefRadioBtnOCtrl("Primatte_v2.arithmetic",1, 1, 0, "0|ux/radio/radio_replace", "1|ux/radio/radio_add", "2|ux/radio/radio_subtract", "3|ux/radio/radio_multiply");
nuxDefRadioBtnOCtrl("Primatte_v2.replaceMode",1, 1, 0, "0|ux/function/prim_useImage", "1|ux/function/prim_useColor");
nuxDefRadioBtnOCtrl("Primatte_v2.output",1, 1, 0, "0|ux/function/primatte.matte", "1|ux/function/primatte.fgmatte", "2|ux/function/primatte.composite", "3|ux/function/primatte.status");
nuxDefToggle("Primatte_v2.processBGColor");
//nuiPushControlGroup("Primatte_v2.Replace Color");
//    nuiGroupControl("Primatte_v2.rReplace");
//    nuiGroupControl("Primatte_v2.gReplace");
//    nuiGroupControl("Primatte_v2.bReplace");
//nuiPopControlGroup();
//nuiPushControlWidget("Primatte_v2.Replace Color",nuiConnectColorTriplet());

// mandelbrot
nuiPushControlGroup("Mandelbrot.color");
    nuiGroupControl("Mandelbrot.red");
    nuiGroupControl("Mandelbrot.green");
    nuiGroupControl("Mandelbrot.blue");
nuiPopControlGroup();
nuiPushControlWidget("Mandelbrot.color",nuiConnectColorTriplet());
nuiDefSlider("Mandelbrot.iterations",	1,1000);
nuiDefSlider("Mandelbrot.offsetX",-width/2,width/2);
nuiDefSlider("Mandelbrot.offsetY",-height/2,height/2);
nuiDefSlider("Mandelbrot.zoom",	0,100);
nuxDefButtonCtrl("Mandelbrot.addColor");
nuxDefButtonCtrl("Mandelbrot.deleteColor");

// julia
nuiPushControlGroup("Julia.color");
    nuiGroupControl("Julia.red");
    nuiGroupControl("Julia.green");
    nuiGroupControl("Julia.blue");
nuiPopControlGroup();
nuiPushControlWidget("Julia.color",nuiConnectColorTriplet());
nuiDefSlider("Julia.iterations",	1,1000);
nuiDefSlider("Julia.offsetX",-width/2,width/2);
nuiDefSlider("Julia.offsetY",-height/2,height/2);
nuiDefSlider("Julia.constantReal",-3,3);
nuiDefSlider("Julia.constantImaginary",-3,3);
nuiDefSlider("Julia.zoom",	0,100);
nuxDefButtonCtrl("Julia.addColor");
nuxDefButtonCtrl("Julia.deleteColor");


nuiPushControlWidget("SourceColor",nuiConnectColorTriplet());
nuiPushControlWidget("ReplaceColor",nuiConnectColorTriplet());
nuxDefToggle( "rInvert" );
nuxDefToggle( "gInvert" );
nuxDefToggle( "bInvert" );
nuxDefToggle( "aInvert" );
nuxDefToggle( "affectAlpha" );
nuiDefTweakerNumCol("ColorCorrect",1);

nuxDefRadioBtnCtrl("preMultiplied",0, 1, 0,
		   "1|no",
		   "2|yes"
		   );

// SGI Writer
nuxDefToggle( "NRxSgiWriter.compression" );

// This sets the maximum displayable image size. It doesn't affect processing
// or FileOuts and is intended to be a safety measure only.

gui.viewer.maxWidth = 4096;
gui.viewer.maxHeight = 4096;

// seconds between autosaves

script.autoSaveDelay= 60;

// Number of undo levels

gui.numUndoLevels= 100;

// Text for infinite time values

timeRange.infiniteOPoint = "inf";
timeRange.infiniteIPoint = "-inf";

// More ViewerScript slider ranges

nuiDefSlider("ViewerScript1_.viewerGamma",	0,	2.2,	0,0,.1);
nuiDefSlider("ViewerScript2_.viewerGamma",	0,	2.2,	0,0,.1);

nuiDefSlider("ViewerScript2_.rOffset",	-180,	180,	0,0,1);
nuiDefSlider("ViewerScript2_.gOffset",	-180,	180,	0,0,1);
nuiDefSlider("ViewerScript2_.bOffset",	-180,	180,	0,0,1);
nuiDefSlider("ViewerScript2_.black",	0,	1023,	0,0,1);
nuiDefSlider("ViewerScript2_.white",	0,	1023,	0,0,1);
nuiDefSlider("ViewerScript2_.nGamma",	0,	2.2);
nuiDefSlider("ViewerScript2_.dGamma",	0,	2.2);
nuiDefSlider("ViewerScript2_.softClip",	0,	50,	0,0,1);

//nuxDefExprToggle("ViewerScript3_.viewerROI");

nuiDefSlider("ViewerScript3_.left",	-100,	width,	    0,  1);
nuiDefSlider("ViewerScript3_.right",	0,	width+100,  0,  1);
nuiDefSlider("ViewerScript3_.bottom",	-100,	height,	    0,  1);
nuiDefSlider("ViewerScript3_.top",	0,	height+100, 0,  1);

// If you are running on an NT dual-head system (two monitors),
// you can set this to 1: this will prompt shake to open
// its windows in a more usable fashion.
gui.dualHead= 0;

// This is an example of what you can do to open a second
// viewer desktop on the other monitor.
if(gui.dualHead) spawnViewerDesktop(1290,10,1260,960);

nuiSetColor(1,1,0,0);
nuiSetColor(2,1,0.5,0);
nuiSetColor(3,1,1,0);
nuiSetColor(4,0.5,1,0);
nuiSetColor(5,0,1,0);
nuiSetColor(6,0,1,0.5);
nuiSetColor(7,0,1,1);
nuiSetColor(8,0,0.5,1);
nuiSetColor(9,0,0,1);
nuiSetColor(10,0.5,0,1);
nuiSetColor(11,1,0,1);
nuiSetColor(12,1,0,0.5);
nuiSetColor(13,0,0,0);
nuiSetColor(14,0.1,0.1,0.1);
nuiSetColor(15,0.2,0.2,0.2);
nuiSetColor(16,0.3,0.3,0.3);
nuiSetColor(17,0.4,0.4,0.4);
nuiSetColor(18,0.5,0.5,0.5);
nuiSetColor(19,0.6,0.6,0.6);
nuiSetColor(20,0.7,0.7,0.7);
nuiSetColor(21,0.8,0.8,0.8);
nuiSetColor(22,0.9,0.9,0.9);
nuiSetColor(23,1.0,1.0,1.0);
nuiSetColor(24,1.0,1.0,1.0);

nuiSetMultipleObjectsColor(
    imageToolBoxRed, imageToolBoxGreen, imageToolBoxBlue,
    imageTextCol, imageTextCol, imageTextCol,

    "Average",		
    "Checker",		
    "Color",		
    "ColorWheel",	
    "FileIn",		
    "FileOut",		
    "Grad",		
    "Julia",		
    "Mandelbrot",		
    "PullDown",		
    "PullUp",		
    "QuickPaint",
    "QuickShape",	
    "Rand",		
    "Ramp",		
    "RGrad",
    "RotoShape",
    "Text",		
    "VTRIn",		
    "VTROut"
);

nuiSetMultipleObjectsColor(
    colorToolBoxRed, colorToolBoxGreen, colorToolBoxBlue,
    standardTextCol, standardTextCol, standardTextCol,

    "Add",		
    "AdjustHSV",	
    "Brightness",	
    "Clamp",
    "ColorCorrect",
    "ColorMatch",	
    "ColorReplace",	
    "ColorSpace",	
    "ColorX",		
    "Compress",		
    "ContrastLum",	
    "ContrastRGB",	
    "DelogC",		
    "DelogRGB",		
    "Expand",		
    "Fade",		
    "Gamma",		
    "Invert",		
    "LogC",		
    "LogRGB",		
    "LogLin",		
    "Lookup",		
    "LookupFile",	
    "LookupHLS",	
    "LookupHSV",	
    "MDiv",		
    "MMult",		
    "Monochrome",	
    "Mult",		
    "Reorder",		
    "Saturation",	
    "Set",		
    "SetAlpha",		
    "SetBGColor",	
    "Solarize",		
    "@Threshold",	
    "VideoSafe"
);

nuiSetMultipleObjectsColor(
    filterToolBoxRed, filterToolBoxGreen, filterToolBoxBlue,
    standardTextCol, standardTextCol, standardTextCol,

    "ApplyFilter",	
    "Blur",		
    "Convolve",	
    "Defocus",	
    "DilateErode",	
    "Emboss",	
    "EdgeDetect",	
    "Grain",	
    "IBlur",	
    "IDilateErode",	
    "IRBlur",	
    "ISharpen",	
    "IDefocus",	
    "Median",	
    "PercentBlur",	
    "Pixelize",	
    "RBlur",	
    "Sharpen",	
    "ZBlur",	
    "ZDefocus"
);

nuiSetMultipleObjectsColor(
    keyToolBoxRed, keyToolBoxGreen, keyToolBoxBlue,
    standardTextCol, standardTextCol, standardTextCol,

    "ChromaKey",	
    "DepthKey",		
    "DepthSlice",	
    "LumaKey",		
    "Primatte_v2",
    "Keylight_1v4",
    "SpillSuppress"
);

nuiSetMultipleObjectsColor(
    layerToolBoxRed, layerToolBoxGreen, layerToolBoxBlue,
    layerTextCol, layerTextCol, layerTextCol,

    "AddMix",		
    "AddText",		
    "Atop",		
    "Common",		
    "Constraint",	
    "Copy",		
    "IAdd",		
    "IDiv",		
    "IMult",		
    "Inside",		
    "Interlace",	
    "ISub",		
    "ISubA",		
    "KeyMix",		
    "LayerMacro",	
    "Layer",		
    "LayerX",		
    "Max",		
    "Min",		
    "Mix",		
    "Outside",		
    "Over",		
    "Screen",		
    "SwitchMatte",	
    "Under",		
    "Xor",		
    "ZCompose"
);

nuiSetMultipleObjectsColor(
    transformToolBoxRed*1.2, transformToolBoxGreen*1.2, transformToolBoxBlue*1.2,
    transformTextCol, transformTextCol, transformTextCol,

    "CameraShake",	
    "CornerPin",	
    "Crop",		
    "Fit",		
    "Flip",		
    "Flop",		
    "MatchMove",	
    "Move2D",	
    "Move3D",	
    "Orient",	
    "Pan",		
    "Resize",	
    "Rotate",	
    "Scale",	
    "Scroll",	
    "SetDOD",	
    "Shear",	
    "Stabilize",	
    "Tracker",	
    "Viewport",	
    "Window",	
    "Zoom"
);

nuiSetMultipleObjectsColor(
    warpToolBoxRed, warpToolBoxGreen, warpToolBoxBlue,
    standardTextCol, standardTextCol, standardTextCol,

    "DisplaceX",	
    "IDisplace",	
    "PinCushion",	
    "Randomize",	
    "Turbulate",	
    "Twirl",		
    "WarpX"
);

nuiSetMultipleObjectsColor(
    otherToolBoxRed, otherToolBoxGreen, otherToolBoxBlue,
    standardTextCol, standardTextCol, standardTextCol,

    "AddBorders",		
    "AddShadow",	
    "Append",		
    "Bytes",		
    "Deinterlace",	
    "DropShadow",	
    "Field",		
    "Histogram",	
    "PlotScanline",	
    "Select",		
    "SwapFields",	
    "Tile",		
    "TimeX",		
    "Transition"
);

gui.fileBrowser.readUISettingToggle= 0;
gui.fileBrowser.writeUISettingToggle= 1;
sys.maxThread = nrcGetAvailableProcessors();

nuiAddMaskCommand("RotoShape","RotoShape();");
nuiAddMaskCommand("QuickShape","QuickShape();");
nuiAddMaskCommand("QuickPaint","QuickPaint(0);");
nuiAddMaskCommand("RGrad","RGrad();");
nuiAddMaskCommand("Ramp","Ramp();");
nuiAddMaskCommand("Text","Text();");

float textFieldFontClrRed   = 0.6f;
float textFieldFontClrGreen = 0.6f;
float textFieldFontClrBlue  = 0.6f;

float textFieldModifiedClrRed   = 1.f;
float textFieldModifiedClrGreen = 1.f;
float textFieldModifiedClrBlue  = 1.f;

float textFieldKeyClrRed   = 0.45f;
float textFieldKeyClrGreen = 0.66f;
float textFieldKeyClrBlue  = 1.f;

float textFieldExprClrRed   = 0.66f;
float textFieldExprClrGreen = 0.45f;
float textFieldExprClrBlue  = 1.0f;

float textFieldTempKeyBackgroundClrRed   = 0.3f;
float textFieldTempKeyBackgroundClrGreen = 0.3f;
float textFieldTempKeyBackgroundClrBlue  = 0.f;

float nodeViewExprLinkRed = 0.66f;
float nodeViewExprLinkGreen = 0.45f;
float nodeViewExprLinkBlue = 1.0f;

int color = (0xFF0000*textFieldFontClrRed);
color = color & 0xFF0000;
color = color + (0x00FF00*textFieldFontClrGreen);
color = color & 0xFFFF00;
color = color + (0x0000FF*textFieldFontClrBlue);
gui.textField.fontColor=color;

color = (0xFF0000*textFieldModifiedClrRed);
color = color & 0xFF0000;
color = color + (0x00FF00*textFieldModifiedClrGreen);
color = color & 0xFFFF00;
color = color + (0x0000FF*textFieldModifiedClrBlue);
gui.textField.valModClr=color;

color = (0xFF0000*textFieldKeyClrRed);
color = color & 0xFF0000;
color = color + (0x00FF00*textFieldKeyClrGreen);
color = color & 0xFFFF00;
color = color + (0x0000FF*textFieldKeyClrBlue);
gui.textField.setKeyClr=color;

color = (0xFF0000*textFieldExprClrRed);
color = color & 0xFF0000;
color = color + (0x00FF00*textFieldExprClrGreen);
color = color & 0xFFFF00;
color = color + (0x0000FF*textFieldExprClrBlue);
gui.textField.expressionColor=color;

color = (0xFF0000*textFieldTempKeyBackgroundClrRed);
color = color & 0xFF0000;
color = color + (0x00FF00*textFieldTempKeyBackgroundClrGreen);
color = color & 0xFFFF00;
color = color + (0x0000FF*textFieldTempKeyBackgroundClrBlue);
gui.textField.tempKeyBackClr=color;

color = (0xFF000000*nodeViewExprLinkRed);
color = color & 0xFF000000;
color = color + (0x00FF0000*nodeViewExprLinkGreen);
color = color & 0xFFFF0000;
color = color + (0x0000FF00*nodeViewExprLinkBlue);
color = color | (0x000000FF);
gui.nodeView.exprLinkColor=color;

int colorCtrlHorizontalCurveEditor = 0;
int colorCtrlVerticalCurveEditor = 1;

if(gui.trm)	gui.colorCtrl.curveEditorDirection = colorCtrlHorizontalCurveEditor;
else		gui.colorCtrl.curveEditorDirection = colorCtrlVerticalCurveEditor;


// viewer script ui settings
nuxDefRadioBtnCtrl("ViewerScript1_.viewerLogLin",0, 1, 0,
		   "2|None",
		   "0|LogToLin",
		   "1|LinToLog"
		   );

nuiPushControlGroup("ViewerScript1_.viewerLogLin");
    	nuiGroupControl("ViewerScript1_.rOffset");
	nuiGroupControl("ViewerScript1_.gOffset");
	nuiGroupControl("ViewerScript1_.bOffset");
	nuiPushControlGroup("ViewerScript1_.rBlack");
	    	nuiGroupControl("ViewerScript1_.gBlack");
    		nuiGroupControl("ViewerScript1_.bBlack");
     	nuiPopControlGroup();   	
	nuiPushControlGroup("ViewerScript1_.rWhite");
   	 	nuiGroupControl("ViewerScript1_.gWhite");
    		nuiGroupControl("ViewerScript1_.bWhite");
     	nuiPopControlGroup();   
    	nuiPushControlGroup("ViewerScript1_.rNGamma");
    		nuiGroupControl("ViewerScript1_.gNGamma");
   	 	nuiGroupControl("ViewerScript1_.bNGamma");
     	nuiPopControlGroup();   
    	nuiPushControlGroup("ViewerScript1_.rDGamma");
    		nuiGroupControl("ViewerScript1_.gDGamma");
    		nuiGroupControl("ViewerScript1_.bDGamma");
     	nuiPopControlGroup();   
    	nuiPushControlGroup("ViewerScript1_.rSoftClip");
	    	nuiGroupControl("ViewerScript1_.gSoftClip");
    		nuiGroupControl("ViewerScript1_.bSoftClip");
    	nuiPopControlGroup();   
nuiPopControlGroup();

nuiDefSlider("ViewerScript1_.ViewerGamma",0,4,0);
nuiDefSlider("ViewerScript1_.viewerOffset",-1,1,0);

nuiDefSlider("ViewerScript1_.viewerLogLin",0,2,2);
nuiDefSlider("ViewerScript1_.rOffset",-180,180,1);
nuiDefSlider("ViewerScript1_.gOffset",-180,180,1);
nuiDefSlider("ViewerScript1_.bOffset",-180,180,1);
nuiDefSlider("ViewerScript1_.rBlack",0,1023,1);
nuiDefSlider("ViewerScript1_.gBlack",0,1023,1);
nuiDefSlider("ViewerScript1_.bBlack",0,1023,1);
nuiDefSlider("ViewerScript1_.rWhite",0,1023,1);
nuiDefSlider("ViewerScript1_.gWhite",0,1023,1);
nuiDefSlider("ViewerScript1_.bWhite",0,1023,1);
nuiDefSlider("ViewerScript1_.rNGamma",0,2.2,0);
nuiDefSlider("ViewerScript1_.gNGamma",0,2.2,0);
nuiDefSlider("ViewerScript1_.bNGamma",0,2.2,0);
nuiDefSlider("ViewerScript1_.rDGamma",0,2.2,0);
nuiDefSlider("ViewerScript1_.gDGamma",0,2.2,0);
nuiDefSlider("ViewerScript1_.bDGamma",0,2.2,0);
nuiDefSlider("ViewerScript1_.rSoftClip",0,50,1);
nuiDefSlider("ViewerScript1_.gSoftClip",0,50,1);
nuiDefSlider("ViewerScript1_.bSoftClip",0,50,1);

// same as viewerscript1_, only with the ROI stuff...

nuxDefRadioBtnCtrl("ViewerScript2_.viewerLogLin",0, 1, 0,
		   "2|None",
		   "0|LogToLin",
		   "1|LinToLog"
		   );

nuxDefRadioBtnCtrl("ViewerScript2_.viewerROI",0 ,1 ,0,
		"1|Off",
		"2|On"
		);


nuiPushControlGroup("ViewerScript2_.viewerLogLin");
    	nuiGroupControl("ViewerScript2_.rOffset");
	nuiGroupControl("ViewerScript2_.gOffset");
	nuiGroupControl("ViewerScript2_.bOffset");
	nuiPushControlGroup("ViewerScript2_.rBlack");
	    	nuiGroupControl("ViewerScript2_.gBlack");
    		nuiGroupControl("ViewerScript2_.bBlack");
     	nuiPopControlGroup();   	
	nuiPushControlGroup("ViewerScript2_.rWhite");
   	 	nuiGroupControl("ViewerScript2_.gWhite");
    		nuiGroupControl("ViewerScript2_.bWhite");
     	nuiPopControlGroup();   
    	nuiPushControlGroup("ViewerScript2_.rNGamma");
    		nuiGroupControl("ViewerScript2_.gNGamma");
   	 	nuiGroupControl("ViewerScript2_.bNGamma");
     	nuiPopControlGroup();   
    	nuiPushControlGroup("ViewerScript2_.rDGamma");
    		nuiGroupControl("ViewerScript2_.gDGamma");
    		nuiGroupControl("ViewerScript2_.bDGamma");
     	nuiPopControlGroup();   
    	nuiPushControlGroup("ViewerScript2_.rSoftClip");
	    	nuiGroupControl("ViewerScript2_.gSoftClip");
    		nuiGroupControl("ViewerScript2_.bSoftClip");
    	nuiPopControlGroup();   
nuiPopControlGroup();

nuiPushControlGroup("ViewerScript2_.viewerROI");
	nuiGroupControl("ViewerScript2_.left");
	nuiGroupControl("ViewerScript2_.right");
	nuiGroupControl("ViewerScript2_.bottom");
	nuiGroupControl("ViewerScript2_.top");
nuiPopControlGroup();

nuiDefSlider("ViewerScript2_.ViewerGamma",0,4,0);
nuiDefSlider("ViewerScript2_.viewerOffset",-1,1,0);

nuiDefSlider("ViewerScript2_.viewerLogLin",0,2,2);
nuiDefSlider("ViewerScript2_.rOffset",-180,180,1);
nuiDefSlider("ViewerScript2_.gOffset",-180,180,1);
nuiDefSlider("ViewerScript2_.bOffset",-180,180,1);
nuiDefSlider("ViewerScript2_.rBlack",0,1023,1);
nuiDefSlider("ViewerScript2_.gBlack",0,1023,1);
nuiDefSlider("ViewerScript2_.bBlack",0,1023,1);
nuiDefSlider("ViewerScript2_.rWhite",0,1023,1);
nuiDefSlider("ViewerScript2_.gWhite",0,1023,1);
nuiDefSlider("ViewerScript2_.bWhite",0,1023,1);
nuiDefSlider("ViewerScript2_.rNGamma",0,2.2,0);
nuiDefSlider("ViewerScript2_.gNGamma",0,2.2,0);
nuiDefSlider("ViewerScript2_.bNGamma",0,2.2,0);
nuiDefSlider("ViewerScript2_.rDGamma",0,2.2,0);
nuiDefSlider("ViewerScript2_.gDGamma",0,2.2,0);
nuiDefSlider("ViewerScript2_.bDGamma",0,2.2,0);
nuiDefSlider("ViewerScript2_.rSoftClip",0,50,1);
nuiDefSlider("ViewerScript2_.gSoftClip",0,50,1);
nuiDefSlider("ViewerScript2_.bSoftClip",0,50,1);

nuiDefSlider("ViewerScript2_.viewerROI",1,2,1);
nuiDefSlider("ViewerScript2_.left",-100,width,0);
nuiDefSlider("ViewerScript2_.right",0,width+100,0);
nuiDefSlider("ViewerScript2_.bottom",-100,height,0);
nuiDefSlider("ViewerScript2_.top",0,height+100,0);


nuxDefRadioBtnCtrl("ViewerScript3_.viewerROI",0 ,1 ,0,
		"1|Off",
		"2|On"
		);

nriDefNoKeyPCtrl("NRiRenderWinNode.pixelScale");
nriDefNoKeyPCtrl("NRiRenderWinNode.pixelRatio");
nriDefNoKeyPCtrl("NRiRenderWinNode.motionBlur");
nriDefNoKeyPCtrl("NRiRenderWinNode.shutterTiming");
nriDefNoKeyPCtrl("NRiRenderWinNode.shutterOffset");
nriDefNoKeyPCtrl("maxThread");

